import Prismic from 'prismic.io';
import invariant from 'invariant';

//$FlowFixMe https://github.com/facebook/flow/issues/183
var query = function query(_ref) {
  var url = _ref.url,
      _ref$query = _ref.query,
      query = _ref$query === undefined ? false : _ref$query,
      _ref$predicates = _ref.predicates,
      predicates = _ref$predicates === undefined ? '' : _ref$predicates,
      _ref$options = _ref.options,
      options = _ref$options === undefined ? {} : _ref$options;

  !url ? process.env.NODE_ENV !== 'production' ? invariant(false, 'No url prop passed. Make sure you pass in an api url ' + 'via the "url" prop.') : invariant(false) : void 0;
  !(query || predicates || options) ? process.env.NODE_ENV !== 'production' ? invariant(false, 'You must pass a query, predicates, or options. ') : invariant(false) : void 0;
  return Prismic.api(url).then(function (api) {
    if (query) {
      return api.query.apply(api, query);
    }
    return api.query(predicates, options);
  });
};
var queryById = function queryById(_ref2) {
  var url = _ref2.url,
      id = _ref2.id;

  !url ? process.env.NODE_ENV !== 'production' ? invariant(false, 'No url prop passed. Make sure you pass in an api url ' + 'via the "url" prop.') : invariant(false) : void 0;
  !id ? process.env.NODE_ENV !== 'production' ? invariant(false, 'No id prop passed. Make sure you pass in a document' + 'id via the "id" prop.') : invariant(false) : void 0;
  return Prismic.api(url).then(function (api) {
    return api.getByID(id);
  });
};

var queryByUid = function queryByUid(_ref3) {
  var url = _ref3.url,
      uid = _ref3.uid,
      type = _ref3.type;

  !url ? process.env.NODE_ENV !== 'production' ? invariant(false, 'No url prop passed. Make sure you pass in an api url ' + 'via the "url" prop.') : invariant(false) : void 0;
  !uid ? process.env.NODE_ENV !== 'production' ? invariant(false, 'No uid prop passed. Make sure you pass in a document' + 'type via the "uid" prop.') : invariant(false) : void 0;
  !type ? process.env.NODE_ENV !== 'production' ? invariant(false, 'No type prop passed. Make sure you pass in a document' + 'type via the "type" prop.') : invariant(false) : void 0;
  return Prismic.api(url).then(function (api) {
    return api.getByUID(type, uid);
  });
};
export { query, queryById, queryByUid };