var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { queryById } from '../queries';

export default function withDocumentById(_ref) {
  var url = _ref.url,
      id = _ref.id,
      _ref$queryKey = _ref.queryKey,
      queryKey = _ref$queryKey === undefined ? '' : _ref$queryKey;

  return function (ComposedComponent) {
    return function (_React$Component) {
      _inherits(withDocument, _React$Component);

      function withDocument(props) {
        _classCallCheck(this, withDocument);

        var _this2 = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this2.componentDidMount = function () {
          var _this = _this2;
          queryById({ url: url, id: id }).then(function (response) {
            _this.setState({ loading: false, prismic: response });
          }).catch(function (err) {
            _this.setState({ loading: false, error: err });
          });
        };

        _this2.state = {
          loading: true,
          prismic: false,
          error: false
        };
        return _this2;
      }

      withDocument.prototype.render = function render() {
        var _prismic;

        var keyed = queryKey.length > 0;
        var prismic = (_prismic = {
          queryKey: keyed ? queryKey : false
        }, _prismic[keyed ? queryKey + 'Loading' : 'loading'] = this.state.loading, _prismic[keyed ? queryKey + 'Error' : 'error'] = this.state.error, _prismic[keyed ? queryKey + 'Prismic' : 'prismic'] = this.state.prismic, _prismic);
        return React.createElement(ComposedComponent, _extends({}, this.props, prismic));
      };

      return withDocument;
    }(React.Component);
  };
}