(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["ReactPrismic"] = factory(require("react"));
	else
		root["ReactPrismic"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_7__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.DocumentByUid = exports.DocumentById = exports.Query = exports.withDocumentByUid = exports.withDocumentById = exports.withQuery = undefined;

	var _withQuery = __webpack_require__(31);

	var _withQuery2 = _interopRequireDefault(_withQuery);

	var _withDocumentById = __webpack_require__(29);

	var _withDocumentById2 = _interopRequireDefault(_withDocumentById);

	var _withDocumentByUid = __webpack_require__(30);

	var _withDocumentByUid2 = _interopRequireDefault(_withDocumentByUid);

	var _Query = __webpack_require__(28);

	var _Query2 = _interopRequireDefault(_Query);

	var _DocumentById = __webpack_require__(26);

	var _DocumentById2 = _interopRequireDefault(_DocumentById);

	var _DocumentByUid = __webpack_require__(27);

	var _DocumentByUid2 = _interopRequireDefault(_DocumentByUid);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.withQuery = _withQuery2.default;
	exports.withDocumentById = _withDocumentById2.default;
	exports.withDocumentByUid = _withDocumentByUid2.default;
	exports.Query = _Query2.default;
	exports.DocumentById = _DocumentById2.default;
	exports.DocumentByUid = _DocumentByUid2.default;

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	var documents = __webpack_require__(11);
	var WithFragments = documents.WithFragments,
	    GroupDoc = documents.GroupDoc;

	/**
	 * Embodies a plain text fragment (beware: not a structured text)
	 * @constructor
	 * @global
	 * @alias Fragments:Text
	 */
	function Text(data) {
	  this.value = data;
	}
	Text.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<span>" + this.value + "</span>";
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return this.value;
	  }
	};
	/**
	 * Embodies a document link fragment (a link that is internal to a prismic.io repository)
	 * @constructor
	 * @global
	 * @alias Fragments:DocumentLink
	 */
	function DocumentLink(data) {
	  this.value = data;

	  this.document = data.document;
	  /**
	   * @field
	   * @description the linked document id
	   */
	  this.id = data.document.id;
	  /**
	   * @field
	   * @description the linked document uid
	   */
	  this.uid = data.document.uid;
	  /**
	   * @field
	   * @description the linked document tags
	   */
	  this.tags = data.document.tags;
	  /**
	   * @field
	   * @description the linked document slug
	   */
	  this.slug = data.document.slug;
	  /**
	   * @field
	   * @description the linked document type
	   */
	  this.type = data.document.type;

	  var fragmentsData = {};
	  if (data.document.data) {
	    for (var field in data.document.data[data.document.type]) {
	      fragmentsData[data.document.type + '.' + field] = data.document.data[data.document.type][field];
	    }
	  }
	  /**
	   * @field
	   * @description the fragment list, if the fetchLinks parameter was used in at query time
	   */
	  this.fragments = parseFragments(fragmentsData);
	  /**
	   * @field
	   * @description true if the link is broken, false otherwise
	   */
	  this.isBroken = data.isBroken;
	}

	DocumentLink.prototype = Object.create(WithFragments.prototype);

	/**
	 * Turns the fragment into a useable HTML version of it.
	 * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	 *
	 * @params {object} ctx - mandatory ctx object, with a useable linkResolver function (please read prismic.io online documentation about this)
	 * @returns {string} - basic HTML code for the fragment
	 */
	DocumentLink.prototype.asHtml = function (ctx) {
	  return "<a href=\""+this.url(ctx)+"\">"+this.url(ctx)+"</a>";
	};

	/**
	 * Returns the URL of the document link.
	 *
	 * @params {object} linkResolver - mandatory linkResolver function (please read prismic.io online documentation about this)
	 * @returns {string} - the proper URL to use
	 */
	DocumentLink.prototype.url = function (linkResolver) {
	  return linkResolver(this, this.isBroken);
	};

	/**
	 * Turns the fragment into a useable text version of it.
	 *
	 * @returns {string} - basic text version of the fragment
	 */
	DocumentLink.prototype.asText = function(linkResolver) {
	  return this.url(linkResolver);
	};

	/**
	 * Embodies a web link fragment
	 * @constructor
	 * @global
	 * @alias Fragments:WebLink
	 */
	function WebLink(data) {
	  /**
	   * @field
	   * @description the JSON object exactly as is returned in the "data" field of the JSON responses (see API documentation: https://developers.prismic.io/documentation/UjBe8bGIJ3EKtgBZ/api-documentation#json-responses)
	   */
	  this.value = data;
	}
	WebLink.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<a href=\""+this.url()+"\">"+this.url()+"</a>";
	  },
	  /**
	   * Returns the URL of the link.
	   *
	   * @returns {string} - the proper URL to use
	   */
	  url: function() {
	    return this.value.url;
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return this.url();
	  }
	};

	/**
	 * Embodies a file link fragment
	 * @constructor
	 * @global
	 * @alias Fragments:FileLink
	 */
	function FileLink(data) {
	  /**
	   * @field
	   * @description the JSON object exactly as is returned in the "data" field of the JSON responses (see API documentation: https://developers.prismic.io/documentation/UjBe8bGIJ3EKtgBZ/api-documentation#json-responses)
	   */
	  this.value = data;
	}
	FileLink.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<a href=\""+this.url()+"\">"+this.value.file.name+"</a>";
	  },
	  /**
	   * Returns the URL of the link.
	   *
	   * @returns {string} - the proper URL to use
	   */
	  url: function() {
	    return this.value.file.url;
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return this.url();
	  }
	};

	/**
	 * Embodies an image link fragment
	 * @constructor
	 * @global
	 * @alias Fragments:ImageLink
	 */
	function ImageLink(data) {
	  /**
	   *
	   * @field
	   * @description the JSON object exactly as is returned in the "data" field of the JSON responses (see API documentation: https://developers.prismic.io/documentation/UjBe8bGIJ3EKtgBZ/api-documentation#json-responses)
	   */
	  this.value = data;
	}
	ImageLink.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<a href=\"" + this.url() + "\"><img src=\"" + this.url() + "\" alt=\"" + (this.alt || "") + "\"></a>";
	  },
	  /**
	   * Returns the URL of the link.
	   *
	   * @returns {string} - the proper URL to use
	   */
	  url: function() {
	    return this.value.image.url;
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return this.url();
	  }
	};

	/**
	 * Embodies a select fragment
	 * @constructor
	 * @global
	 * @alias Fragments:Select
	 */
	function Select(data) {
	  /**
	   * @field
	   * @description the text value of the fragment
	   */
	  this.value = data;
	}
	Select.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<span>" + this.value + "</span>";
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return this.value;
	  }
	};

	/**
	 * Embodies a color fragment
	 * @constructor
	 * @global
	 * @alias Fragments:Color
	 */
	function Color(data) {
	  /**
	   * @field
	   * @description the text value of the fragment
	   */
	  this.value = data;
	}
	Color.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<span>" + this.value + "</span>";
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return this.value;
	  }
	};

	/**
	 * Embodies a geopoint
	 * @constructor
	 * @global
	 * @alias Fragments:GeoPoint
	 */
	function GeoPoint(data) {
	  /**
	   * @field
	   * @description the latitude of the geo point
	   */
	  this.latitude = data.latitude;
	  /**
	   * @field
	   * @description the longitude of the geo point
	   */
	  this.longitude = data.longitude;
	}

	GeoPoint.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return '<div class="geopoint"><span class="latitude">' + this.latitude + '</span><span class="longitude">' + this.longitude + '</span></div>';
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return '(' + this.latitude + "," + this.longitude + ')';
	  }
	};

	/**
	 * Embodies a Number fragment
	 * @constructor
	 * @global
	 * @alias Fragments:Num
	 */
	function Num(data) {
	  /**
	   * @field
	   * @description the integer value of the fragment
	   */
	  this.value = data;
	}
	Num.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<span>" + this.value + "</span>";
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    if (this.value === null) {
	      return null;
	    } else {
	      return this.value.toString();
	    }
	  }
	};

	/**
	 * Embodies a Date fragment
	 * @constructor
	 * @global
	 * @alias Fragments:Date
	 */
	function DateFragment(data) {
	  /**
	   * @field
	   * @description the Date value of the fragment (as a regular JS Date object)
	   */
	  this.value = new Date(data);
	}

	DateFragment.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<time>" + this.value + "</time>";
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    if (this.value === null) {
	      return null;
	    } else {
	      return this.value.toString();
	    }
	  }
	};

	/**
	 * Embodies a Timestamp fragment
	 * @constructor
	 * @global
	 * @alias Fragments:Timestamp
	 */
	function Timestamp(data) {
	  /**
	   * @field
	   * @description the Date value of the fragment (as a regular JS Date object)
	   */
	  // Adding ":" in the locale if needed, so JS considers it ISO8601-compliant
	  if (data) {
	    var correctIso8601Date = (data.length == 24) ? data.substring(0, 22) + ':' + data.substring(22, 24) : data;
	    this.value = new Date(correctIso8601Date);
	  }
	  else {
	    this.value = null;
	  }
	}

	Timestamp.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<time>" + this.value + "</time>";
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    if (this.value === null) {
	      return null;
	    } else {
	      return this.value.toString();
	    }
	  }
	};

	/**
	 * Embodies an embed fragment
	 * @constructor
	 * @global
	 * @alias Fragments:Embed
	 */
	function Embed(data) {
	  /**
	   * @field
	   * @description the JSON object exactly as is returned in the "data" field of the JSON responses (see API documentation: https://developers.prismic.io/documentation/UjBe8bGIJ3EKtgBZ/api-documentation#json-responses)
	   */
	  this.value = data;
	}

	Embed.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return this.value.oembed.html;
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return "";
	  }
	};

	/**
	 * Embodies an Image fragment
	 * @constructor
	 * @global
	 * @alias Fragments:ImageEl
	 */
	function ImageEl(main, views) {
	  /**
	   * @field
	   * @description the main ImageView for this image
	   */
	  this.main = main;


	  /**
	   * @field
	   * @description the url of the main ImageView for this image
	   */
	  this.url = main.url;

	  /**
	   * @field
	   * @description an array of all the other ImageViews for this image
	   */
	  this.views = views || {};
	}
	ImageEl.prototype = {
	  /**
	   * Gets the view of the image, from its name
	   *
	   * @param {string} name - the name of the view to get
	   * @returns {ImageView} - the proper view
	   */
	  getView: function(name) {
	    if (name === "main") {
	      return this.main;
	    } else {
	      return this.views[name];
	    }
	  },
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return this.main.asHtml();
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return "";
	  }
	};

	/**
	 * Embodies an image view (an image in prismic.io can be defined with several different thumbnail sizes, each size is called a "view")
	 * @constructor
	 * @global
	 * @alias Fragments:ImageView
	 */
	function ImageView(url, width, height, alt) {
	  /**
	   * @field
	   * @description the URL of the ImageView (useable as it, in a <img> tag in HTML, for instance)
	   */
	  this.url = url;
	  /**
	   * @field
	   * @description the width of the ImageView
	   */
	  this.width = width;
	  /**
	   * @field
	   * @description the height of the ImageView
	   */
	  this.height = height;
	  /**
	   * @field
	   * @description the alt text for the ImageView
	   */
	  this.alt = alt;
	}
	ImageView.prototype = {
	  ratio: function () {
	    return this.width / this.height;
	  },
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function () {
	    return "<img src=\"" + this.url + "\" width=\"" + this.width + "\" height=\"" + this.height + "\" alt=\"" + (this.alt || "") + "\">";
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    return "";
	  }
	};


	/**
	 * Embodies a fragment of type "Separator" (only used in Slices)
	 * @constructor
	 * @global
	 * @alias Fragments:Separator
	 */
	function Separator() {
	}
	Separator.prototype = {
	  asHtml: function() {
	    return "<hr/>";
	  },
	  asText: function() {
	    return "----";
	  }
	};

	/**
	 * Embodies a fragment of type "Group" (which is a group of subfragments)
	 * @constructor
	 * @global
	 * @alias Fragments:Group
	 */
	function Group(data) {
	  this.value = [];
	  for (var i = 0; i < data.length; i++) {
	    this.value.push(new GroupDoc(data[i]));
	  }
	}
	Group.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   * @params {function} linkResolver - linkResolver function (please read prismic.io online documentation about this)
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function(linkResolver) {
	    var output = "";
	    for (var i = 0; i < this.value.length; i++) {
	      output += this.value[i].asHtml(linkResolver);
	    }
	    return output;
	  },
	  /**
	   * Turns the Group fragment into an array in order to access its items (groups of fragments),
	   * or to loop through them.
	   * @params {object} ctx - mandatory ctx object, with a useable linkResolver function (please read prismic.io online documentation about this)
	   * @returns {Array} - the array of groups, each group being a JSON object with subfragment name as keys, and subfragment as values
	   */
	  toArray: function(){
	    return this.value;
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function(linkResolver) {
	    var output = "";
	    for (var i=0; i<this.value.length; i++) {
	      output += this.value[i].asText(linkResolver) + '\n';
	    }
	    return output;
	  },

	  getFirstImage: function() {
	    return this.toArray().reduce(function(image, fragment) {
	      if (image) return image;
	      else {
	        return fragment.getFirstImage();
	      }
	    }, null);
	  },

	  getFirstTitle: function() {
	    return this.toArray().reduce(function(st, fragment) {
	      if (st) return st;
	      else {
	        return fragment.getFirstTitle();
	      }
	    }, null);
	  },

	  getFirstParagraph: function() {
	    return this.toArray().reduce(function(st, fragment) {
	      if (st) return st;
	      else {
	        return fragment.getFirstParagraph();
	      }
	    }, null);
	  }
	};


	/**
	 * Embodies a structured text fragment
	 * @constructor
	 * @global
	 * @alias Fragments:StructuredText
	 */
	function StructuredText(blocks) {

	  this.blocks = blocks;

	}

	StructuredText.prototype = {

	  /**
	   * @returns {object} the first heading block in the text
	   */
	  getTitle: function () {
	    for(var i=0; i<this.blocks.length; i++) {
	      var block = this.blocks[i];
	      if(block.type.indexOf('heading') === 0) {
	        return block;
	      }
	    }
	    return null;
	  },

	  /**
	   * @returns {object} the first block of type paragraph
	   */
	  getFirstParagraph: function() {
	    for(var i=0; i<this.blocks.length; i++) {
	      var block = this.blocks[i];
	      if(block.type == 'paragraph') {
	        return block;
	      }
	    }
	    return null;
	  },

	  /**
	   * @returns {array} all paragraphs
	   */
	  getParagraphs: function() {
	    var paragraphs = [];
	    for(var i=0; i<this.blocks.length; i++) {
	      var block = this.blocks[i];
	      if(block.type == 'paragraph') {
	        paragraphs.push(block);
	      }
	    }
	    return paragraphs;
	  },

	  /**
	   * @returns {object} the nth paragraph
	   */
	  getParagraph: function(n) {
	    return this.getParagraphs()[n];
	  },

	  /**
	   * @returns {object}
	   */
	  getFirstImage: function() {
	    for(var i=0; i<this.blocks.length; i++) {
	      var block = this.blocks[i];
	      if(block.type == 'image') {
	        return new ImageView(
	          block.url,
	          block.dimensions.width,
	          block.dimensions.height,
	          block.alt
	        );
	      }
	    }
	    return null;
	  },

	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   * @params {function} linkResolver - please read prismic.io online documentation about link resolvers
	   * @params {function} htmlSerializer optional HTML serializer to customize the output
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function(linkResolver, htmlSerializer) {
	    var blockGroups = [],
	        blockGroup,
	        block,
	        html = [];
	    if (!isFunction(linkResolver)) {
	      // Backward compatibility with the old ctx argument
	      var ctx = linkResolver;
	      linkResolver = function(doc, isBroken) {
	        return ctx.linkResolver(ctx, doc, isBroken);
	      };
	    }
	    if (Array.isArray(this.blocks)) {

	      for(var i=0; i < this.blocks.length; i++) {
	        block = this.blocks[i];

	        // Resolve image links
	        if (block.type == "image" && block.linkTo) {
	          var link = initField(block.linkTo);
	          block.linkUrl = link.url(linkResolver);
	        }

	        if (block.type !== "list-item" && block.type !== "o-list-item") {
	          // it's not a type that groups
	          blockGroups.push(block);
	          blockGroup = null;
	        } else if (!blockGroup || blockGroup.type != ("group-" + block.type)) {
	          // it's a new type or no BlockGroup was set so far
	          blockGroup = {
	            type: "group-" + block.type,
	            blocks: [block]
	          };
	          blockGroups.push(blockGroup);
	        } else {
	          // it's the same type as before, no touching blockGroup
	          blockGroup.blocks.push(block);
	        }
	      }

	      var blockContent = function(block) {
	        var content = "";
	        if (block.blocks) {
	          block.blocks.forEach(function (block2) {
	            content = content + serialize(block2, blockContent(block2), htmlSerializer);
	          });
	        } else {
	          content = insertSpans(block.text, block.spans, linkResolver, htmlSerializer);
	        }
	        return content;
	      };

	      blockGroups.forEach(function (blockGroup) {
	        html.push(serialize(blockGroup, blockContent(blockGroup), htmlSerializer));
	      });

	    }

	    return html.join('');

	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function() {
	    var output = [];
	    for(var i=0; i<this.blocks.length; i++) {
	      var block = this.blocks[i];
	      if (block.text) {
	        output.push(block.text);
	      }
	    }
	    return output.join(' ');
	  }

	};

	function htmlEscape(input) {
	  return input && input.replace(/&/g, "&amp;")
	    .replace(/</g, "&lt;")
	    .replace(/>/g, "&gt;")
	    .replace(/\n/g, "<br>");
	}

	/**
	 * Parses a block that has spans, and inserts the proper HTML code.
	 *
	 * @param {string} text - the original text of the block
	 * @param {object} spans - the spans as returned by the API
	 * @param {object} linkResolver - the function to build links that may be in the fragment (please read prismic.io's online documentation about this)
	 * @param {function} htmlSerializer - optional serializer
	 * @returns {string} - the HTML output
	 */
	function insertSpans(text, spans, linkResolver, htmlSerializer) {
	  if (!spans || !spans.length) {
	    return htmlEscape(text);
	  }

	  var tagsStart = {};
	  var tagsEnd = {};

	  spans.forEach(function (span) {
	    if (!tagsStart[span.start]) { tagsStart[span.start] = []; }
	    if (!tagsEnd[span.end]) { tagsEnd[span.end] = []; }

	    tagsStart[span.start].push(span);
	    tagsEnd[span.end].unshift(span);
	  });

	  var c;
	  var html = "";
	  var stack = [];
	  for (var pos = 0, len = text.length + 1; pos < len; pos++) { // Looping to length + 1 to catch closing tags
	    if (tagsEnd[pos]) {
	      tagsEnd[pos].forEach(function () {
	        // Close a tag
	        var tag = stack.pop();
	        // Continue only if block contains content.
	        if (typeof tag !== 'undefined') {
	          var innerHtml = serialize(tag.span, tag.text, htmlSerializer);
	          if (stack.length === 0) {
	            // The tag was top level
	            html += innerHtml;
	          } else {
	            // Add the content to the parent tag
	            stack[stack.length - 1].text += innerHtml;
	          }
	        }
	      });
	    }
	    if (tagsStart[pos]) {
	      // Sort bigger tags first to ensure the right tag hierarchy
	      tagsStart[pos].sort(function (a, b) {
	        return (b.end - b.start) - (a.end - a.start);
	      });
	      tagsStart[pos].forEach(function (span) {
	        // Open a tag
	        var url = null;
	        if (span.type == "hyperlink") {
	          var fragment = initField(span.data);
	          if (fragment) {
	            url = fragment.url(linkResolver);
	          } else {
	            if (console && console.error) console.error('Impossible to convert span.data as a Fragment', span);
	            return;
	          }
	          span.url = url;
	        }
	        var elt = {
	          span: span,
	          text: ""
	        };
	        stack.push(elt);
	      });
	    }
	    if (pos < text.length) {
	      c = text[pos];
	      if (stack.length === 0) {
	        // Top-level text
	        html += htmlEscape(c);
	      } else {
	        // Inner text of a span
	        stack[stack.length - 1].text += htmlEscape(c);
	      }
	    }
	  }

	  return html;
	}

	/**
	 * Embodies a Slice fragment
	 * @constructor
	 * @global
	 * @alias Fragments:Slice
	 */
	function Slice(sliceType, label, value) {
	  this.sliceType = sliceType;
	  this.label = label;
	  this.value = value;
	}

	Slice.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function (linkResolver) {
	    var classes = ['slice'];
	    if (this.label) classes.push(this.label);
	    return '<div data-slicetype="' + this.sliceType + '" class="' + classes.join(' ') + '">' +
	      this.value.asHtml(linkResolver) +
	      '</div>';

	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function(linkResolver) {
	    return this.value.asText(linkResolver);
	  },

	  /**
	   * Get the first Image in slice.
	   * @returns {object}
	   */
	  getFirstImage: function() {
	    var fragment = this.value;
	    if(typeof fragment.getFirstImage === "function") {
	      return fragment.getFirstImage();
	    } else if (fragment instanceof ImageEl) {
	      return fragment;
	    } else return null;
	  },

	  getFirstTitle: function() {
	    var fragment = this.value;
	    if(typeof fragment.getFirstTitle === "function") {
	      return fragment.getFirstTitle();
	    } else if (fragment instanceof StructuredText) {
	      return fragment.getTitle();
	    } else return null;
	  },

	  getFirstParagraph: function() {
	    var fragment = this.value;
	    if(typeof fragment.getFirstParagraph === "function") {
	      return fragment.getFirstParagraph();
	    } else return null;
	  }

	};

	/**
	 * Embodies a SliceZone fragment
	 * @constructor
	 * @global
	 * @alias Fragments:SliceZone
	 */
	function SliceZone(data) {
	  this.value = [];
	  for (var i = 0; i < data.length; i++) {
	    var sliceType = data[i]['slice_type'];
	    var fragment = initField(data[i]['value']);
	    var label = data[i]['slice_label'] || null;
	    if (sliceType && fragment) {
	      this.value.push(new Slice(sliceType, label, fragment));
	    }
	  }
	  this.slices = this.value;
	}

	SliceZone.prototype = {
	  /**
	   * Turns the fragment into a useable HTML version of it.
	   * If the native HTML code doesn't suit your design, this function is meant to be overriden.
	   *
	   * @returns {string} - basic HTML code for the fragment
	   */
	  asHtml: function (linkResolver) {
	    var output = "";
	    for (var i = 0; i < this.value.length; i++) {
	      output += this.value[i].asHtml(linkResolver);
	    }
	    return output;
	  },

	  /**
	   * Turns the fragment into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function(linkResolver) {
	    var output = "";
	    for (var i = 0; i < this.value.length; i++) {
	      output += this.value[i].asText(linkResolver) + '\n';
	    }
	    return output;
	  },

	  getFirstImage: function() {
	    return this.value.reduce(function(image, slice) {
	      if (image) return image;
	      else {
	        return slice.getFirstImage();
	      }
	    }, null);
	  },

	  getFirstTitle: function() {
	    return this.value.reduce(function(text, slice) {
	      if (text) return text;
	      else {
	        return slice.getFirstTitle();
	      }
	    }, null);
	  },

	  getFirstParagraph: function() {
	    return this.value.reduce(function(paragraph, slice) {
	      if (paragraph) return paragraph;
	      else {
	        return slice.getFirstParagraph();
	      }
	    }, null);
	  }
	};

	/**
	 * From a fragment's name, casts it into the proper object type (like Prismic.Fragments.StructuredText)
	 *
	 * @private
	 * @param {string} field - the fragment's name
	 * @returns {object} - the object of the proper Fragments type.
	 */
	function initField(field) {

	  var classForType = {
	    "Color": Color,
	    "Number": Num,
	    "Date": DateFragment,
	    "Timestamp": Timestamp,
	    "Text": Text,
	    "Embed": Embed,
	    "GeoPoint": GeoPoint,
	    "Select": Select,
	    "StructuredText": StructuredText,
	    "Link.document": DocumentLink,
	    "Link.web": WebLink,
	    "Link.file": FileLink,
	    "Link.image": ImageLink,
	    "Separator": Separator,
	    "Group": Group,
	    "SliceZone": SliceZone
	  };

	  if (classForType[field.type]) {
	    return new classForType[field.type](field.value);
	  }

	  if (field.type === "Image") {
	    var img = field.value.main;
	    var output = new ImageEl(
	      new ImageView(
	        img.url,
	        img.dimensions.width,
	        img.dimensions.height,
	        img.alt
	      ),
	      {}
	    );
	    for (var name in field.value.views) {
	      img = field.value.views[name];
	      output.views[name] = new ImageView(
	        img.url,
	        img.dimensions.width,
	        img.dimensions.height,
	        img.alt
	      );
	    }
	    return output;
	  }

	  if (console && console.log) console.log("Fragment type not supported: ", field.type);
	  return null;

	}

	function parseFragments(json) {
	  var result = {};
	  for (var key in json) {
	    if (json.hasOwnProperty(key)) {
	      if (Array.isArray(json[key])) {
	        result[key] = json[key].map(function (fragment) {
	          return initField(fragment);
	        });
	      } else {
	        result[key] = initField(json[key]);
	      }
	    }
	  }
	  return result;
	}


	function isFunction(f) {
	  var getType = {};
	  return f && getType.toString.call(f) === '[object Function]';
	}

	function serialize(element, content, htmlSerializer) {
	  // Return the user customized output (if available)
	  if (htmlSerializer) {
	    var custom = htmlSerializer(element, content);
	    if (custom) {
	      return custom;
	    }
	  }

	  // Fall back to the default HTML output
	  var TAG_NAMES = {
	    "heading1": "h1",
	    "heading2": "h2",
	    "heading3": "h3",
	    "heading4": "h4",
	    "heading5": "h5",
	    "heading6": "h6",
	    "paragraph": "p",
	    "preformatted": "pre",
	    "list-item": "li",
	    "o-list-item": "li",
	    "group-list-item": "ul",
	    "group-o-list-item": "ol",
	    "strong": "strong",
	    "em": "em"
	  };

	  if (TAG_NAMES[element.type]) {
	    var name = TAG_NAMES[element.type];
	    var classCode = element.label ? (' class="' + element.label + '"') : '';
	    return '<' + name + classCode + '>' + content + '</' + name + '>';
	  }

	  if (element.type == "image") {
	    var label = element.label ? (" " + element.label) : "";
	    var imgTag = '<img src="' + element.url + '" alt="' + (element.alt || "") + '">';
	    return '<p class="block-img' + label + '">' +
	      (element.linkUrl ? ('<a href="' + element.linkUrl + '">' + imgTag + '</a>') : imgTag) +
	      '</p>';
	  }

	  if (element.type == "embed") {
	    return '<div data-oembed="'+ element.embed_url +
	      '" data-oembed-type="'+ element.type +
	      '" data-oembed-provider="'+ element.provider_name +
	      (element.label ? ('" class="' + element.label) : '') +
	      '">' + element.oembed.html+"</div>";
	  }

	  if (element.type === 'hyperlink') {
	    return '<a href="' + element.url + '">' + content + '</a>';
	  }

	  if (element.type === 'label') {
	    return '<span class="' + element.data.label + '">' + content + '</span>';
	  }

	  return "<!-- Warning: " + element.type + " not implemented. Upgrade the Developer Kit. -->" + content;
	}

	module.exports = {
	  Embed: Embed,
	  Image: ImageEl,
	  ImageView: ImageView,
	  Text: Text,
	  Number: Num,
	  Date: DateFragment,
	  Timestamp: Timestamp,
	  Select: Select,
	  Color: Color,
	  StructuredText: StructuredText,
	  WebLink: WebLink,
	  DocumentLink: DocumentLink,
	  ImageLink: ImageLink,
	  FileLink: FileLink,
	  Separator: Separator,
	  Group: Group,
	  GeoPoint: GeoPoint,
	  Slice: Slice,
	  SliceZone: SliceZone,
	  initField: initField,
	  parseFragments: parseFragments,
	  insertSpans: insertSpans
	};


/***/ },
/* 2 */
/***/ function(module, exports) {

	if (typeof Object.create === 'function') {
	  // implementation from standard node.js 'util' module
	  module.exports = function inherits(ctor, superCtor) {
	    ctor.super_ = superCtor
	    ctor.prototype = Object.create(superCtor.prototype, {
	      constructor: {
	        value: ctor,
	        enumerable: false,
	        writable: true,
	        configurable: true
	      }
	    });
	  };
	} else {
	  // old school shim for old browsers
	  module.exports = function inherits(ctor, superCtor) {
	    ctor.super_ = superCtor
	    var TempCtor = function () {}
	    TempCtor.prototype = superCtor.prototype
	    ctor.prototype = new TempCtor()
	    ctor.prototype.constructor = ctor
	  }
	}


/***/ },
/* 3 */
/***/ function(module, exports) {

	// shim for using process in browser
	var process = module.exports = {};

	// cached from whatever global is present so that test runners that stub it
	// don't break things.  But we need to wrap it in a try catch in case it is
	// wrapped in strict mode code which doesn't define any globals.  It's inside a
	// function because try/catches deoptimize in certain engines.

	var cachedSetTimeout;
	var cachedClearTimeout;

	function defaultSetTimout() {
	    throw new Error('setTimeout has not been defined');
	}
	function defaultClearTimeout () {
	    throw new Error('clearTimeout has not been defined');
	}
	(function () {
	    try {
	        if (typeof setTimeout === 'function') {
	            cachedSetTimeout = setTimeout;
	        } else {
	            cachedSetTimeout = defaultSetTimout;
	        }
	    } catch (e) {
	        cachedSetTimeout = defaultSetTimout;
	    }
	    try {
	        if (typeof clearTimeout === 'function') {
	            cachedClearTimeout = clearTimeout;
	        } else {
	            cachedClearTimeout = defaultClearTimeout;
	        }
	    } catch (e) {
	        cachedClearTimeout = defaultClearTimeout;
	    }
	} ())
	function runTimeout(fun) {
	    if (cachedSetTimeout === setTimeout) {
	        //normal enviroments in sane situations
	        return setTimeout(fun, 0);
	    }
	    // if setTimeout wasn't available but was latter defined
	    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
	        cachedSetTimeout = setTimeout;
	        return setTimeout(fun, 0);
	    }
	    try {
	        // when when somebody has screwed with setTimeout but no I.E. maddness
	        return cachedSetTimeout(fun, 0);
	    } catch(e){
	        try {
	            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
	            return cachedSetTimeout.call(null, fun, 0);
	        } catch(e){
	            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
	            return cachedSetTimeout.call(this, fun, 0);
	        }
	    }


	}
	function runClearTimeout(marker) {
	    if (cachedClearTimeout === clearTimeout) {
	        //normal enviroments in sane situations
	        return clearTimeout(marker);
	    }
	    // if clearTimeout wasn't available but was latter defined
	    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
	        cachedClearTimeout = clearTimeout;
	        return clearTimeout(marker);
	    }
	    try {
	        // when when somebody has screwed with setTimeout but no I.E. maddness
	        return cachedClearTimeout(marker);
	    } catch (e){
	        try {
	            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
	            return cachedClearTimeout.call(null, marker);
	        } catch (e){
	            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
	            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
	            return cachedClearTimeout.call(this, marker);
	        }
	    }



	}
	var queue = [];
	var draining = false;
	var currentQueue;
	var queueIndex = -1;

	function cleanUpNextTick() {
	    if (!draining || !currentQueue) {
	        return;
	    }
	    draining = false;
	    if (currentQueue.length) {
	        queue = currentQueue.concat(queue);
	    } else {
	        queueIndex = -1;
	    }
	    if (queue.length) {
	        drainQueue();
	    }
	}

	function drainQueue() {
	    if (draining) {
	        return;
	    }
	    var timeout = runTimeout(cleanUpNextTick);
	    draining = true;

	    var len = queue.length;
	    while(len) {
	        currentQueue = queue;
	        queue = [];
	        while (++queueIndex < len) {
	            if (currentQueue) {
	                currentQueue[queueIndex].run();
	            }
	        }
	        queueIndex = -1;
	        len = queue.length;
	    }
	    currentQueue = null;
	    draining = false;
	    runClearTimeout(timeout);
	}

	process.nextTick = function (fun) {
	    var args = new Array(arguments.length - 1);
	    if (arguments.length > 1) {
	        for (var i = 1; i < arguments.length; i++) {
	            args[i - 1] = arguments[i];
	        }
	    }
	    queue.push(new Item(fun, args));
	    if (queue.length === 1 && !draining) {
	        runTimeout(drainQueue);
	    }
	};

	// v8 likes predictible objects
	function Item(fun, array) {
	    this.fun = fun;
	    this.array = array;
	}
	Item.prototype.run = function () {
	    this.fun.apply(null, this.array);
	};
	process.title = 'browser';
	process.browser = true;
	process.env = {};
	process.argv = [];
	process.version = ''; // empty string to avoid regexp issues
	process.versions = {};

	function noop() {}

	process.on = noop;
	process.addListener = noop;
	process.once = noop;
	process.off = noop;
	process.removeListener = noop;
	process.removeAllListeners = noop;
	process.emit = noop;

	process.binding = function (name) {
	    throw new Error('process.binding is not supported');
	};

	process.cwd = function () { return '/' };
	process.chdir = function (dir) {
	    throw new Error('process.chdir is not supported');
	};
	process.umask = function() { return 0; };


/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	// a duplex stream is just a stream that is both readable and writable.
	// Since JS doesn't have multiple prototypal inheritance, this class
	// prototypally inherits from Readable, and then parasitically from
	// Writable.

	'use strict';

	/*<replacement>*/

	var objectKeys = Object.keys || function (obj) {
	  var keys = [];
	  for (var key in obj) {
	    keys.push(key);
	  }return keys;
	};
	/*</replacement>*/

	module.exports = Duplex;

	/*<replacement>*/
	var processNextTick = __webpack_require__(12);
	/*</replacement>*/

	/*<replacement>*/
	var util = __webpack_require__(8);
	util.inherits = __webpack_require__(2);
	/*</replacement>*/

	var Readable = __webpack_require__(22);
	var Writable = __webpack_require__(14);

	util.inherits(Duplex, Readable);

	var keys = objectKeys(Writable.prototype);
	for (var v = 0; v < keys.length; v++) {
	  var method = keys[v];
	  if (!Duplex.prototype[method]) Duplex.prototype[method] = Writable.prototype[method];
	}

	function Duplex(options) {
	  if (!(this instanceof Duplex)) return new Duplex(options);

	  Readable.call(this, options);
	  Writable.call(this, options);

	  if (options && options.readable === false) this.readable = false;

	  if (options && options.writable === false) this.writable = false;

	  this.allowHalfOpen = true;
	  if (options && options.allowHalfOpen === false) this.allowHalfOpen = false;

	  this.once('end', onend);
	}

	// the no-half-open enforcer
	function onend() {
	  // if we allow half-open state, or if the writable side ended,
	  // then we're ok.
	  if (this.allowHalfOpen || this._writableState.ended) return;

	  // no more data can be written.
	  // But allow more writes to happen in this tick.
	  processNextTick(onEndNT, this);
	}

	function onEndNT(self) {
	  self.end();
	}

	function forEach(xs, f) {
	  for (var i = 0, l = xs.length; i < l; i++) {
	    f(xs[i], i);
	  }
	}

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.queryByUid = exports.queryById = exports.query = undefined;

	var _prismic = __webpack_require__(42);

	var _prismic2 = _interopRequireDefault(_prismic);

	var _invariant = __webpack_require__(37);

	var _invariant2 = _interopRequireDefault(_invariant);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	//$FlowFixMe https://github.com/facebook/flow/issues/183
	var query = function query(_ref) {
	  var url = _ref.url,
	      _ref$query = _ref.query,
	      query = _ref$query === undefined ? false : _ref$query,
	      _ref$predicates = _ref.predicates,
	      predicates = _ref$predicates === undefined ? '' : _ref$predicates,
	      _ref$options = _ref.options,
	      options = _ref$options === undefined ? {} : _ref$options;

	  !url ?  true ? (0, _invariant2.default)(false, 'No url prop passed. Make sure you pass in an api url ' + 'via the "url" prop.') : (0, _invariant2.default)(false) : void 0;
	  !(query || predicates || options) ?  true ? (0, _invariant2.default)(false, 'You must pass a query, predicates, or options. ') : (0, _invariant2.default)(false) : void 0;
	  return _prismic2.default.api(url).then(function (api) {
	    if (query) {
	      return api.query.apply(api, query);
	    }
	    return api.query(predicates, options);
	  });
	};
	var queryById = function queryById(_ref2) {
	  var url = _ref2.url,
	      id = _ref2.id;

	  !url ?  true ? (0, _invariant2.default)(false, 'No url prop passed. Make sure you pass in an api url ' + 'via the "url" prop.') : (0, _invariant2.default)(false) : void 0;
	  !id ?  true ? (0, _invariant2.default)(false, 'No id prop passed. Make sure you pass in a document' + 'id via the "id" prop.') : (0, _invariant2.default)(false) : void 0;
	  return _prismic2.default.api(url).then(function (api) {
	    return api.getByID(id);
	  });
	};

	var queryByUid = function queryByUid(_ref3) {
	  var url = _ref3.url,
	      uid = _ref3.uid,
	      type = _ref3.type;

	  !url ?  true ? (0, _invariant2.default)(false, 'No url prop passed. Make sure you pass in an api url ' + 'via the "url" prop.') : (0, _invariant2.default)(false) : void 0;
	  !uid ?  true ? (0, _invariant2.default)(false, 'No uid prop passed. Make sure you pass in a document' + 'type via the "uid" prop.') : (0, _invariant2.default)(false) : void 0;
	  !type ?  true ? (0, _invariant2.default)(false, 'No type prop passed. Make sure you pass in a document' + 'type via the "type" prop.') : (0, _invariant2.default)(false) : void 0;
	  return _prismic2.default.api(url).then(function (api) {
	    return api.getByUID(type, uid);
	  });
	};
	exports.query = query;
	exports.queryById = queryById;
	exports.queryByUid = queryByUid;

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {/*!
	 * The buffer module from node.js, for the browser.
	 *
	 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
	 * @license  MIT
	 */
	/* eslint-disable no-proto */

	'use strict'

	var base64 = __webpack_require__(32)
	var ieee754 = __webpack_require__(36)
	var isArray = __webpack_require__(33)

	exports.Buffer = Buffer
	exports.SlowBuffer = SlowBuffer
	exports.INSPECT_MAX_BYTES = 50

	/**
	 * If `Buffer.TYPED_ARRAY_SUPPORT`:
	 *   === true    Use Uint8Array implementation (fastest)
	 *   === false   Use Object implementation (most compatible, even IE6)
	 *
	 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
	 * Opera 11.6+, iOS 4.2+.
	 *
	 * Due to various browser bugs, sometimes the Object implementation will be used even
	 * when the browser supports typed arrays.
	 *
	 * Note:
	 *
	 *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
	 *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
	 *
	 *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
	 *
	 *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
	 *     incorrect length in some situations.

	 * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
	 * get the Object implementation, which is slower but behaves correctly.
	 */
	Buffer.TYPED_ARRAY_SUPPORT = global.TYPED_ARRAY_SUPPORT !== undefined
	  ? global.TYPED_ARRAY_SUPPORT
	  : typedArraySupport()

	/*
	 * Export kMaxLength after typed array support is determined.
	 */
	exports.kMaxLength = kMaxLength()

	function typedArraySupport () {
	  try {
	    var arr = new Uint8Array(1)
	    arr.__proto__ = {__proto__: Uint8Array.prototype, foo: function () { return 42 }}
	    return arr.foo() === 42 && // typed array instances can be augmented
	        typeof arr.subarray === 'function' && // chrome 9-10 lack `subarray`
	        arr.subarray(1, 1).byteLength === 0 // ie10 has broken `subarray`
	  } catch (e) {
	    return false
	  }
	}

	function kMaxLength () {
	  return Buffer.TYPED_ARRAY_SUPPORT
	    ? 0x7fffffff
	    : 0x3fffffff
	}

	function createBuffer (that, length) {
	  if (kMaxLength() < length) {
	    throw new RangeError('Invalid typed array length')
	  }
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = new Uint8Array(length)
	    that.__proto__ = Buffer.prototype
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    if (that === null) {
	      that = new Buffer(length)
	    }
	    that.length = length
	  }

	  return that
	}

	/**
	 * The Buffer constructor returns instances of `Uint8Array` that have their
	 * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
	 * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
	 * and the `Uint8Array` methods. Square bracket notation works as expected -- it
	 * returns a single octet.
	 *
	 * The `Uint8Array` prototype remains unmodified.
	 */

	function Buffer (arg, encodingOrOffset, length) {
	  if (!Buffer.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer)) {
	    return new Buffer(arg, encodingOrOffset, length)
	  }

	  // Common case.
	  if (typeof arg === 'number') {
	    if (typeof encodingOrOffset === 'string') {
	      throw new Error(
	        'If encoding is specified then the first argument must be a string'
	      )
	    }
	    return allocUnsafe(this, arg)
	  }
	  return from(this, arg, encodingOrOffset, length)
	}

	Buffer.poolSize = 8192 // not used by this implementation

	// TODO: Legacy, not needed anymore. Remove in next major version.
	Buffer._augment = function (arr) {
	  arr.__proto__ = Buffer.prototype
	  return arr
	}

	function from (that, value, encodingOrOffset, length) {
	  if (typeof value === 'number') {
	    throw new TypeError('"value" argument must not be a number')
	  }

	  if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
	    return fromArrayBuffer(that, value, encodingOrOffset, length)
	  }

	  if (typeof value === 'string') {
	    return fromString(that, value, encodingOrOffset)
	  }

	  return fromObject(that, value)
	}

	/**
	 * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
	 * if value is a number.
	 * Buffer.from(str[, encoding])
	 * Buffer.from(array)
	 * Buffer.from(buffer)
	 * Buffer.from(arrayBuffer[, byteOffset[, length]])
	 **/
	Buffer.from = function (value, encodingOrOffset, length) {
	  return from(null, value, encodingOrOffset, length)
	}

	if (Buffer.TYPED_ARRAY_SUPPORT) {
	  Buffer.prototype.__proto__ = Uint8Array.prototype
	  Buffer.__proto__ = Uint8Array
	  if (typeof Symbol !== 'undefined' && Symbol.species &&
	      Buffer[Symbol.species] === Buffer) {
	    // Fix subarray() in ES2016. See: https://github.com/feross/buffer/pull/97
	    Object.defineProperty(Buffer, Symbol.species, {
	      value: null,
	      configurable: true
	    })
	  }
	}

	function assertSize (size) {
	  if (typeof size !== 'number') {
	    throw new TypeError('"size" argument must be a number')
	  } else if (size < 0) {
	    throw new RangeError('"size" argument must not be negative')
	  }
	}

	function alloc (that, size, fill, encoding) {
	  assertSize(size)
	  if (size <= 0) {
	    return createBuffer(that, size)
	  }
	  if (fill !== undefined) {
	    // Only pay attention to encoding if it's a string. This
	    // prevents accidentally sending in a number that would
	    // be interpretted as a start offset.
	    return typeof encoding === 'string'
	      ? createBuffer(that, size).fill(fill, encoding)
	      : createBuffer(that, size).fill(fill)
	  }
	  return createBuffer(that, size)
	}

	/**
	 * Creates a new filled Buffer instance.
	 * alloc(size[, fill[, encoding]])
	 **/
	Buffer.alloc = function (size, fill, encoding) {
	  return alloc(null, size, fill, encoding)
	}

	function allocUnsafe (that, size) {
	  assertSize(size)
	  that = createBuffer(that, size < 0 ? 0 : checked(size) | 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) {
	    for (var i = 0; i < size; ++i) {
	      that[i] = 0
	    }
	  }
	  return that
	}

	/**
	 * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
	 * */
	Buffer.allocUnsafe = function (size) {
	  return allocUnsafe(null, size)
	}
	/**
	 * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
	 */
	Buffer.allocUnsafeSlow = function (size) {
	  return allocUnsafe(null, size)
	}

	function fromString (that, string, encoding) {
	  if (typeof encoding !== 'string' || encoding === '') {
	    encoding = 'utf8'
	  }

	  if (!Buffer.isEncoding(encoding)) {
	    throw new TypeError('"encoding" must be a valid string encoding')
	  }

	  var length = byteLength(string, encoding) | 0
	  that = createBuffer(that, length)

	  var actual = that.write(string, encoding)

	  if (actual !== length) {
	    // Writing a hex string, for example, that contains invalid characters will
	    // cause everything after the first invalid character to be ignored. (e.g.
	    // 'abxxcd' will be treated as 'ab')
	    that = that.slice(0, actual)
	  }

	  return that
	}

	function fromArrayLike (that, array) {
	  var length = array.length < 0 ? 0 : checked(array.length) | 0
	  that = createBuffer(that, length)
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	function fromArrayBuffer (that, array, byteOffset, length) {
	  array.byteLength // this throws if `array` is not a valid ArrayBuffer

	  if (byteOffset < 0 || array.byteLength < byteOffset) {
	    throw new RangeError('\'offset\' is out of bounds')
	  }

	  if (array.byteLength < byteOffset + (length || 0)) {
	    throw new RangeError('\'length\' is out of bounds')
	  }

	  if (byteOffset === undefined && length === undefined) {
	    array = new Uint8Array(array)
	  } else if (length === undefined) {
	    array = new Uint8Array(array, byteOffset)
	  } else {
	    array = new Uint8Array(array, byteOffset, length)
	  }

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = array
	    that.__proto__ = Buffer.prototype
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    that = fromArrayLike(that, array)
	  }
	  return that
	}

	function fromObject (that, obj) {
	  if (Buffer.isBuffer(obj)) {
	    var len = checked(obj.length) | 0
	    that = createBuffer(that, len)

	    if (that.length === 0) {
	      return that
	    }

	    obj.copy(that, 0, 0, len)
	    return that
	  }

	  if (obj) {
	    if ((typeof ArrayBuffer !== 'undefined' &&
	        obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
	      if (typeof obj.length !== 'number' || isnan(obj.length)) {
	        return createBuffer(that, 0)
	      }
	      return fromArrayLike(that, obj)
	    }

	    if (obj.type === 'Buffer' && isArray(obj.data)) {
	      return fromArrayLike(that, obj.data)
	    }
	  }

	  throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
	}

	function checked (length) {
	  // Note: cannot use `length < kMaxLength()` here because that fails when
	  // length is NaN (which is otherwise coerced to zero.)
	  if (length >= kMaxLength()) {
	    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
	                         'size: 0x' + kMaxLength().toString(16) + ' bytes')
	  }
	  return length | 0
	}

	function SlowBuffer (length) {
	  if (+length != length) { // eslint-disable-line eqeqeq
	    length = 0
	  }
	  return Buffer.alloc(+length)
	}

	Buffer.isBuffer = function isBuffer (b) {
	  return !!(b != null && b._isBuffer)
	}

	Buffer.compare = function compare (a, b) {
	  if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
	    throw new TypeError('Arguments must be Buffers')
	  }

	  if (a === b) return 0

	  var x = a.length
	  var y = b.length

	  for (var i = 0, len = Math.min(x, y); i < len; ++i) {
	    if (a[i] !== b[i]) {
	      x = a[i]
	      y = b[i]
	      break
	    }
	  }

	  if (x < y) return -1
	  if (y < x) return 1
	  return 0
	}

	Buffer.isEncoding = function isEncoding (encoding) {
	  switch (String(encoding).toLowerCase()) {
	    case 'hex':
	    case 'utf8':
	    case 'utf-8':
	    case 'ascii':
	    case 'latin1':
	    case 'binary':
	    case 'base64':
	    case 'ucs2':
	    case 'ucs-2':
	    case 'utf16le':
	    case 'utf-16le':
	      return true
	    default:
	      return false
	  }
	}

	Buffer.concat = function concat (list, length) {
	  if (!isArray(list)) {
	    throw new TypeError('"list" argument must be an Array of Buffers')
	  }

	  if (list.length === 0) {
	    return Buffer.alloc(0)
	  }

	  var i
	  if (length === undefined) {
	    length = 0
	    for (i = 0; i < list.length; ++i) {
	      length += list[i].length
	    }
	  }

	  var buffer = Buffer.allocUnsafe(length)
	  var pos = 0
	  for (i = 0; i < list.length; ++i) {
	    var buf = list[i]
	    if (!Buffer.isBuffer(buf)) {
	      throw new TypeError('"list" argument must be an Array of Buffers')
	    }
	    buf.copy(buffer, pos)
	    pos += buf.length
	  }
	  return buffer
	}

	function byteLength (string, encoding) {
	  if (Buffer.isBuffer(string)) {
	    return string.length
	  }
	  if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
	      (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
	    return string.byteLength
	  }
	  if (typeof string !== 'string') {
	    string = '' + string
	  }

	  var len = string.length
	  if (len === 0) return 0

	  // Use a for loop to avoid recursion
	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'ascii':
	      case 'latin1':
	      case 'binary':
	        return len
	      case 'utf8':
	      case 'utf-8':
	      case undefined:
	        return utf8ToBytes(string).length
	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return len * 2
	      case 'hex':
	        return len >>> 1
	      case 'base64':
	        return base64ToBytes(string).length
	      default:
	        if (loweredCase) return utf8ToBytes(string).length // assume utf8
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}
	Buffer.byteLength = byteLength

	function slowToString (encoding, start, end) {
	  var loweredCase = false

	  // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
	  // property of a typed array.

	  // This behaves neither like String nor Uint8Array in that we set start/end
	  // to their upper/lower bounds if the value passed is out of range.
	  // undefined is handled specially as per ECMA-262 6th Edition,
	  // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
	  if (start === undefined || start < 0) {
	    start = 0
	  }
	  // Return early if start > this.length. Done here to prevent potential uint32
	  // coercion fail below.
	  if (start > this.length) {
	    return ''
	  }

	  if (end === undefined || end > this.length) {
	    end = this.length
	  }

	  if (end <= 0) {
	    return ''
	  }

	  // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
	  end >>>= 0
	  start >>>= 0

	  if (end <= start) {
	    return ''
	  }

	  if (!encoding) encoding = 'utf8'

	  while (true) {
	    switch (encoding) {
	      case 'hex':
	        return hexSlice(this, start, end)

	      case 'utf8':
	      case 'utf-8':
	        return utf8Slice(this, start, end)

	      case 'ascii':
	        return asciiSlice(this, start, end)

	      case 'latin1':
	      case 'binary':
	        return latin1Slice(this, start, end)

	      case 'base64':
	        return base64Slice(this, start, end)

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return utf16leSlice(this, start, end)

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = (encoding + '').toLowerCase()
	        loweredCase = true
	    }
	  }
	}

	// The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
	// Buffer instances.
	Buffer.prototype._isBuffer = true

	function swap (b, n, m) {
	  var i = b[n]
	  b[n] = b[m]
	  b[m] = i
	}

	Buffer.prototype.swap16 = function swap16 () {
	  var len = this.length
	  if (len % 2 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 16-bits')
	  }
	  for (var i = 0; i < len; i += 2) {
	    swap(this, i, i + 1)
	  }
	  return this
	}

	Buffer.prototype.swap32 = function swap32 () {
	  var len = this.length
	  if (len % 4 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 32-bits')
	  }
	  for (var i = 0; i < len; i += 4) {
	    swap(this, i, i + 3)
	    swap(this, i + 1, i + 2)
	  }
	  return this
	}

	Buffer.prototype.swap64 = function swap64 () {
	  var len = this.length
	  if (len % 8 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 64-bits')
	  }
	  for (var i = 0; i < len; i += 8) {
	    swap(this, i, i + 7)
	    swap(this, i + 1, i + 6)
	    swap(this, i + 2, i + 5)
	    swap(this, i + 3, i + 4)
	  }
	  return this
	}

	Buffer.prototype.toString = function toString () {
	  var length = this.length | 0
	  if (length === 0) return ''
	  if (arguments.length === 0) return utf8Slice(this, 0, length)
	  return slowToString.apply(this, arguments)
	}

	Buffer.prototype.equals = function equals (b) {
	  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
	  if (this === b) return true
	  return Buffer.compare(this, b) === 0
	}

	Buffer.prototype.inspect = function inspect () {
	  var str = ''
	  var max = exports.INSPECT_MAX_BYTES
	  if (this.length > 0) {
	    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ')
	    if (this.length > max) str += ' ... '
	  }
	  return '<Buffer ' + str + '>'
	}

	Buffer.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
	  if (!Buffer.isBuffer(target)) {
	    throw new TypeError('Argument must be a Buffer')
	  }

	  if (start === undefined) {
	    start = 0
	  }
	  if (end === undefined) {
	    end = target ? target.length : 0
	  }
	  if (thisStart === undefined) {
	    thisStart = 0
	  }
	  if (thisEnd === undefined) {
	    thisEnd = this.length
	  }

	  if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
	    throw new RangeError('out of range index')
	  }

	  if (thisStart >= thisEnd && start >= end) {
	    return 0
	  }
	  if (thisStart >= thisEnd) {
	    return -1
	  }
	  if (start >= end) {
	    return 1
	  }

	  start >>>= 0
	  end >>>= 0
	  thisStart >>>= 0
	  thisEnd >>>= 0

	  if (this === target) return 0

	  var x = thisEnd - thisStart
	  var y = end - start
	  var len = Math.min(x, y)

	  var thisCopy = this.slice(thisStart, thisEnd)
	  var targetCopy = target.slice(start, end)

	  for (var i = 0; i < len; ++i) {
	    if (thisCopy[i] !== targetCopy[i]) {
	      x = thisCopy[i]
	      y = targetCopy[i]
	      break
	    }
	  }

	  if (x < y) return -1
	  if (y < x) return 1
	  return 0
	}

	// Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
	// OR the last index of `val` in `buffer` at offset <= `byteOffset`.
	//
	// Arguments:
	// - buffer - a Buffer to search
	// - val - a string, Buffer, or number
	// - byteOffset - an index into `buffer`; will be clamped to an int32
	// - encoding - an optional encoding, relevant is val is a string
	// - dir - true for indexOf, false for lastIndexOf
	function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
	  // Empty buffer means no match
	  if (buffer.length === 0) return -1

	  // Normalize byteOffset
	  if (typeof byteOffset === 'string') {
	    encoding = byteOffset
	    byteOffset = 0
	  } else if (byteOffset > 0x7fffffff) {
	    byteOffset = 0x7fffffff
	  } else if (byteOffset < -0x80000000) {
	    byteOffset = -0x80000000
	  }
	  byteOffset = +byteOffset  // Coerce to Number.
	  if (isNaN(byteOffset)) {
	    // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
	    byteOffset = dir ? 0 : (buffer.length - 1)
	  }

	  // Normalize byteOffset: negative offsets start from the end of the buffer
	  if (byteOffset < 0) byteOffset = buffer.length + byteOffset
	  if (byteOffset >= buffer.length) {
	    if (dir) return -1
	    else byteOffset = buffer.length - 1
	  } else if (byteOffset < 0) {
	    if (dir) byteOffset = 0
	    else return -1
	  }

	  // Normalize val
	  if (typeof val === 'string') {
	    val = Buffer.from(val, encoding)
	  }

	  // Finally, search either indexOf (if dir is true) or lastIndexOf
	  if (Buffer.isBuffer(val)) {
	    // Special case: looking for empty string/buffer always fails
	    if (val.length === 0) {
	      return -1
	    }
	    return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
	  } else if (typeof val === 'number') {
	    val = val & 0xFF // Search for a byte value [0-255]
	    if (Buffer.TYPED_ARRAY_SUPPORT &&
	        typeof Uint8Array.prototype.indexOf === 'function') {
	      if (dir) {
	        return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
	      } else {
	        return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
	      }
	    }
	    return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)
	  }

	  throw new TypeError('val must be string, number or Buffer')
	}

	function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
	  var indexSize = 1
	  var arrLength = arr.length
	  var valLength = val.length

	  if (encoding !== undefined) {
	    encoding = String(encoding).toLowerCase()
	    if (encoding === 'ucs2' || encoding === 'ucs-2' ||
	        encoding === 'utf16le' || encoding === 'utf-16le') {
	      if (arr.length < 2 || val.length < 2) {
	        return -1
	      }
	      indexSize = 2
	      arrLength /= 2
	      valLength /= 2
	      byteOffset /= 2
	    }
	  }

	  function read (buf, i) {
	    if (indexSize === 1) {
	      return buf[i]
	    } else {
	      return buf.readUInt16BE(i * indexSize)
	    }
	  }

	  var i
	  if (dir) {
	    var foundIndex = -1
	    for (i = byteOffset; i < arrLength; i++) {
	      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
	        if (foundIndex === -1) foundIndex = i
	        if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
	      } else {
	        if (foundIndex !== -1) i -= i - foundIndex
	        foundIndex = -1
	      }
	    }
	  } else {
	    if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength
	    for (i = byteOffset; i >= 0; i--) {
	      var found = true
	      for (var j = 0; j < valLength; j++) {
	        if (read(arr, i + j) !== read(val, j)) {
	          found = false
	          break
	        }
	      }
	      if (found) return i
	    }
	  }

	  return -1
	}

	Buffer.prototype.includes = function includes (val, byteOffset, encoding) {
	  return this.indexOf(val, byteOffset, encoding) !== -1
	}

	Buffer.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
	  return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
	}

	Buffer.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
	  return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
	}

	function hexWrite (buf, string, offset, length) {
	  offset = Number(offset) || 0
	  var remaining = buf.length - offset
	  if (!length) {
	    length = remaining
	  } else {
	    length = Number(length)
	    if (length > remaining) {
	      length = remaining
	    }
	  }

	  // must be an even number of digits
	  var strLen = string.length
	  if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

	  if (length > strLen / 2) {
	    length = strLen / 2
	  }
	  for (var i = 0; i < length; ++i) {
	    var parsed = parseInt(string.substr(i * 2, 2), 16)
	    if (isNaN(parsed)) return i
	    buf[offset + i] = parsed
	  }
	  return i
	}

	function utf8Write (buf, string, offset, length) {
	  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
	}

	function asciiWrite (buf, string, offset, length) {
	  return blitBuffer(asciiToBytes(string), buf, offset, length)
	}

	function latin1Write (buf, string, offset, length) {
	  return asciiWrite(buf, string, offset, length)
	}

	function base64Write (buf, string, offset, length) {
	  return blitBuffer(base64ToBytes(string), buf, offset, length)
	}

	function ucs2Write (buf, string, offset, length) {
	  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
	}

	Buffer.prototype.write = function write (string, offset, length, encoding) {
	  // Buffer#write(string)
	  if (offset === undefined) {
	    encoding = 'utf8'
	    length = this.length
	    offset = 0
	  // Buffer#write(string, encoding)
	  } else if (length === undefined && typeof offset === 'string') {
	    encoding = offset
	    length = this.length
	    offset = 0
	  // Buffer#write(string, offset[, length][, encoding])
	  } else if (isFinite(offset)) {
	    offset = offset | 0
	    if (isFinite(length)) {
	      length = length | 0
	      if (encoding === undefined) encoding = 'utf8'
	    } else {
	      encoding = length
	      length = undefined
	    }
	  // legacy write(string, encoding, offset, length) - remove in v0.13
	  } else {
	    throw new Error(
	      'Buffer.write(string, encoding, offset[, length]) is no longer supported'
	    )
	  }

	  var remaining = this.length - offset
	  if (length === undefined || length > remaining) length = remaining

	  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
	    throw new RangeError('Attempt to write outside buffer bounds')
	  }

	  if (!encoding) encoding = 'utf8'

	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'hex':
	        return hexWrite(this, string, offset, length)

	      case 'utf8':
	      case 'utf-8':
	        return utf8Write(this, string, offset, length)

	      case 'ascii':
	        return asciiWrite(this, string, offset, length)

	      case 'latin1':
	      case 'binary':
	        return latin1Write(this, string, offset, length)

	      case 'base64':
	        // Warning: maxLength not taken into account in base64Write
	        return base64Write(this, string, offset, length)

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return ucs2Write(this, string, offset, length)

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}

	Buffer.prototype.toJSON = function toJSON () {
	  return {
	    type: 'Buffer',
	    data: Array.prototype.slice.call(this._arr || this, 0)
	  }
	}

	function base64Slice (buf, start, end) {
	  if (start === 0 && end === buf.length) {
	    return base64.fromByteArray(buf)
	  } else {
	    return base64.fromByteArray(buf.slice(start, end))
	  }
	}

	function utf8Slice (buf, start, end) {
	  end = Math.min(buf.length, end)
	  var res = []

	  var i = start
	  while (i < end) {
	    var firstByte = buf[i]
	    var codePoint = null
	    var bytesPerSequence = (firstByte > 0xEF) ? 4
	      : (firstByte > 0xDF) ? 3
	      : (firstByte > 0xBF) ? 2
	      : 1

	    if (i + bytesPerSequence <= end) {
	      var secondByte, thirdByte, fourthByte, tempCodePoint

	      switch (bytesPerSequence) {
	        case 1:
	          if (firstByte < 0x80) {
	            codePoint = firstByte
	          }
	          break
	        case 2:
	          secondByte = buf[i + 1]
	          if ((secondByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F)
	            if (tempCodePoint > 0x7F) {
	              codePoint = tempCodePoint
	            }
	          }
	          break
	        case 3:
	          secondByte = buf[i + 1]
	          thirdByte = buf[i + 2]
	          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F)
	            if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
	              codePoint = tempCodePoint
	            }
	          }
	          break
	        case 4:
	          secondByte = buf[i + 1]
	          thirdByte = buf[i + 2]
	          fourthByte = buf[i + 3]
	          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F)
	            if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
	              codePoint = tempCodePoint
	            }
	          }
	      }
	    }

	    if (codePoint === null) {
	      // we did not generate a valid codePoint so insert a
	      // replacement char (U+FFFD) and advance only 1 byte
	      codePoint = 0xFFFD
	      bytesPerSequence = 1
	    } else if (codePoint > 0xFFFF) {
	      // encode to utf16 (surrogate pair dance)
	      codePoint -= 0x10000
	      res.push(codePoint >>> 10 & 0x3FF | 0xD800)
	      codePoint = 0xDC00 | codePoint & 0x3FF
	    }

	    res.push(codePoint)
	    i += bytesPerSequence
	  }

	  return decodeCodePointsArray(res)
	}

	// Based on http://stackoverflow.com/a/22747272/680742, the browser with
	// the lowest limit is Chrome, with 0x10000 args.
	// We go 1 magnitude less, for safety
	var MAX_ARGUMENTS_LENGTH = 0x1000

	function decodeCodePointsArray (codePoints) {
	  var len = codePoints.length
	  if (len <= MAX_ARGUMENTS_LENGTH) {
	    return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
	  }

	  // Decode in chunks to avoid "call stack size exceeded".
	  var res = ''
	  var i = 0
	  while (i < len) {
	    res += String.fromCharCode.apply(
	      String,
	      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
	    )
	  }
	  return res
	}

	function asciiSlice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; ++i) {
	    ret += String.fromCharCode(buf[i] & 0x7F)
	  }
	  return ret
	}

	function latin1Slice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; ++i) {
	    ret += String.fromCharCode(buf[i])
	  }
	  return ret
	}

	function hexSlice (buf, start, end) {
	  var len = buf.length

	  if (!start || start < 0) start = 0
	  if (!end || end < 0 || end > len) end = len

	  var out = ''
	  for (var i = start; i < end; ++i) {
	    out += toHex(buf[i])
	  }
	  return out
	}

	function utf16leSlice (buf, start, end) {
	  var bytes = buf.slice(start, end)
	  var res = ''
	  for (var i = 0; i < bytes.length; i += 2) {
	    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256)
	  }
	  return res
	}

	Buffer.prototype.slice = function slice (start, end) {
	  var len = this.length
	  start = ~~start
	  end = end === undefined ? len : ~~end

	  if (start < 0) {
	    start += len
	    if (start < 0) start = 0
	  } else if (start > len) {
	    start = len
	  }

	  if (end < 0) {
	    end += len
	    if (end < 0) end = 0
	  } else if (end > len) {
	    end = len
	  }

	  if (end < start) end = start

	  var newBuf
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    newBuf = this.subarray(start, end)
	    newBuf.__proto__ = Buffer.prototype
	  } else {
	    var sliceLen = end - start
	    newBuf = new Buffer(sliceLen, undefined)
	    for (var i = 0; i < sliceLen; ++i) {
	      newBuf[i] = this[i + start]
	    }
	  }

	  return newBuf
	}

	/*
	 * Need to make sure that buffer isn't trying to write out of bounds.
	 */
	function checkOffset (offset, ext, length) {
	  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
	  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
	}

	Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }

	  return val
	}

	Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    checkOffset(offset, byteLength, this.length)
	  }

	  var val = this[offset + --byteLength]
	  var mul = 1
	  while (byteLength > 0 && (mul *= 0x100)) {
	    val += this[offset + --byteLength] * mul
	  }

	  return val
	}

	Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  return this[offset]
	}

	Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return this[offset] | (this[offset + 1] << 8)
	}

	Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return (this[offset] << 8) | this[offset + 1]
	}

	Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return ((this[offset]) |
	      (this[offset + 1] << 8) |
	      (this[offset + 2] << 16)) +
	      (this[offset + 3] * 0x1000000)
	}

	Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset] * 0x1000000) +
	    ((this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    this[offset + 3])
	}

	Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }
	  mul *= 0x80

	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

	  return val
	}

	Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var i = byteLength
	  var mul = 1
	  var val = this[offset + --i]
	  while (i > 0 && (mul *= 0x100)) {
	    val += this[offset + --i] * mul
	  }
	  mul *= 0x80

	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

	  return val
	}

	Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  if (!(this[offset] & 0x80)) return (this[offset])
	  return ((0xff - this[offset] + 1) * -1)
	}

	Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset] | (this[offset + 1] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}

	Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset + 1] | (this[offset] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}

	Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset]) |
	    (this[offset + 1] << 8) |
	    (this[offset + 2] << 16) |
	    (this[offset + 3] << 24)
	}

	Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset] << 24) |
	    (this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    (this[offset + 3])
	}

	Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, true, 23, 4)
	}

	Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, false, 23, 4)
	}

	Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, true, 52, 8)
	}

	Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, false, 52, 8)
	}

	function checkInt (buf, value, offset, ext, max, min) {
	  if (!Buffer.isBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
	  if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
	  if (offset + ext > buf.length) throw new RangeError('Index out of range')
	}

	Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    var maxBytes = Math.pow(2, 8 * byteLength) - 1
	    checkInt(this, value, offset, byteLength, maxBytes, 0)
	  }

	  var mul = 1
	  var i = 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    var maxBytes = Math.pow(2, 8 * byteLength) - 1
	    checkInt(this, value, offset, byteLength, maxBytes, 0)
	  }

	  var i = byteLength - 1
	  var mul = 1
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  this[offset] = (value & 0xff)
	  return offset + 1
	}

	function objectWriteUInt16 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
	    buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
	      (littleEndian ? i : 1 - i) * 8
	  }
	}

	Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = (value & 0xff)
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}

	function objectWriteUInt32 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffffffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
	    buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff
	  }
	}

	Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset + 3] = (value >>> 24)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 1] = (value >>> 8)
	    this[offset] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)

	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }

	  var i = 0
	  var mul = 1
	  var sub = 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
	      sub = 1
	    }
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)

	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }

	  var i = byteLength - 1
	  var mul = 1
	  var sub = 0
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
	      sub = 1
	    }
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  if (value < 0) value = 0xff + value + 1
	  this[offset] = (value & 0xff)
	  return offset + 1
	}

	Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = (value & 0xff)
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 3] = (value >>> 24)
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (value < 0) value = 0xffffffff + value + 1
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}

	function checkIEEE754 (buf, value, offset, ext, max, min) {
	  if (offset + ext > buf.length) throw new RangeError('Index out of range')
	  if (offset < 0) throw new RangeError('Index out of range')
	}

	function writeFloat (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 23, 4)
	  return offset + 4
	}

	Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, true, noAssert)
	}

	Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, false, noAssert)
	}

	function writeDouble (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 52, 8)
	  return offset + 8
	}

	Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, true, noAssert)
	}

	Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, false, noAssert)
	}

	// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
	Buffer.prototype.copy = function copy (target, targetStart, start, end) {
	  if (!start) start = 0
	  if (!end && end !== 0) end = this.length
	  if (targetStart >= target.length) targetStart = target.length
	  if (!targetStart) targetStart = 0
	  if (end > 0 && end < start) end = start

	  // Copy 0 bytes; we're done
	  if (end === start) return 0
	  if (target.length === 0 || this.length === 0) return 0

	  // Fatal error conditions
	  if (targetStart < 0) {
	    throw new RangeError('targetStart out of bounds')
	  }
	  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
	  if (end < 0) throw new RangeError('sourceEnd out of bounds')

	  // Are we oob?
	  if (end > this.length) end = this.length
	  if (target.length - targetStart < end - start) {
	    end = target.length - targetStart + start
	  }

	  var len = end - start
	  var i

	  if (this === target && start < targetStart && targetStart < end) {
	    // descending copy from end
	    for (i = len - 1; i >= 0; --i) {
	      target[i + targetStart] = this[i + start]
	    }
	  } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
	    // ascending copy from start
	    for (i = 0; i < len; ++i) {
	      target[i + targetStart] = this[i + start]
	    }
	  } else {
	    Uint8Array.prototype.set.call(
	      target,
	      this.subarray(start, start + len),
	      targetStart
	    )
	  }

	  return len
	}

	// Usage:
	//    buffer.fill(number[, offset[, end]])
	//    buffer.fill(buffer[, offset[, end]])
	//    buffer.fill(string[, offset[, end]][, encoding])
	Buffer.prototype.fill = function fill (val, start, end, encoding) {
	  // Handle string cases:
	  if (typeof val === 'string') {
	    if (typeof start === 'string') {
	      encoding = start
	      start = 0
	      end = this.length
	    } else if (typeof end === 'string') {
	      encoding = end
	      end = this.length
	    }
	    if (val.length === 1) {
	      var code = val.charCodeAt(0)
	      if (code < 256) {
	        val = code
	      }
	    }
	    if (encoding !== undefined && typeof encoding !== 'string') {
	      throw new TypeError('encoding must be a string')
	    }
	    if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
	      throw new TypeError('Unknown encoding: ' + encoding)
	    }
	  } else if (typeof val === 'number') {
	    val = val & 255
	  }

	  // Invalid ranges are not set to a default, so can range check early.
	  if (start < 0 || this.length < start || this.length < end) {
	    throw new RangeError('Out of range index')
	  }

	  if (end <= start) {
	    return this
	  }

	  start = start >>> 0
	  end = end === undefined ? this.length : end >>> 0

	  if (!val) val = 0

	  var i
	  if (typeof val === 'number') {
	    for (i = start; i < end; ++i) {
	      this[i] = val
	    }
	  } else {
	    var bytes = Buffer.isBuffer(val)
	      ? val
	      : utf8ToBytes(new Buffer(val, encoding).toString())
	    var len = bytes.length
	    for (i = 0; i < end - start; ++i) {
	      this[i + start] = bytes[i % len]
	    }
	  }

	  return this
	}

	// HELPER FUNCTIONS
	// ================

	var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g

	function base64clean (str) {
	  // Node strips out invalid characters like \n and \t from the string, base64-js does not
	  str = stringtrim(str).replace(INVALID_BASE64_RE, '')
	  // Node converts strings with length < 2 to ''
	  if (str.length < 2) return ''
	  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
	  while (str.length % 4 !== 0) {
	    str = str + '='
	  }
	  return str
	}

	function stringtrim (str) {
	  if (str.trim) return str.trim()
	  return str.replace(/^\s+|\s+$/g, '')
	}

	function toHex (n) {
	  if (n < 16) return '0' + n.toString(16)
	  return n.toString(16)
	}

	function utf8ToBytes (string, units) {
	  units = units || Infinity
	  var codePoint
	  var length = string.length
	  var leadSurrogate = null
	  var bytes = []

	  for (var i = 0; i < length; ++i) {
	    codePoint = string.charCodeAt(i)

	    // is surrogate component
	    if (codePoint > 0xD7FF && codePoint < 0xE000) {
	      // last char was a lead
	      if (!leadSurrogate) {
	        // no lead yet
	        if (codePoint > 0xDBFF) {
	          // unexpected trail
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        } else if (i + 1 === length) {
	          // unpaired lead
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        }

	        // valid lead
	        leadSurrogate = codePoint

	        continue
	      }

	      // 2 leads in a row
	      if (codePoint < 0xDC00) {
	        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	        leadSurrogate = codePoint
	        continue
	      }

	      // valid surrogate pair
	      codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000
	    } else if (leadSurrogate) {
	      // valid bmp char, but last char was a lead
	      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	    }

	    leadSurrogate = null

	    // encode utf8
	    if (codePoint < 0x80) {
	      if ((units -= 1) < 0) break
	      bytes.push(codePoint)
	    } else if (codePoint < 0x800) {
	      if ((units -= 2) < 0) break
	      bytes.push(
	        codePoint >> 0x6 | 0xC0,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x10000) {
	      if ((units -= 3) < 0) break
	      bytes.push(
	        codePoint >> 0xC | 0xE0,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x110000) {
	      if ((units -= 4) < 0) break
	      bytes.push(
	        codePoint >> 0x12 | 0xF0,
	        codePoint >> 0xC & 0x3F | 0x80,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else {
	      throw new Error('Invalid code point')
	    }
	  }

	  return bytes
	}

	function asciiToBytes (str) {
	  var byteArray = []
	  for (var i = 0; i < str.length; ++i) {
	    // Node's code seems to be doing this and not & 0x7F..
	    byteArray.push(str.charCodeAt(i) & 0xFF)
	  }
	  return byteArray
	}

	function utf16leToBytes (str, units) {
	  var c, hi, lo
	  var byteArray = []
	  for (var i = 0; i < str.length; ++i) {
	    if ((units -= 2) < 0) break

	    c = str.charCodeAt(i)
	    hi = c >> 8
	    lo = c % 256
	    byteArray.push(lo)
	    byteArray.push(hi)
	  }

	  return byteArray
	}

	function base64ToBytes (str) {
	  return base64.toByteArray(base64clean(str))
	}

	function blitBuffer (src, dst, offset, length) {
	  for (var i = 0; i < length; ++i) {
	    if ((i + offset >= dst.length) || (i >= src.length)) break
	    dst[i + offset] = src[i]
	  }
	  return i
	}

	function isnan (val) {
	  return val !== val // eslint-disable-line no-self-compare
	}

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 7 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_7__;

/***/ },
/* 8 */
/***/ function(module, exports) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	// NOTE: These type checking functions intentionally don't use `instanceof`
	// because it is fragile and can be easily faked with `Object.create()`.

	function isArray(arg) {
	  if (Array.isArray) {
	    return Array.isArray(arg);
	  }
	  return objectToString(arg) === '[object Array]';
	}
	exports.isArray = isArray;

	function isBoolean(arg) {
	  return typeof arg === 'boolean';
	}
	exports.isBoolean = isBoolean;

	function isNull(arg) {
	  return arg === null;
	}
	exports.isNull = isNull;

	function isNullOrUndefined(arg) {
	  return arg == null;
	}
	exports.isNullOrUndefined = isNullOrUndefined;

	function isNumber(arg) {
	  return typeof arg === 'number';
	}
	exports.isNumber = isNumber;

	function isString(arg) {
	  return typeof arg === 'string';
	}
	exports.isString = isString;

	function isSymbol(arg) {
	  return typeof arg === 'symbol';
	}
	exports.isSymbol = isSymbol;

	function isUndefined(arg) {
	  return arg === void 0;
	}
	exports.isUndefined = isUndefined;

	function isRegExp(re) {
	  return objectToString(re) === '[object RegExp]';
	}
	exports.isRegExp = isRegExp;

	function isObject(arg) {
	  return typeof arg === 'object' && arg !== null;
	}
	exports.isObject = isObject;

	function isDate(d) {
	  return objectToString(d) === '[object Date]';
	}
	exports.isDate = isDate;

	function isError(e) {
	  return (objectToString(e) === '[object Error]' || e instanceof Error);
	}
	exports.isError = isError;

	function isFunction(arg) {
	  return typeof arg === 'function';
	}
	exports.isFunction = isFunction;

	function isPrimitive(arg) {
	  return arg === null ||
	         typeof arg === 'boolean' ||
	         typeof arg === 'number' ||
	         typeof arg === 'string' ||
	         typeof arg === 'symbol' ||  // ES6 symbol
	         typeof arg === 'undefined';
	}
	exports.isPrimitive = isPrimitive;

	exports.isBuffer = Buffer.isBuffer;

	function objectToString(o) {
	  return Object.prototype.toString.call(o);
	}


/***/ },
/* 9 */
/***/ function(module, exports) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	function EventEmitter() {
	  this._events = this._events || {};
	  this._maxListeners = this._maxListeners || undefined;
	}
	module.exports = EventEmitter;

	// Backwards-compat with node 0.10.x
	EventEmitter.EventEmitter = EventEmitter;

	EventEmitter.prototype._events = undefined;
	EventEmitter.prototype._maxListeners = undefined;

	// By default EventEmitters will print a warning if more than 10 listeners are
	// added to it. This is a useful default which helps finding memory leaks.
	EventEmitter.defaultMaxListeners = 10;

	// Obviously not all Emitters should be limited to 10. This function allows
	// that to be increased. Set to zero for unlimited.
	EventEmitter.prototype.setMaxListeners = function(n) {
	  if (!isNumber(n) || n < 0 || isNaN(n))
	    throw TypeError('n must be a positive number');
	  this._maxListeners = n;
	  return this;
	};

	EventEmitter.prototype.emit = function(type) {
	  var er, handler, len, args, i, listeners;

	  if (!this._events)
	    this._events = {};

	  // If there is no 'error' event listener then throw.
	  if (type === 'error') {
	    if (!this._events.error ||
	        (isObject(this._events.error) && !this._events.error.length)) {
	      er = arguments[1];
	      if (er instanceof Error) {
	        throw er; // Unhandled 'error' event
	      } else {
	        // At least give some kind of context to the user
	        var err = new Error('Uncaught, unspecified "error" event. (' + er + ')');
	        err.context = er;
	        throw err;
	      }
	    }
	  }

	  handler = this._events[type];

	  if (isUndefined(handler))
	    return false;

	  if (isFunction(handler)) {
	    switch (arguments.length) {
	      // fast cases
	      case 1:
	        handler.call(this);
	        break;
	      case 2:
	        handler.call(this, arguments[1]);
	        break;
	      case 3:
	        handler.call(this, arguments[1], arguments[2]);
	        break;
	      // slower
	      default:
	        args = Array.prototype.slice.call(arguments, 1);
	        handler.apply(this, args);
	    }
	  } else if (isObject(handler)) {
	    args = Array.prototype.slice.call(arguments, 1);
	    listeners = handler.slice();
	    len = listeners.length;
	    for (i = 0; i < len; i++)
	      listeners[i].apply(this, args);
	  }

	  return true;
	};

	EventEmitter.prototype.addListener = function(type, listener) {
	  var m;

	  if (!isFunction(listener))
	    throw TypeError('listener must be a function');

	  if (!this._events)
	    this._events = {};

	  // To avoid recursion in the case that type === "newListener"! Before
	  // adding it to the listeners, first emit "newListener".
	  if (this._events.newListener)
	    this.emit('newListener', type,
	              isFunction(listener.listener) ?
	              listener.listener : listener);

	  if (!this._events[type])
	    // Optimize the case of one listener. Don't need the extra array object.
	    this._events[type] = listener;
	  else if (isObject(this._events[type]))
	    // If we've already got an array, just append.
	    this._events[type].push(listener);
	  else
	    // Adding the second element, need to change to array.
	    this._events[type] = [this._events[type], listener];

	  // Check for listener leak
	  if (isObject(this._events[type]) && !this._events[type].warned) {
	    if (!isUndefined(this._maxListeners)) {
	      m = this._maxListeners;
	    } else {
	      m = EventEmitter.defaultMaxListeners;
	    }

	    if (m && m > 0 && this._events[type].length > m) {
	      this._events[type].warned = true;
	      console.error('(node) warning: possible EventEmitter memory ' +
	                    'leak detected. %d listeners added. ' +
	                    'Use emitter.setMaxListeners() to increase limit.',
	                    this._events[type].length);
	      if (typeof console.trace === 'function') {
	        // not supported in IE 10
	        console.trace();
	      }
	    }
	  }

	  return this;
	};

	EventEmitter.prototype.on = EventEmitter.prototype.addListener;

	EventEmitter.prototype.once = function(type, listener) {
	  if (!isFunction(listener))
	    throw TypeError('listener must be a function');

	  var fired = false;

	  function g() {
	    this.removeListener(type, g);

	    if (!fired) {
	      fired = true;
	      listener.apply(this, arguments);
	    }
	  }

	  g.listener = listener;
	  this.on(type, g);

	  return this;
	};

	// emits a 'removeListener' event iff the listener was removed
	EventEmitter.prototype.removeListener = function(type, listener) {
	  var list, position, length, i;

	  if (!isFunction(listener))
	    throw TypeError('listener must be a function');

	  if (!this._events || !this._events[type])
	    return this;

	  list = this._events[type];
	  length = list.length;
	  position = -1;

	  if (list === listener ||
	      (isFunction(list.listener) && list.listener === listener)) {
	    delete this._events[type];
	    if (this._events.removeListener)
	      this.emit('removeListener', type, listener);

	  } else if (isObject(list)) {
	    for (i = length; i-- > 0;) {
	      if (list[i] === listener ||
	          (list[i].listener && list[i].listener === listener)) {
	        position = i;
	        break;
	      }
	    }

	    if (position < 0)
	      return this;

	    if (list.length === 1) {
	      list.length = 0;
	      delete this._events[type];
	    } else {
	      list.splice(position, 1);
	    }

	    if (this._events.removeListener)
	      this.emit('removeListener', type, listener);
	  }

	  return this;
	};

	EventEmitter.prototype.removeAllListeners = function(type) {
	  var key, listeners;

	  if (!this._events)
	    return this;

	  // not listening for removeListener, no need to emit
	  if (!this._events.removeListener) {
	    if (arguments.length === 0)
	      this._events = {};
	    else if (this._events[type])
	      delete this._events[type];
	    return this;
	  }

	  // emit removeListener for all listeners on all events
	  if (arguments.length === 0) {
	    for (key in this._events) {
	      if (key === 'removeListener') continue;
	      this.removeAllListeners(key);
	    }
	    this.removeAllListeners('removeListener');
	    this._events = {};
	    return this;
	  }

	  listeners = this._events[type];

	  if (isFunction(listeners)) {
	    this.removeListener(type, listeners);
	  } else if (listeners) {
	    // LIFO order
	    while (listeners.length)
	      this.removeListener(type, listeners[listeners.length - 1]);
	  }
	  delete this._events[type];

	  return this;
	};

	EventEmitter.prototype.listeners = function(type) {
	  var ret;
	  if (!this._events || !this._events[type])
	    ret = [];
	  else if (isFunction(this._events[type]))
	    ret = [this._events[type]];
	  else
	    ret = this._events[type].slice();
	  return ret;
	};

	EventEmitter.prototype.listenerCount = function(type) {
	  if (this._events) {
	    var evlistener = this._events[type];

	    if (isFunction(evlistener))
	      return 1;
	    else if (evlistener)
	      return evlistener.length;
	  }
	  return 0;
	};

	EventEmitter.listenerCount = function(emitter, type) {
	  return emitter.listenerCount(type);
	};

	function isFunction(arg) {
	  return typeof arg === 'function';
	}

	function isNumber(arg) {
	  return typeof arg === 'number';
	}

	function isObject(arg) {
	  return typeof arg === 'object' && arg !== null;
	}

	function isUndefined(arg) {
	  return arg === void 0;
	}


/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';

	var buffer = __webpack_require__(6);
	var Buffer = buffer.Buffer;
	var SlowBuffer = buffer.SlowBuffer;
	var MAX_LEN = buffer.kMaxLength || 2147483647;
	exports.alloc = function alloc(size, fill, encoding) {
	  if (typeof Buffer.alloc === 'function') {
	    return Buffer.alloc(size, fill, encoding);
	  }
	  if (typeof encoding === 'number') {
	    throw new TypeError('encoding must not be number');
	  }
	  if (typeof size !== 'number') {
	    throw new TypeError('size must be a number');
	  }
	  if (size > MAX_LEN) {
	    throw new RangeError('size is too large');
	  }
	  var enc = encoding;
	  var _fill = fill;
	  if (_fill === undefined) {
	    enc = undefined;
	    _fill = 0;
	  }
	  var buf = new Buffer(size);
	  if (typeof _fill === 'string') {
	    var fillBuf = new Buffer(_fill, enc);
	    var flen = fillBuf.length;
	    var i = -1;
	    while (++i < size) {
	      buf[i] = fillBuf[i % flen];
	    }
	  } else {
	    buf.fill(_fill);
	  }
	  return buf;
	}
	exports.allocUnsafe = function allocUnsafe(size) {
	  if (typeof Buffer.allocUnsafe === 'function') {
	    return Buffer.allocUnsafe(size);
	  }
	  if (typeof size !== 'number') {
	    throw new TypeError('size must be a number');
	  }
	  if (size > MAX_LEN) {
	    throw new RangeError('size is too large');
	  }
	  return new Buffer(size);
	}
	exports.from = function from(value, encodingOrOffset, length) {
	  if (typeof Buffer.from === 'function' && (!global.Uint8Array || Uint8Array.from !== Buffer.from)) {
	    return Buffer.from(value, encodingOrOffset, length);
	  }
	  if (typeof value === 'number') {
	    throw new TypeError('"value" argument must not be a number');
	  }
	  if (typeof value === 'string') {
	    return new Buffer(value, encodingOrOffset);
	  }
	  if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
	    var offset = encodingOrOffset;
	    if (arguments.length === 1) {
	      return new Buffer(value);
	    }
	    if (typeof offset === 'undefined') {
	      offset = 0;
	    }
	    var len = length;
	    if (typeof len === 'undefined') {
	      len = value.byteLength - offset;
	    }
	    if (offset >= value.byteLength) {
	      throw new RangeError('\'offset\' is out of bounds');
	    }
	    if (len > value.byteLength - offset) {
	      throw new RangeError('\'length\' is out of bounds');
	    }
	    return new Buffer(value.slice(offset, offset + len));
	  }
	  if (Buffer.isBuffer(value)) {
	    var out = new Buffer(value.length);
	    value.copy(out, 0, 0, value.length);
	    return out;
	  }
	  if (value) {
	    if (Array.isArray(value) || (typeof ArrayBuffer !== 'undefined' && value.buffer instanceof ArrayBuffer) || 'length' in value) {
	      return new Buffer(value);
	    }
	    if (value.type === 'Buffer' && Array.isArray(value.data)) {
	      return new Buffer(value.data);
	    }
	  }

	  throw new TypeError('First argument must be a string, Buffer, ' + 'ArrayBuffer, Array, or array-like object.');
	}
	exports.allocUnsafeSlow = function allocUnsafeSlow(size) {
	  if (typeof Buffer.allocUnsafeSlow === 'function') {
	    return Buffer.allocUnsafeSlow(size);
	  }
	  if (typeof size !== 'number') {
	    throw new TypeError('size must be a number');
	  }
	  if (size >= MAX_LEN) {
	    throw new RangeError('size is too large');
	  }
	  return new SlowBuffer(size);
	}

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	/**
	 * Functions to access fragments: superclass for Document and Doc (from Group), not supposed to be created directly
	 * @constructor
	 */
	function WithFragments() {}

	WithFragments.prototype = {
	  /**
	   * Gets the fragment in the current Document object. Since you most likely know the type
	   * of this fragment, it is advised that you use a dedicated method, like get StructuredText() or getDate(),
	   * for instance.
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.author"
	   * @returns {object} - The JavaScript Fragment object to manipulate
	   */
	  get: function(name) {
	    var frags = this._getFragments(name);
	    return frags.length ? frags[0] : null;
	  },

	  /**
	   * Builds an array of all the fragments in case they are multiple.
	   *
	   * @param {string} name - The name of the multiple fragment to get, with its type; for instance, "blog-post.author"
	   * @returns {array} - An array of each JavaScript fragment object to manipulate.
	   */
	  getAll: function(name) {
	    return this._getFragments(name);
	  },

	  /**
	   * Gets the image fragment in the current Document object, for further manipulation.
	   *
	   * @example document.getImage('blog-post.photo').asHtml(linkResolver)
	   *
	   * @param {string} fragment - The name of the fragment to get, with its type; for instance, "blog-post.photo"
	   * @returns {ImageEl} - The Image object to manipulate
	   */
	  getImage: function(fragment) {
	    var Fragments = __webpack_require__(1);
	    var img = this.get(fragment);
	    if (img instanceof Fragments.Image) {
	      return img;
	    }
	    if (img instanceof Fragments.StructuredText) {
	      // find first image in st.
	      return img;
	    }
	    return null;
	  },

	  // Useful for obsolete multiples
	  getAllImages: function(fragment) {
	    var Fragments = __webpack_require__(1);
	    var images = this.getAll(fragment);

	    return images.map(function (image) {
	      if (image instanceof Fragments.Image) {
	        return image;
	      }
	      if (image instanceof Fragments.StructuredText) {
	        throw new Error("Not done.");
	      }
	      return null;
	    });
	  },


	  getFirstImage: function() {
	    var Fragments = __webpack_require__(1);
	    var fragments = this.fragments;

	    var firstImage = Object.keys(fragments).reduce(function(image, key) {
	      if (image) {
	        return image;
	      } else {
	        var element = fragments[key];
	        if(typeof element.getFirstImage === "function") {
	          return element.getFirstImage();
	        } else if (element instanceof Fragments.Image) {
	          return element;

	        } else return null;
	      }
	    }, null);
	    return firstImage;
	  },

	  getFirstTitle: function() {
	    var Fragments = __webpack_require__(1);
	    var fragments = this.fragments;

	    var firstTitle = Object.keys(fragments).reduce(function(st, key) {
	      if (st) {
	        return st;
	      } else {
	        var element = fragments[key];
	        if(typeof element.getFirstTitle === "function") {
	          return element.getFirstTitle();
	        } else if (element instanceof Fragments.StructuredText) {
	          return element.getTitle();
	        } else return null;
	      }
	    }, null);
	    return firstTitle;
	  },

	  getFirstParagraph: function() {
	    var fragments = this.fragments;

	    var firstParagraph = Object.keys(fragments).reduce(function(st, key) {
	      if (st) {
	        return st;
	      } else {
	        var element = fragments[key];
	        if(typeof element.getFirstParagraph === "function") {
	          return element.getFirstParagraph();
	        } else return null;
	      }
	    }, null);
	    return firstParagraph;
	  },

	  /**
	   * Gets the view within the image fragment in the current Document object, for further manipulation.
	   *
	   * @example document.getImageView('blog-post.photo', 'large').asHtml(linkResolver)
	   *
	   * @param {string} name- The name of the fragment to get, with its type; for instance, "blog-post.photo"
	   * @returns {ImageView} view - The View object to manipulate
	   */
	  getImageView: function(name, view) {
	    var Fragments = __webpack_require__(1);
	    var fragment = this.get(name);
	    if (fragment instanceof Fragments.Image) {
	      return fragment.getView(view);
	    }
	    if (fragment instanceof Fragments.StructuredText) {
	      for(var i=0; i<fragment.blocks.length; i++) {
	        if(fragment.blocks[i].type == 'image') {
	          return fragment.blocks[i];
	        }
	      }
	    }
	    return null;
	  },

	  // Useful for obsolete multiples
	  getAllImageViews: function(name, view) {
	    return this.getAllImages(name).map(function (image) {
	      return image.getView(view);
	    });
	  },

	  /**
	   * Gets the timestamp fragment in the current Document object, for further manipulation.
	   *
	   * @example document.getDate('blog-post.publicationdate').asHtml(linkResolver)
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.publicationdate"
	   * @returns {Date} - The Date object to manipulate
	   */
	  getTimestamp: function(name) {
	    var Fragments = __webpack_require__(1);
	    var fragment = this.get(name);

	    if (fragment instanceof Fragments.Timestamp) {
	      return fragment.value;
	    }
	    return null;
	  },

	  /**
	   * Gets the date fragment in the current Document object, for further manipulation.
	   *
	   * @example document.getDate('blog-post.publicationdate').asHtml(linkResolver)
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.publicationdate"
	   * @returns {Date} - The Date object to manipulate
	   */
	  getDate: function(name) {
	    var Fragments = __webpack_require__(1);
	    var fragment = this.get(name);

	    if (fragment instanceof Fragments.Date) {
	      return fragment.value;
	    }
	    return null;
	  },

	  /**
	   * Gets a boolean value of the fragment in the current Document object, for further manipulation.
	   * This works great with a Select fragment. The Select values that are considered true are (lowercased before matching): 'yes', 'on', and 'true'.
	   *
	   * @example if(document.getBoolean('blog-post.enableComments')) { ... }
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.enableComments"
	   * @returns {boolean} - The boolean value of the fragment
	   */
	  getBoolean: function(name) {
	    var fragment = this.get(name);
	    return fragment.value && (fragment.value.toLowerCase() == 'yes' || fragment.value.toLowerCase() == 'on' || fragment.value.toLowerCase() == 'true');
	  },

	  /**
	   * Gets the text fragment in the current Document object, for further manipulation.
	   * The method works with StructuredText fragments, Text fragments, Number fragments, Select fragments and Color fragments.
	   *
	   * @example document.getText('blog-post.label').asHtml(linkResolver).
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.label"
	   * @param {string} after - a suffix that will be appended to the value
	   * @returns {object} - either StructuredText, or Text, or Number, or Select, or Color.
	   */
	  getText: function(name, after) {
	    var Fragments = __webpack_require__(1);
	    var fragment = this.get(name);

	    if (fragment instanceof Fragments.StructuredText) {
	      return fragment.blocks.map(function(block) {
	        if (block.text) {
	          return block.text + (after ? after : '');
	        }
	        return '';
	      }).join('\n');
	    }

	    if (fragment instanceof Fragments.Text) {
	      if(fragment.value) {
	        return fragment.value + (after ? after : '');
	      }
	    }

	    if (fragment instanceof Fragments.Number) {
	      if(fragment.value) {
	        return fragment.value + (after ? after : '');
	      }
	    }

	    if (fragment instanceof Fragments.Select) {
	      if(fragment.value) {
	        return fragment.value + (after ? after : '');
	      }
	    }

	    if (fragment instanceof Fragments.Color) {
	      if(fragment.value) {
	        return fragment.value + (after ? after : '');
	      }
	    }

	    return null;
	  },

	  /**
	   * Gets the StructuredText fragment in the current Document object, for further manipulation.
	   * @example document.getStructuredText('blog-post.body').asHtml(linkResolver)
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.body"
	   * @returns {StructuredText} - The StructuredText fragment to manipulate.
	   */
	  getStructuredText: function(name) {
	    var fragment = this.get(name);

	    if (fragment instanceof __webpack_require__(1).StructuredText) {
	      return fragment;
	    }
	    return null;
	  },

	  /**
	   * Gets the Link fragment in the current Document object, for further manipulation.
	   * @example document.getLink('blog-post.link').url(resolver)
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.link"
	   * @returns {WebLink|DocumentLink|ImageLink} - The Link fragment to manipulate.
	   */
	  getLink: function(name) {
	    var Fragments = __webpack_require__(1);
	    var fragment = this.get(name);

	    if (fragment instanceof Fragments.WebLink ||
	        fragment instanceof Fragments.DocumentLink ||
	        fragment instanceof Fragments.FileLink ||
	        fragment instanceof Fragments.ImageLink) {
	      return fragment;
	    }
	    return null;
	  },

	  /**
	   * Gets the Number fragment in the current Document object, for further manipulation.
	   * @example document.getNumber('product.price')
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "product.price"
	   * @returns {number} - The number value of the fragment.
	   */
	  getNumber: function(name) {
	    var Fragments = __webpack_require__(1);
	    var fragment = this.get(name);

	    if (fragment instanceof Fragments.Number) {
	      return fragment.value;
	    }
	    return null;
	  },

	  /**
	   * Gets the Color fragment in the current Document object, for further manipulation.
	   * @example document.getColor('product.color')
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "product.color"
	   * @returns {string} - The string value of the Color fragment.
	   */
	  getColor: function(name) {
	    var Fragments = __webpack_require__(1);
	    var fragment = this.get(name);

	    if (fragment instanceof Fragments.Color) {
	      return fragment.value;
	    }
	    return null;
	  },

	  /** Gets the GeoPoint fragment in the current Document object, for further manipulation.
	   *
	   * @example document.getGeoPoint('blog-post.location').asHtml(linkResolver)
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.location"
	   * @returns {GeoPoint} - The GeoPoint object to manipulate
	   */
	  getGeoPoint: function(name) {
	    var Fragments = __webpack_require__(1);
	    var fragment = this.get(name);

	    if(fragment instanceof Fragments.GeoPoint) {
	      return fragment;
	    }
	    return null;
	  },

	  /**
	   * Gets the Group fragment in the current Document object, for further manipulation.
	   *
	   * @example document.getGroup('product.gallery').asHtml(linkResolver).
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "product.gallery"
	   * @returns {Group} - The Group fragment to manipulate.
	   */
	  getGroup: function(name) {
	    var fragment = this.get(name);

	    if (fragment instanceof __webpack_require__(1).Group) {
	      return fragment;
	    }
	    return null;
	  },

	  /**
	   * Shortcut to get the HTML output of the fragment in the current document.
	   * This is the same as writing document.get(fragment).asHtml(linkResolver);
	   *
	   * @param {string} name - The name of the fragment to get, with its type; for instance, "blog-post.body"
	   * @param {function} linkResolver
	   * @returns {string} - The HTML output
	   */
	  getHtml: function(name, linkResolver) {
	    if (!isFunction(linkResolver)) {
	      // Backward compatibility with the old ctx argument
	      var ctx = linkResolver;
	      linkResolver = function(doc, isBroken) {
	        return ctx.linkResolver(ctx, doc, isBroken);
	      };
	    }
	    var fragment = this.get(name);

	    if(fragment && fragment.asHtml) {
	      return fragment.asHtml(linkResolver);
	    }
	    return null;
	  },

	  /**
	   * Transforms the whole document as an HTML output. Each fragment is separated by a &lt;section&gt; tag,
	   * with the attribute data-field="nameoffragment"
	   * Note that most of the time you will not use this method, but read fragment independently and generate
	   * HTML output for {@link StructuredText} fragment with that class' asHtml method.
	   *
	   * @param {function} linkResolver
	   * @returns {string} - The HTML output
	   */
	  asHtml: function(linkResolver) {
	    if (!isFunction(linkResolver)) {
	      // Backward compatibility with the old ctx argument
	      var ctx = linkResolver;
	      linkResolver = function(doc, isBroken) {
	        return ctx.linkResolver(ctx, doc, isBroken);
	      };
	    }
	    var htmls = [];
	    for(var field in this.fragments) {
	      var fragment = this.get(field);
	      htmls.push(fragment && fragment.asHtml ? '<section data-field="' + field + '">' + fragment.asHtml(linkResolver) + '</section>' : '');
	    }
	    return htmls.join('');
	  },

	  /**
	   * Turns the document into a useable text version of it.
	   *
	   * @returns {string} - basic text version of the fragment
	   */
	  asText: function(linkResolver) {
	    if (!isFunction(linkResolver)) {
	      // Backward compatibility with the old ctx argument
	      var ctx = linkResolver;
	      linkResolver = function(doc, isBroken) {
	        return ctx.linkResolver(ctx, doc, isBroken);
	      };
	    }
	    var texts = [];
	    for(var field in this.fragments) {
	      var fragment = this.get(field);
	      texts.push(fragment && fragment.asText ? fragment.asText(linkResolver) : '');
	    }
	    return texts.join('');
	  },

	  /**
	   * Linked documents, as an array of {@link DocumentLink}
	   * @returns {Array}
	   */
	  linkedDocuments: function() {
	    var i, j, link;
	    var result = [];
	    var Fragments = __webpack_require__(1);
	    for (var field in this.data) {
	      var fragment = this.get(field);
	      if (fragment instanceof Fragments.DocumentLink) {
	        result.push(fragment);
	      }
	      if (fragment instanceof Fragments.StructuredText) {
	        for (i = 0; i < fragment.blocks.length; i++) {
	          var block = fragment.blocks[i];
	          if (block.type == "image" && block.linkTo) {
	            link = Fragments.initField(block.linkTo);
	            if (link instanceof Fragments.DocumentLink) {
	              result.push(link);
	            }
	          }
	          var spans = block.spans || [];
	          for (j = 0; j < spans.length; j++) {
	            var span = spans[j];
	            if (span.type == "hyperlink") {
	              link = Fragments.initField(span.data);
	              if (link instanceof Fragments.DocumentLink) {
	                result.push(link);
	              }
	            }
	          }
	        }
	      }
	      if (fragment instanceof Fragments.Group) {
	        for (i = 0; i < fragment.value.length; i++) {
	          result = result.concat(fragment.value[i].linkedDocuments());
	        }
	      }
	      if (fragment instanceof Fragments.SliceZone) {
	        for (i = 0; i < fragment.value.length; i++) {
	          var slice = fragment.value[i];
	          if (slice.value instanceof Fragments.DocumentLink) {
	            result.push(slice.value);
	          }
	        }
	      }
	    }
	    return result;
	  },

	  /**
	   * An array of the fragments with the given fragment name.
	   * The array is often a single-element array, expect when the fragment is a multiple fragment.
	   * @private
	   */
	  _getFragments: function(name) {
	    if (!this.fragments || !this.fragments[name]) {
	      return [];
	    }

	    if (Array.isArray(this.fragments[name])) {
	      return this.fragments[name];
	    } else {
	      return [this.fragments[name]];
	    }

	  }

	};

	/**
	 * Embodies a document as returned by the API.
	 * Most useful fields: id, type, tags, slug, slugs
	 * @constructor
	 * @global
	 * @alias Doc
	 */
	function Document(id, uid, type, href, tags, slugs, firstPublicationDate, lastPublicationDate, data) {
	  /**
	   * The ID of the document
	   * @type {string}
	   */
	  this.id = id;
	  /**
	   * The User ID of the document, a human readable id
	   * @type {string|null}
	   */
	  this.uid = uid;
	  /**
	   * The type of the document, corresponds to a document mask defined in the repository
	   * @type {string}
	   */
	  this.type = type;
	  /**
	   * The URL of the document in the API
	   * @type {string}
	   */
	  this.href = href;
	  /**
	   * The tags of the document
	   * @type {array}
	   */
	  this.tags = tags;
	  /**
	   * The current slug of the document, "-" if none was provided
	   * @type {string}
	   */
	  this.slug = slugs ? slugs[0] : "-";
	  /**
	   * All the slugs that were ever used by this document (including the current one, at the head)
	   * @type {array}
	   */
	  this.slugs = slugs;
	  /**
	   * The original JSON data from the API
	   */
	  this.data = data;
	  /**
	   * The first publication date of the document
	   */
	  this.firstPublicationDate = firstPublicationDate ? new Date(firstPublicationDate) : null;
	  /**
	   * The last publication date of the document
	   */
	  this.lastPublicationDate = lastPublicationDate ? new Date(lastPublicationDate) : null;
	  /**
	   * Fragments, converted to business objects
	   */
	  this.fragments = __webpack_require__(1).parseFragments(data);
	}

	Document.prototype = Object.create(WithFragments.prototype);

	/**
	 * Gets the SliceZone fragment in the current Document object, for further manipulation.
	 *
	 * @example document.getSliceZone('product.gallery').asHtml(linkResolver).
	 *
	 * @param {string} name - The name of the fragment to get, with its type; for instance, "product.gallery"
	 * @returns {Group} - The SliceZone fragment to manipulate.
	 */
	Document.prototype.getSliceZone = function(name) {
	  var fragment = this.get(name);

	  if (fragment instanceof __webpack_require__(1).SliceZone) {
	    return fragment;
	  }
	  return null;
	};

	function GroupDoc(data) {
	  /**
	   * The original JSON data from the API
	   */
	  this.data = data;
	  /**
	   * Fragments, converted to business objects
	   */
	  this.fragments = __webpack_require__(1).parseFragments(data);
	}

	GroupDoc.prototype = Object.create(WithFragments.prototype);

	// -- Private helpers

	function isFunction(f) {
	  var getType = {};
	  return f && getType.toString.call(f) === '[object Function]';
	}

	module.exports = {
	  WithFragments: WithFragments,
	  Document: Document,
	  GroupDoc: GroupDoc
	};


/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {'use strict';

	if (!process.version ||
	    process.version.indexOf('v0.') === 0 ||
	    process.version.indexOf('v1.') === 0 && process.version.indexOf('v1.8.') !== 0) {
	  module.exports = nextTick;
	} else {
	  module.exports = process.nextTick;
	}

	function nextTick(fn, arg1, arg2, arg3) {
	  if (typeof fn !== 'function') {
	    throw new TypeError('"callback" argument must be a function');
	  }
	  var len = arguments.length;
	  var args, i;
	  switch (len) {
	  case 0:
	  case 1:
	    return process.nextTick(fn);
	  case 2:
	    return process.nextTick(function afterTickOne() {
	      fn.call(null, arg1);
	    });
	  case 3:
	    return process.nextTick(function afterTickTwo() {
	      fn.call(null, arg1, arg2);
	    });
	  case 4:
	    return process.nextTick(function afterTickThree() {
	      fn.call(null, arg1, arg2, arg3);
	    });
	  default:
	    args = new Array(len - 1);
	    i = 0;
	    while (i < args.length) {
	      args[i++] = arguments[i];
	    }
	    return process.nextTick(function afterTick() {
	      fn.apply(null, args);
	    });
	  }
	}

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(3)))

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	// a transform stream is a readable/writable stream where you do
	// something with the data.  Sometimes it's called a "filter",
	// but that's not a great name for it, since that implies a thing where
	// some bits pass through, and others are simply ignored.  (That would
	// be a valid example of a transform, of course.)
	//
	// While the output is causally related to the input, it's not a
	// necessarily symmetric or synchronous transformation.  For example,
	// a zlib stream might take multiple plain-text writes(), and then
	// emit a single compressed chunk some time in the future.
	//
	// Here's how this works:
	//
	// The Transform stream has all the aspects of the readable and writable
	// stream classes.  When you write(chunk), that calls _write(chunk,cb)
	// internally, and returns false if there's a lot of pending writes
	// buffered up.  When you call read(), that calls _read(n) until
	// there's enough pending readable data buffered up.
	//
	// In a transform stream, the written data is placed in a buffer.  When
	// _read(n) is called, it transforms the queued up data, calling the
	// buffered _write cb's as it consumes chunks.  If consuming a single
	// written chunk would result in multiple output chunks, then the first
	// outputted bit calls the readcb, and subsequent chunks just go into
	// the read buffer, and will cause it to emit 'readable' if necessary.
	//
	// This way, back-pressure is actually determined by the reading side,
	// since _read has to be called to start processing a new chunk.  However,
	// a pathological inflate type of transform can cause excessive buffering
	// here.  For example, imagine a stream where every byte of input is
	// interpreted as an integer from 0-255, and then results in that many
	// bytes of output.  Writing the 4 bytes {ff,ff,ff,ff} would result in
	// 1kb of data being output.  In this case, you could write a very small
	// amount of input, and end up with a very large amount of output.  In
	// such a pathological inflating mechanism, there'd be no way to tell
	// the system to stop doing the transform.  A single 4MB write could
	// cause the system to run out of memory.
	//
	// However, even in such a pathological case, only a single written chunk
	// would be consumed, and then the rest would wait (un-transformed) until
	// the results of the previous transformed chunk were consumed.

	'use strict';

	module.exports = Transform;

	var Duplex = __webpack_require__(4);

	/*<replacement>*/
	var util = __webpack_require__(8);
	util.inherits = __webpack_require__(2);
	/*</replacement>*/

	util.inherits(Transform, Duplex);

	function TransformState(stream) {
	  this.afterTransform = function (er, data) {
	    return afterTransform(stream, er, data);
	  };

	  this.needTransform = false;
	  this.transforming = false;
	  this.writecb = null;
	  this.writechunk = null;
	  this.writeencoding = null;
	}

	function afterTransform(stream, er, data) {
	  var ts = stream._transformState;
	  ts.transforming = false;

	  var cb = ts.writecb;

	  if (!cb) return stream.emit('error', new Error('no writecb in Transform class'));

	  ts.writechunk = null;
	  ts.writecb = null;

	  if (data !== null && data !== undefined) stream.push(data);

	  cb(er);

	  var rs = stream._readableState;
	  rs.reading = false;
	  if (rs.needReadable || rs.length < rs.highWaterMark) {
	    stream._read(rs.highWaterMark);
	  }
	}

	function Transform(options) {
	  if (!(this instanceof Transform)) return new Transform(options);

	  Duplex.call(this, options);

	  this._transformState = new TransformState(this);

	  var stream = this;

	  // start out asking for a readable event once data is transformed.
	  this._readableState.needReadable = true;

	  // we have implemented the _read method, and done the other things
	  // that Readable wants before the first _read call, so unset the
	  // sync guard flag.
	  this._readableState.sync = false;

	  if (options) {
	    if (typeof options.transform === 'function') this._transform = options.transform;

	    if (typeof options.flush === 'function') this._flush = options.flush;
	  }

	  // When the writable side finishes, then flush out anything remaining.
	  this.once('prefinish', function () {
	    if (typeof this._flush === 'function') this._flush(function (er, data) {
	      done(stream, er, data);
	    });else done(stream);
	  });
	}

	Transform.prototype.push = function (chunk, encoding) {
	  this._transformState.needTransform = false;
	  return Duplex.prototype.push.call(this, chunk, encoding);
	};

	// This is the part where you do stuff!
	// override this function in implementation classes.
	// 'chunk' is an input chunk.
	//
	// Call `push(newChunk)` to pass along transformed output
	// to the readable side.  You may call 'push' zero or more times.
	//
	// Call `cb(err)` when you are done with this chunk.  If you pass
	// an error, then that'll put the hurt on the whole operation.  If you
	// never call cb(), then you'll never get another chunk.
	Transform.prototype._transform = function (chunk, encoding, cb) {
	  throw new Error('_transform() is not implemented');
	};

	Transform.prototype._write = function (chunk, encoding, cb) {
	  var ts = this._transformState;
	  ts.writecb = cb;
	  ts.writechunk = chunk;
	  ts.writeencoding = encoding;
	  if (!ts.transforming) {
	    var rs = this._readableState;
	    if (ts.needTransform || rs.needReadable || rs.length < rs.highWaterMark) this._read(rs.highWaterMark);
	  }
	};

	// Doesn't matter what the args are here.
	// _transform does all the work.
	// That we got here means that the readable side wants more data.
	Transform.prototype._read = function (n) {
	  var ts = this._transformState;

	  if (ts.writechunk !== null && ts.writecb && !ts.transforming) {
	    ts.transforming = true;
	    this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform);
	  } else {
	    // mark that we need a transform, so that any data that comes in
	    // will get processed, now that we've asked for it.
	    ts.needTransform = true;
	  }
	};

	function done(stream, er, data) {
	  if (er) return stream.emit('error', er);

	  if (data !== null && data !== undefined) stream.push(data);

	  // if there's nothing in the write buffer, then that means
	  // that nothing more will ever be provided
	  var ws = stream._writableState;
	  var ts = stream._transformState;

	  if (ws.length) throw new Error('Calling transform done when ws.length != 0');

	  if (ts.transforming) throw new Error('Calling transform done when still transforming');

	  return stream.push(null);
	}

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process, setImmediate) {// A bit simpler than readable streams.
	// Implement an async ._write(chunk, encoding, cb), and it'll handle all
	// the drain event emission and buffering.

	'use strict';

	module.exports = Writable;

	/*<replacement>*/
	var processNextTick = __webpack_require__(12);
	/*</replacement>*/

	/*<replacement>*/
	var asyncWrite = !process.browser && ['v0.10', 'v0.9.'].indexOf(process.version.slice(0, 5)) > -1 ? setImmediate : processNextTick;
	/*</replacement>*/

	/*<replacement>*/
	var Duplex;
	/*</replacement>*/

	Writable.WritableState = WritableState;

	/*<replacement>*/
	var util = __webpack_require__(8);
	util.inherits = __webpack_require__(2);
	/*</replacement>*/

	/*<replacement>*/
	var internalUtil = {
	  deprecate: __webpack_require__(61)
	};
	/*</replacement>*/

	/*<replacement>*/
	var Stream;
	(function () {
	  try {
	    Stream = __webpack_require__(16);
	  } catch (_) {} finally {
	    if (!Stream) Stream = __webpack_require__(9).EventEmitter;
	  }
	})();
	/*</replacement>*/

	var Buffer = __webpack_require__(6).Buffer;
	/*<replacement>*/
	var bufferShim = __webpack_require__(10);
	/*</replacement>*/

	util.inherits(Writable, Stream);

	function nop() {}

	function WriteReq(chunk, encoding, cb) {
	  this.chunk = chunk;
	  this.encoding = encoding;
	  this.callback = cb;
	  this.next = null;
	}

	function WritableState(options, stream) {
	  Duplex = Duplex || __webpack_require__(4);

	  options = options || {};

	  // object stream flag to indicate whether or not this stream
	  // contains buffers or objects.
	  this.objectMode = !!options.objectMode;

	  if (stream instanceof Duplex) this.objectMode = this.objectMode || !!options.writableObjectMode;

	  // the point at which write() starts returning false
	  // Note: 0 is a valid value, means that we always return false if
	  // the entire buffer is not flushed immediately on write()
	  var hwm = options.highWaterMark;
	  var defaultHwm = this.objectMode ? 16 : 16 * 1024;
	  this.highWaterMark = hwm || hwm === 0 ? hwm : defaultHwm;

	  // cast to ints.
	  this.highWaterMark = ~ ~this.highWaterMark;

	  // drain event flag.
	  this.needDrain = false;
	  // at the start of calling end()
	  this.ending = false;
	  // when end() has been called, and returned
	  this.ended = false;
	  // when 'finish' is emitted
	  this.finished = false;

	  // should we decode strings into buffers before passing to _write?
	  // this is here so that some node-core streams can optimize string
	  // handling at a lower level.
	  var noDecode = options.decodeStrings === false;
	  this.decodeStrings = !noDecode;

	  // Crypto is kind of old and crusty.  Historically, its default string
	  // encoding is 'binary' so we have to make this configurable.
	  // Everything else in the universe uses 'utf8', though.
	  this.defaultEncoding = options.defaultEncoding || 'utf8';

	  // not an actual buffer we keep track of, but a measurement
	  // of how much we're waiting to get pushed to some underlying
	  // socket or file.
	  this.length = 0;

	  // a flag to see when we're in the middle of a write.
	  this.writing = false;

	  // when true all writes will be buffered until .uncork() call
	  this.corked = 0;

	  // a flag to be able to tell if the onwrite cb is called immediately,
	  // or on a later tick.  We set this to true at first, because any
	  // actions that shouldn't happen until "later" should generally also
	  // not happen before the first write call.
	  this.sync = true;

	  // a flag to know if we're processing previously buffered items, which
	  // may call the _write() callback in the same tick, so that we don't
	  // end up in an overlapped onwrite situation.
	  this.bufferProcessing = false;

	  // the callback that's passed to _write(chunk,cb)
	  this.onwrite = function (er) {
	    onwrite(stream, er);
	  };

	  // the callback that the user supplies to write(chunk,encoding,cb)
	  this.writecb = null;

	  // the amount that is being written when _write is called.
	  this.writelen = 0;

	  this.bufferedRequest = null;
	  this.lastBufferedRequest = null;

	  // number of pending user-supplied write callbacks
	  // this must be 0 before 'finish' can be emitted
	  this.pendingcb = 0;

	  // emit prefinish if the only thing we're waiting for is _write cbs
	  // This is relevant for synchronous Transform streams
	  this.prefinished = false;

	  // True if the error was already emitted and should not be thrown again
	  this.errorEmitted = false;

	  // count buffered requests
	  this.bufferedRequestCount = 0;

	  // allocate the first CorkedRequest, there is always
	  // one allocated and free to use, and we maintain at most two
	  this.corkedRequestsFree = new CorkedRequest(this);
	}

	WritableState.prototype.getBuffer = function getBuffer() {
	  var current = this.bufferedRequest;
	  var out = [];
	  while (current) {
	    out.push(current);
	    current = current.next;
	  }
	  return out;
	};

	(function () {
	  try {
	    Object.defineProperty(WritableState.prototype, 'buffer', {
	      get: internalUtil.deprecate(function () {
	        return this.getBuffer();
	      }, '_writableState.buffer is deprecated. Use _writableState.getBuffer ' + 'instead.')
	    });
	  } catch (_) {}
	})();

	// Test _writableState for inheritance to account for Duplex streams,
	// whose prototype chain only points to Readable.
	var realHasInstance;
	if (typeof Symbol === 'function' && Symbol.hasInstance && typeof Function.prototype[Symbol.hasInstance] === 'function') {
	  realHasInstance = Function.prototype[Symbol.hasInstance];
	  Object.defineProperty(Writable, Symbol.hasInstance, {
	    value: function (object) {
	      if (realHasInstance.call(this, object)) return true;

	      return object && object._writableState instanceof WritableState;
	    }
	  });
	} else {
	  realHasInstance = function (object) {
	    return object instanceof this;
	  };
	}

	function Writable(options) {
	  Duplex = Duplex || __webpack_require__(4);

	  // Writable ctor is applied to Duplexes, too.
	  // `realHasInstance` is necessary because using plain `instanceof`
	  // would return false, as no `_writableState` property is attached.

	  // Trying to use the custom `instanceof` for Writable here will also break the
	  // Node.js LazyTransform implementation, which has a non-trivial getter for
	  // `_writableState` that would lead to infinite recursion.
	  if (!realHasInstance.call(Writable, this) && !(this instanceof Duplex)) {
	    return new Writable(options);
	  }

	  this._writableState = new WritableState(options, this);

	  // legacy.
	  this.writable = true;

	  if (options) {
	    if (typeof options.write === 'function') this._write = options.write;

	    if (typeof options.writev === 'function') this._writev = options.writev;
	  }

	  Stream.call(this);
	}

	// Otherwise people can pipe Writable streams, which is just wrong.
	Writable.prototype.pipe = function () {
	  this.emit('error', new Error('Cannot pipe, not readable'));
	};

	function writeAfterEnd(stream, cb) {
	  var er = new Error('write after end');
	  // TODO: defer error events consistently everywhere, not just the cb
	  stream.emit('error', er);
	  processNextTick(cb, er);
	}

	// If we get something that is not a buffer, string, null, or undefined,
	// and we're not in objectMode, then that's an error.
	// Otherwise stream chunks are all considered to be of length=1, and the
	// watermarks determine how many objects to keep in the buffer, rather than
	// how many bytes or characters.
	function validChunk(stream, state, chunk, cb) {
	  var valid = true;
	  var er = false;
	  // Always throw error if a null is written
	  // if we are not in object mode then throw
	  // if it is not a buffer, string, or undefined.
	  if (chunk === null) {
	    er = new TypeError('May not write null values to stream');
	  } else if (!Buffer.isBuffer(chunk) && typeof chunk !== 'string' && chunk !== undefined && !state.objectMode) {
	    er = new TypeError('Invalid non-string/buffer chunk');
	  }
	  if (er) {
	    stream.emit('error', er);
	    processNextTick(cb, er);
	    valid = false;
	  }
	  return valid;
	}

	Writable.prototype.write = function (chunk, encoding, cb) {
	  var state = this._writableState;
	  var ret = false;

	  if (typeof encoding === 'function') {
	    cb = encoding;
	    encoding = null;
	  }

	  if (Buffer.isBuffer(chunk)) encoding = 'buffer';else if (!encoding) encoding = state.defaultEncoding;

	  if (typeof cb !== 'function') cb = nop;

	  if (state.ended) writeAfterEnd(this, cb);else if (validChunk(this, state, chunk, cb)) {
	    state.pendingcb++;
	    ret = writeOrBuffer(this, state, chunk, encoding, cb);
	  }

	  return ret;
	};

	Writable.prototype.cork = function () {
	  var state = this._writableState;

	  state.corked++;
	};

	Writable.prototype.uncork = function () {
	  var state = this._writableState;

	  if (state.corked) {
	    state.corked--;

	    if (!state.writing && !state.corked && !state.finished && !state.bufferProcessing && state.bufferedRequest) clearBuffer(this, state);
	  }
	};

	Writable.prototype.setDefaultEncoding = function setDefaultEncoding(encoding) {
	  // node::ParseEncoding() requires lower case.
	  if (typeof encoding === 'string') encoding = encoding.toLowerCase();
	  if (!(['hex', 'utf8', 'utf-8', 'ascii', 'binary', 'base64', 'ucs2', 'ucs-2', 'utf16le', 'utf-16le', 'raw'].indexOf((encoding + '').toLowerCase()) > -1)) throw new TypeError('Unknown encoding: ' + encoding);
	  this._writableState.defaultEncoding = encoding;
	  return this;
	};

	function decodeChunk(state, chunk, encoding) {
	  if (!state.objectMode && state.decodeStrings !== false && typeof chunk === 'string') {
	    chunk = bufferShim.from(chunk, encoding);
	  }
	  return chunk;
	}

	// if we're already writing something, then just put this
	// in the queue, and wait our turn.  Otherwise, call _write
	// If we return false, then we need a drain event, so set that flag.
	function writeOrBuffer(stream, state, chunk, encoding, cb) {
	  chunk = decodeChunk(state, chunk, encoding);

	  if (Buffer.isBuffer(chunk)) encoding = 'buffer';
	  var len = state.objectMode ? 1 : chunk.length;

	  state.length += len;

	  var ret = state.length < state.highWaterMark;
	  // we must ensure that previous needDrain will not be reset to false.
	  if (!ret) state.needDrain = true;

	  if (state.writing || state.corked) {
	    var last = state.lastBufferedRequest;
	    state.lastBufferedRequest = new WriteReq(chunk, encoding, cb);
	    if (last) {
	      last.next = state.lastBufferedRequest;
	    } else {
	      state.bufferedRequest = state.lastBufferedRequest;
	    }
	    state.bufferedRequestCount += 1;
	  } else {
	    doWrite(stream, state, false, len, chunk, encoding, cb);
	  }

	  return ret;
	}

	function doWrite(stream, state, writev, len, chunk, encoding, cb) {
	  state.writelen = len;
	  state.writecb = cb;
	  state.writing = true;
	  state.sync = true;
	  if (writev) stream._writev(chunk, state.onwrite);else stream._write(chunk, encoding, state.onwrite);
	  state.sync = false;
	}

	function onwriteError(stream, state, sync, er, cb) {
	  --state.pendingcb;
	  if (sync) processNextTick(cb, er);else cb(er);

	  stream._writableState.errorEmitted = true;
	  stream.emit('error', er);
	}

	function onwriteStateUpdate(state) {
	  state.writing = false;
	  state.writecb = null;
	  state.length -= state.writelen;
	  state.writelen = 0;
	}

	function onwrite(stream, er) {
	  var state = stream._writableState;
	  var sync = state.sync;
	  var cb = state.writecb;

	  onwriteStateUpdate(state);

	  if (er) onwriteError(stream, state, sync, er, cb);else {
	    // Check if we're actually ready to finish, but don't emit yet
	    var finished = needFinish(state);

	    if (!finished && !state.corked && !state.bufferProcessing && state.bufferedRequest) {
	      clearBuffer(stream, state);
	    }

	    if (sync) {
	      /*<replacement>*/
	      asyncWrite(afterWrite, stream, state, finished, cb);
	      /*</replacement>*/
	    } else {
	        afterWrite(stream, state, finished, cb);
	      }
	  }
	}

	function afterWrite(stream, state, finished, cb) {
	  if (!finished) onwriteDrain(stream, state);
	  state.pendingcb--;
	  cb();
	  finishMaybe(stream, state);
	}

	// Must force callback to be called on nextTick, so that we don't
	// emit 'drain' before the write() consumer gets the 'false' return
	// value, and has a chance to attach a 'drain' listener.
	function onwriteDrain(stream, state) {
	  if (state.length === 0 && state.needDrain) {
	    state.needDrain = false;
	    stream.emit('drain');
	  }
	}

	// if there's something in the buffer waiting, then process it
	function clearBuffer(stream, state) {
	  state.bufferProcessing = true;
	  var entry = state.bufferedRequest;

	  if (stream._writev && entry && entry.next) {
	    // Fast case, write everything using _writev()
	    var l = state.bufferedRequestCount;
	    var buffer = new Array(l);
	    var holder = state.corkedRequestsFree;
	    holder.entry = entry;

	    var count = 0;
	    while (entry) {
	      buffer[count] = entry;
	      entry = entry.next;
	      count += 1;
	    }

	    doWrite(stream, state, true, state.length, buffer, '', holder.finish);

	    // doWrite is almost always async, defer these to save a bit of time
	    // as the hot path ends with doWrite
	    state.pendingcb++;
	    state.lastBufferedRequest = null;
	    if (holder.next) {
	      state.corkedRequestsFree = holder.next;
	      holder.next = null;
	    } else {
	      state.corkedRequestsFree = new CorkedRequest(state);
	    }
	  } else {
	    // Slow case, write chunks one-by-one
	    while (entry) {
	      var chunk = entry.chunk;
	      var encoding = entry.encoding;
	      var cb = entry.callback;
	      var len = state.objectMode ? 1 : chunk.length;

	      doWrite(stream, state, false, len, chunk, encoding, cb);
	      entry = entry.next;
	      // if we didn't call the onwrite immediately, then
	      // it means that we need to wait until it does.
	      // also, that means that the chunk and cb are currently
	      // being processed, so move the buffer counter past them.
	      if (state.writing) {
	        break;
	      }
	    }

	    if (entry === null) state.lastBufferedRequest = null;
	  }

	  state.bufferedRequestCount = 0;
	  state.bufferedRequest = entry;
	  state.bufferProcessing = false;
	}

	Writable.prototype._write = function (chunk, encoding, cb) {
	  cb(new Error('_write() is not implemented'));
	};

	Writable.prototype._writev = null;

	Writable.prototype.end = function (chunk, encoding, cb) {
	  var state = this._writableState;

	  if (typeof chunk === 'function') {
	    cb = chunk;
	    chunk = null;
	    encoding = null;
	  } else if (typeof encoding === 'function') {
	    cb = encoding;
	    encoding = null;
	  }

	  if (chunk !== null && chunk !== undefined) this.write(chunk, encoding);

	  // .end() fully uncorks
	  if (state.corked) {
	    state.corked = 1;
	    this.uncork();
	  }

	  // ignore unnecessary end() calls.
	  if (!state.ending && !state.finished) endWritable(this, state, cb);
	};

	function needFinish(state) {
	  return state.ending && state.length === 0 && state.bufferedRequest === null && !state.finished && !state.writing;
	}

	function prefinish(stream, state) {
	  if (!state.prefinished) {
	    state.prefinished = true;
	    stream.emit('prefinish');
	  }
	}

	function finishMaybe(stream, state) {
	  var need = needFinish(state);
	  if (need) {
	    if (state.pendingcb === 0) {
	      prefinish(stream, state);
	      state.finished = true;
	      stream.emit('finish');
	    } else {
	      prefinish(stream, state);
	    }
	  }
	  return need;
	}

	function endWritable(stream, state, cb) {
	  state.ending = true;
	  finishMaybe(stream, state);
	  if (cb) {
	    if (state.finished) processNextTick(cb);else stream.once('finish', cb);
	  }
	  state.ended = true;
	  stream.writable = false;
	}

	// It seems a linked list but it is not
	// there will be only 2 of these for each stream
	function CorkedRequest(state) {
	  var _this = this;

	  this.next = null;
	  this.entry = null;

	  this.finish = function (err) {
	    var entry = _this.entry;
	    _this.entry = null;
	    while (entry) {
	      var cb = entry.callback;
	      state.pendingcb--;
	      cb(err);
	      entry = entry.next;
	    }
	    if (state.corkedRequestsFree) {
	      state.corkedRequestsFree.next = _this;
	    } else {
	      state.corkedRequestsFree = _this;
	    }
	  };
	}
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(3), __webpack_require__(57).setImmediate))

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var Stream = (function (){
	  try {
	    return __webpack_require__(16); // hack to fix a circular dependency issue when used with browserify
	  } catch(_){}
	}());
	exports = module.exports = __webpack_require__(22);
	exports.Stream = Stream || exports;
	exports.Readable = exports;
	exports.Writable = __webpack_require__(14);
	exports.Duplex = __webpack_require__(4);
	exports.Transform = __webpack_require__(13);
	exports.PassThrough = __webpack_require__(21);

	if (!process.browser && process.env.READABLE_STREAM === 'disable' && Stream) {
	  module.exports = Stream;
	}

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(3)))

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	module.exports = Stream;

	var EE = __webpack_require__(9).EventEmitter;
	var inherits = __webpack_require__(2);

	inherits(Stream, EE);
	Stream.Readable = __webpack_require__(15);
	Stream.Writable = __webpack_require__(53);
	Stream.Duplex = __webpack_require__(48);
	Stream.Transform = __webpack_require__(52);
	Stream.PassThrough = __webpack_require__(51);

	// Backwards-compat with node 0.4.x
	Stream.Stream = Stream;



	// old-style streams.  Note that the pipe method (the only relevant
	// part of this class) is overridden in the Readable class.

	function Stream() {
	  EE.call(this);
	}

	Stream.prototype.pipe = function(dest, options) {
	  var source = this;

	  function ondata(chunk) {
	    if (dest.writable) {
	      if (false === dest.write(chunk) && source.pause) {
	        source.pause();
	      }
	    }
	  }

	  source.on('data', ondata);

	  function ondrain() {
	    if (source.readable && source.resume) {
	      source.resume();
	    }
	  }

	  dest.on('drain', ondrain);

	  // If the 'end' option is not supplied, dest.end() will be called when
	  // source gets the 'end' or 'close' events.  Only dest.end() once.
	  if (!dest._isStdio && (!options || options.end !== false)) {
	    source.on('end', onend);
	    source.on('close', onclose);
	  }

	  var didOnEnd = false;
	  function onend() {
	    if (didOnEnd) return;
	    didOnEnd = true;

	    dest.end();
	  }


	  function onclose() {
	    if (didOnEnd) return;
	    didOnEnd = true;

	    if (typeof dest.destroy === 'function') dest.destroy();
	  }

	  // don't leave dangling pipes when there are errors.
	  function onerror(er) {
	    cleanup();
	    if (EE.listenerCount(this, 'error') === 0) {
	      throw er; // Unhandled stream error in pipe.
	    }
	  }

	  source.on('error', onerror);
	  dest.on('error', onerror);

	  // remove all the event listeners that were added.
	  function cleanup() {
	    source.removeListener('data', ondata);
	    dest.removeListener('drain', ondrain);

	    source.removeListener('end', onend);
	    source.removeListener('close', onclose);

	    source.removeListener('error', onerror);
	    dest.removeListener('error', onerror);

	    source.removeListener('end', cleanup);
	    source.removeListener('close', cleanup);

	    dest.removeListener('close', cleanup);
	  }

	  source.on('end', cleanup);
	  source.on('close', cleanup);

	  dest.on('close', cleanup);

	  dest.emit('pipe', source);

	  // Allow for unix-like usage: A.pipe(B).pipe(C)
	  return dest;
	};


/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {var ClientRequest = __webpack_require__(55)
	var extend = __webpack_require__(63)
	var statusCodes = __webpack_require__(34)
	var url = __webpack_require__(25)

	var http = exports

	http.request = function (opts, cb) {
		if (typeof opts === 'string')
			opts = url.parse(opts)
		else
			opts = extend(opts)

		// Normally, the page is loaded from http or https, so not specifying a protocol
		// will result in a (valid) protocol-relative url. However, this won't work if
		// the protocol is something else, like 'file:'
		var defaultProtocol = global.location.protocol.search(/^https?:$/) === -1 ? 'http:' : ''

		var protocol = opts.protocol || defaultProtocol
		var host = opts.hostname || opts.host
		var port = opts.port
		var path = opts.path || '/'

		// Necessary for IPv6 addresses
		if (host && host.indexOf(':') !== -1)
			host = '[' + host + ']'

		// This may be a relative url. The browser should always be able to interpret it correctly.
		opts.url = (host ? (protocol + '//' + host) : '') + (port ? ':' + port : '') + path
		opts.method = (opts.method || 'GET').toUpperCase()
		opts.headers = opts.headers || {}

		// Also valid opts.auth, opts.mode

		var req = new ClientRequest(opts)
		if (cb)
			req.on('response', cb)
		return req
	}

	http.get = function get (opts, cb) {
		var req = http.request(opts, cb)
		req.end()
		return req
	}

	http.Agent = function () {}
	http.Agent.defaultMaxSockets = 4

	http.STATUS_CODES = statusCodes

	http.METHODS = [
		'CHECKOUT',
		'CONNECT',
		'COPY',
		'DELETE',
		'GET',
		'HEAD',
		'LOCK',
		'M-SEARCH',
		'MERGE',
		'MKACTIVITY',
		'MKCOL',
		'MOVE',
		'NOTIFY',
		'OPTIONS',
		'PATCH',
		'POST',
		'PROPFIND',
		'PROPPATCH',
		'PURGE',
		'PUT',
		'REPORT',
		'SEARCH',
		'SUBSCRIBE',
		'TRACE',
		'UNLOCK',
		'UNSUBSCRIBE'
	]
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 18 */
/***/ function(module, exports) {

	module.exports = {
		"name": "prismic.io",
		"description": "JavaScript development kit for prismic.io",
		"license": "Apache-2.0",
		"url": "https://github.com/prismicio/javascript-kit",
		"keywords": [
			"prismic",
			"prismic.io",
			"cms",
			"content",
			"api"
		],
		"version": "3.3.1",
		"devDependencies": {
			"babel-preset-es2015": "^6.3.13",
			"babelify": "^7.2.0",
			"browserify": "^12.0.1",
			"chai": "*",
			"codeclimate-test-reporter": "0.0.4",
			"es6-promise": "^3.2.1",
			"eslint": "^2.12.0",
			"istanbul": "^0.4.4",
			"jsdoc": "^3.4.0",
			"mocha": "*",
			"rimraf": "^2.5.4",
			"uglify-js": "^2.6.1",
			"vinyl-buffer": "^1.0.0",
			"vinyl-source-stream": "^1.1.0"
		},
		"repository": {
			"type": "git",
			"url": "http://github.com/prismicio/javascript-kit.git"
		},
		"main": "lib/prismic.js",
		"scripts": {
			"build": "scripts/browser.js",
			"postbuild": "npm run docs",
			"uglify": "uglifyjs -c -o=dist/prismic.io.min.js dist/prismic.io.js",
			"preuglify": "npm run build",
			"prepublish": "npm run uglify",
			"lint": "eslint lib",
			"test": "istanbul cover _mocha test/",
			"posttest": "eslint lib",
			"predocs": "rimraf ./docs",
			"docs": "jsdoc dist/prismic.io.js README.md -d docs"
		}
	};

/***/ },
/* 19 */
/***/ function(module, exports) {

	
	"use strict";

	/**
	 * A collection of experiments currently available
	 * @param data the json data received from the Prismic API
	 * @constructor
	 */
	function Experiments(data) {
	  var drafts = [];
	  var running = [];
	  if (data) {
	    data.drafts && data.drafts.forEach(function (exp) {
	      drafts.push(new Experiment(exp));
	    });
	    data.running && data.running.forEach(function (exp) {
	      running.push(new Experiment(exp));
	    });
	  }
	  this.drafts = drafts;
	  this.running = running;
	}

	Experiments.prototype.current = function() {
	  return this.running.length > 0 ? this.running[0] : null;
	};

	/**
	 * Get the current running experiment variation ref from a cookie content
	 */
	Experiments.prototype.refFromCookie = function(cookie) {
	  if (!cookie || cookie.trim() === "") return null;
	  var splitted = cookie.trim().split(" ");
	  if (splitted.length < 2) return null;
	  var expId = splitted[0];
	  var varIndex = parseInt(splitted[1], 10);
	  var exp = this.running.filter(function(exp) {
	    return exp.googleId() == expId && exp.variations.length > varIndex;
	  })[0];
	  return exp ? exp.variations[varIndex].ref() : null;
	};

	function Experiment(data) {
	  this.data = data;
	  var variations = [];
	  data.variations && data.variations.forEach(function(v) {
	    variations.push(new Variation(v));
	  });
	  this.variations = variations;
	}

	Experiment.prototype.id = function() {
	  return this.data.id;
	};

	Experiment.prototype.googleId = function() {
	  return this.data.googleId;
	};

	Experiment.prototype.name = function() {
	  return this.data.name;
	};

	function Variation(data) {
	  this.data = data;
	}

	Variation.prototype.id = function() {
	  return this.data.id;
	};

	Variation.prototype.ref = function() {
	  return this.data.ref;
	};

	Variation.prototype.label = function() {
	  return this.data.label;
	};

	module.exports = {
	  Experiments: Experiments,
	  Variation: Variation
	};


/***/ },
/* 20 */
/***/ function(module, exports) {

	"use strict";

	function stripQuotes(s) {
	  return s.replace(/"/g, "");
	}

	function toQueryValue(value) {
	  if (typeof value === 'string') {
	    return '"' + stripQuotes(value) + '"';
	  } else if (value instanceof Date) {
	    return value.getTime();
	  } else if (Array.isArray(value)) {
	    return "[" + value.map(function (item) {
	      return toQueryValue(item);
	    }).join(',') + "]";
	  }
	  return value;
	}

	/**
	 * @global
	 * @namespace
	 * @alias Predicates
	 */
	module.exports = {

	  /**
	   * Convert a predicate (array of 3 elements) into a query for prismic.io (string)
	   */
	  toQuery: function (predicate) {
	    var operator = stripQuotes(predicate[0]);
	    var path = stripQuotes(predicate[1]);
	    var pathArg = (path.indexOf("my.") === 0 || path.indexOf("document") === 0) ? path : '"' + path + '"';
	    var values = predicate.slice(2).map(toQueryValue).join(',');
	    return "[:d = " + operator + "(" + pathArg + (predicate.length > 2 ? ", " : "") + values + ")]";
	  },

	  /**
	   * Build an "at" predicate: equality of a fragment to a value.
	   *
	   * @example Predicates.at("document.type", "article")
	   * @param fragment {String}
	   * @param value {String}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  at: function(fragment, value) { return ["at", fragment, value]; },

	  /**
	   * Build an "not" predicate: inequality of a fragment to a value.
	   *
	   * @example Predicates.not("document.type", "article")
	   * @param fragment {String}
	   * @param value {String}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  not: function(fragment, value) { return ["not", fragment, value]; },

	  /**
	   * Build a "missing" predicate: documents where the requested field is empty
	   *
	   * @example Predicates.missing("my.blog-post.author")
	   * @param fragment {String}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  missing: function(fragment) { return ["missing", fragment]; },

	  /**
	   * Build a "has" predicate: documents where the requested field is defined
	   *
	   * @example Predicates.has("my.blog-post.author")
	   * @param fragment {String}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  has: function(fragment) { return ["has", fragment]; },

	  /**
	   * Build an "any" predicate: equality of a fragment to a value.
	   *
	   * @example Predicates.any("document.type", ["article", "blog-post"])
	   * @param fragment {String}
	   * @param values {Array}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  any: function(fragment, values) { return ["any", fragment, values]; },

	  /**
	   * Build an "in" predicate: equality of a fragment to a value.
	   *
	   * @example Predicates.in("my.product.price", [4, 5])
	   * @param fragment {String}
	   * @param values {Array}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  in: function(fragment, values) { return ["in", fragment, values]; },

	  /**
	   * Build a "fulltext" predicate: fulltext search in a fragment.
	   *
	   * @example Predicates.fulltext("my.article.body", "sausage"])
	   * @param fragment {String}
	   * @param value {String} the term to search
	   * @returns {Array} an array corresponding to the predicate
	   */
	  fulltext: function(fragment, value) { return ["fulltext", fragment, value]; },

	  /**
	   * Build a "similar" predicate.
	   *
	   * @example Predicates.similar("UXasdFwe42D", 10)
	   * @param documentId {String} the document id to retrieve similar documents to.
	   * @param maxResults {Number} the maximum number of results to return
	   * @returns {Array} an array corresponding to the predicate
	   */
	  similar: function(documentId, maxResults) { return ["similar", documentId, maxResults]; },

	  /**
	   * Build a "number.gt" predicate: documents where the fragment field is greater than the given value.
	   *
	   * @example Predicates.gt("my.product.price", 10)
	   * @param fragment {String} the name of the field - must be a number.
	   * @param value {Number} the lower bound of the predicate
	   * @returns {Array} an array corresponding to the predicate
	   */
	  gt: function(fragment, value) { return ["number.gt", fragment, value]; },

	  /**
	   * Build a "number.lt" predicate: documents where the fragment field is lower than the given value.
	   *
	   * @example Predicates.lt("my.product.price", 20)
	   * @param fragment {String} the name of the field - must be a number.
	   * @param value {Number} the upper bound of the predicate
	   * @returns {Array} an array corresponding to the predicate
	   */
	  lt: function(fragment, value) { return ["number.lt", fragment, value]; },

	  /**
	   * Build a "number.inRange" predicate: combination of lt and gt.
	   *
	   * @example Predicates.inRange("my.product.price", 10, 20)
	   * @param fragment {String} the name of the field - must be a number.
	   * @param before {Number}
	   * @param after {Number}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  inRange: function(fragment, before, after) { return ["number.inRange", fragment, before, after]; },

	  /**
	   * Build a "date.before" predicate: documents where the fragment field is before the given date.
	   *
	   * @example Predicates.dateBefore("my.product.releaseDate", new Date(2014, 6, 1))
	   * @param fragment {String} the name of the field - must be a date or timestamp field.
	   * @param before {Date}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  dateBefore: function(fragment, before) { return ["date.before", fragment, before]; },

	  /**
	   * Build a "date.after" predicate: documents where the fragment field is after the given date.
	   *
	   * @example Predicates.dateAfter("my.product.releaseDate", new Date(2014, 1, 1))
	   * @param fragment {String} the name of the field - must be a date or timestamp field.
	   * @param after {Date}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  dateAfter: function(fragment, after) { return ["date.after", fragment, after]; },

	  /**
	   * Build a "date.between" predicate: combination of dateBefore and dateAfter
	   *
	   * @example Predicates.dateBetween("my.product.releaseDate", new Date(2014, 1, 1), new Date(2014, 6, 1))
	   * @param fragment {String} the name of the field - must be a date or timestamp field.
	   * @param before {Date}
	   * @param after {Date}
	   * @returns {Array} an array corresponding to the predicate
	   */
	  dateBetween: function(fragment, before, after) { return ["date.between", fragment, before, after]; },

	  /**
	   *
	   * @example Predicates.dayOfMonth("my.product.releaseDate", 14)
	   * @param fragment
	   * @param day {Number} between 1 and 31
	   * @returns {Array}
	   */
	  dayOfMonth: function(fragment, day) { return ["date.day-of-month", fragment, day]; },

	  /**
	   *
	   * @example Predicates.dayOfMonthAfter("my.product.releaseDate", 14)
	   * @param fragment
	   * @param day {Number} between 1 and 31
	   * @returns {Array}
	   */
	  dayOfMonthAfter: function(fragment, day) { return ["date.day-of-month-after", fragment, day]; },

	  /**
	   *
	   * @example Predicates.dayOfMonthBefore("my.product.releaseDate", 14)
	   * @param fragment
	   * @param day {Number} between 1 and 31
	   * @returns {Array}
	   */
	  dayOfMonthBefore: function(fragment, day) { return ["date.day-of-month-before", fragment, day]; },

	  /**
	   *
	   * @example Predicates.dayOfWeek("my.product.releaseDate", 14)
	   * @param fragment
	   * @param day {Number|String} Number between 1 and 7 or string between "Monday" and "Sunday"
	   * @returns {Array}
	   */
	  dayOfWeek: function(fragment, day) { return ["date.day-of-week", fragment, day]; },

	  /**
	   *
	   * @example Predicates.dayOfWeekAfter("my.product.releaseDate", "Wednesday")
	   * @param fragment
	   * @param day {Number|String} Number between 1 and 7 or string between "Monday" and "Sunday"
	   * @returns {Array}
	   */
	  dayOfWeekAfter: function(fragment, day) { return ["date.day-of-week-after", fragment, day]; },

	  /**
	   *
	   * @example Predicates.dayOfWeekBefore("my.product.releaseDate", "Wednesday")
	   * @param fragment
	   * @param day {Number|String} Number between 1 and 7 or string between "Monday" and "Sunday"
	   * @returns {Array}
	   */
	  dayOfWeekBefore: function(fragment, day) { return ["date.day-of-week-before", fragment, day]; },

	  /**
	   *
	   * @example Predicates.month("my.product.releaseDate", "June")
	   * @param fragment
	   * @param month {Number|String} Number between 1 and 12 or string between "January" and "December"
	   * @returns {Array}
	   */
	  month: function(fragment, month) { return ["date.month", fragment, month]; },

	  /**
	   *
	   * @example Predicates.monthBefore("my.product.releaseDate", "June")
	   * @param fragment
	   * @param month {Number|String} Number between 1 and 12 or string between "January" and "December"
	   * @returns {Array}
	   */
	  monthBefore: function(fragment, month) { return ["date.month-before", fragment, month]; },

	  /**
	   *
	   * @example Predicates.monthAfter("my.product.releaseDate", "June")
	   * @param fragment
	   * @param month {Number|String} Number between 1 and 12 or string between "January" and "December"
	   * @returns {Array}
	   * @returns {Array}
	   */
	  monthAfter: function(fragment, month) { return ["date.month-after", fragment, month]; },

	  /**
	   *
	   * @example Predicates.year("my.product.releaseDate", 2014)
	   * @param fragment
	   * @param year {Number}
	   * @returns {Array}
	   */
	  year: function(fragment, year) { return ["date.year", fragment, year]; },

	  /**
	   *
	   * @example Predicates.hour("my.product.releaseDate", 12)
	   * @param fragment
	   * @param hour {Number}
	   * @returns {Array}
	   */
	  hour: function(fragment, hour) { return ["date.hour", fragment, hour]; },

	  /**
	   *
	   * @example Predicates.hourBefore("my.product.releaseDate", 12)
	   * @param fragment
	   * @param hour {Number}
	   * @returns {Array}
	   */
	  hourBefore: function(fragment, hour) { return ["date.hour-before", fragment, hour]; },

	  /**
	   *
	   * @example Predicates.hourAfter("my.product.releaseDate", 12)
	   * @param fragment
	   * @param hour {Number}
	   * @returns {Array}
	   */
	  hourAfter: function(fragment, hour) { return ["date.hour-after", fragment, hour]; },

	  /**
	   *
	   * @example Predicates.near("my.store.location", 48.8768767, 2.3338802, 10)
	   * @param fragment
	   * @param latitude {Number}
	   * @param longitude {Number}
	   * @param radius {Number} in kilometers
	   * @returns {Array}
	   */
	  near: function(fragment, latitude, longitude, radius) { return ["geopoint.near", fragment, latitude, longitude, radius]; }

	};


/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	// a passthrough stream.
	// basically just the most minimal sort of Transform stream.
	// Every written chunk gets output as-is.

	'use strict';

	module.exports = PassThrough;

	var Transform = __webpack_require__(13);

	/*<replacement>*/
	var util = __webpack_require__(8);
	util.inherits = __webpack_require__(2);
	/*</replacement>*/

	util.inherits(PassThrough, Transform);

	function PassThrough(options) {
	  if (!(this instanceof PassThrough)) return new PassThrough(options);

	  Transform.call(this, options);
	}

	PassThrough.prototype._transform = function (chunk, encoding, cb) {
	  cb(null, chunk);
	};

/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {'use strict';

	module.exports = Readable;

	/*<replacement>*/
	var processNextTick = __webpack_require__(12);
	/*</replacement>*/

	/*<replacement>*/
	var isArray = __webpack_require__(50);
	/*</replacement>*/

	/*<replacement>*/
	var Duplex;
	/*</replacement>*/

	Readable.ReadableState = ReadableState;

	/*<replacement>*/
	var EE = __webpack_require__(9).EventEmitter;

	var EElistenerCount = function (emitter, type) {
	  return emitter.listeners(type).length;
	};
	/*</replacement>*/

	/*<replacement>*/
	var Stream;
	(function () {
	  try {
	    Stream = __webpack_require__(16);
	  } catch (_) {} finally {
	    if (!Stream) Stream = __webpack_require__(9).EventEmitter;
	  }
	})();
	/*</replacement>*/

	var Buffer = __webpack_require__(6).Buffer;
	/*<replacement>*/
	var bufferShim = __webpack_require__(10);
	/*</replacement>*/

	/*<replacement>*/
	var util = __webpack_require__(8);
	util.inherits = __webpack_require__(2);
	/*</replacement>*/

	/*<replacement>*/
	var debugUtil = __webpack_require__(64);
	var debug = void 0;
	if (debugUtil && debugUtil.debuglog) {
	  debug = debugUtil.debuglog('stream');
	} else {
	  debug = function () {};
	}
	/*</replacement>*/

	var BufferList = __webpack_require__(49);
	var StringDecoder;

	util.inherits(Readable, Stream);

	function prependListener(emitter, event, fn) {
	  // Sadly this is not cacheable as some libraries bundle their own
	  // event emitter implementation with them.
	  if (typeof emitter.prependListener === 'function') {
	    return emitter.prependListener(event, fn);
	  } else {
	    // This is a hack to make sure that our error handler is attached before any
	    // userland ones.  NEVER DO THIS. This is here only because this code needs
	    // to continue to work with older versions of Node.js that do not include
	    // the prependListener() method. The goal is to eventually remove this hack.
	    if (!emitter._events || !emitter._events[event]) emitter.on(event, fn);else if (isArray(emitter._events[event])) emitter._events[event].unshift(fn);else emitter._events[event] = [fn, emitter._events[event]];
	  }
	}

	function ReadableState(options, stream) {
	  Duplex = Duplex || __webpack_require__(4);

	  options = options || {};

	  // object stream flag. Used to make read(n) ignore n and to
	  // make all the buffer merging and length checks go away
	  this.objectMode = !!options.objectMode;

	  if (stream instanceof Duplex) this.objectMode = this.objectMode || !!options.readableObjectMode;

	  // the point at which it stops calling _read() to fill the buffer
	  // Note: 0 is a valid value, means "don't call _read preemptively ever"
	  var hwm = options.highWaterMark;
	  var defaultHwm = this.objectMode ? 16 : 16 * 1024;
	  this.highWaterMark = hwm || hwm === 0 ? hwm : defaultHwm;

	  // cast to ints.
	  this.highWaterMark = ~ ~this.highWaterMark;

	  // A linked list is used to store data chunks instead of an array because the
	  // linked list can remove elements from the beginning faster than
	  // array.shift()
	  this.buffer = new BufferList();
	  this.length = 0;
	  this.pipes = null;
	  this.pipesCount = 0;
	  this.flowing = null;
	  this.ended = false;
	  this.endEmitted = false;
	  this.reading = false;

	  // a flag to be able to tell if the onwrite cb is called immediately,
	  // or on a later tick.  We set this to true at first, because any
	  // actions that shouldn't happen until "later" should generally also
	  // not happen before the first write call.
	  this.sync = true;

	  // whenever we return null, then we set a flag to say
	  // that we're awaiting a 'readable' event emission.
	  this.needReadable = false;
	  this.emittedReadable = false;
	  this.readableListening = false;
	  this.resumeScheduled = false;

	  // Crypto is kind of old and crusty.  Historically, its default string
	  // encoding is 'binary' so we have to make this configurable.
	  // Everything else in the universe uses 'utf8', though.
	  this.defaultEncoding = options.defaultEncoding || 'utf8';

	  // when piping, we only care about 'readable' events that happen
	  // after read()ing all the bytes and not getting any pushback.
	  this.ranOut = false;

	  // the number of writers that are awaiting a drain event in .pipe()s
	  this.awaitDrain = 0;

	  // if true, a maybeReadMore has been scheduled
	  this.readingMore = false;

	  this.decoder = null;
	  this.encoding = null;
	  if (options.encoding) {
	    if (!StringDecoder) StringDecoder = __webpack_require__(24).StringDecoder;
	    this.decoder = new StringDecoder(options.encoding);
	    this.encoding = options.encoding;
	  }
	}

	function Readable(options) {
	  Duplex = Duplex || __webpack_require__(4);

	  if (!(this instanceof Readable)) return new Readable(options);

	  this._readableState = new ReadableState(options, this);

	  // legacy
	  this.readable = true;

	  if (options && typeof options.read === 'function') this._read = options.read;

	  Stream.call(this);
	}

	// Manually shove something into the read() buffer.
	// This returns true if the highWaterMark has not been hit yet,
	// similar to how Writable.write() returns true if you should
	// write() some more.
	Readable.prototype.push = function (chunk, encoding) {
	  var state = this._readableState;

	  if (!state.objectMode && typeof chunk === 'string') {
	    encoding = encoding || state.defaultEncoding;
	    if (encoding !== state.encoding) {
	      chunk = bufferShim.from(chunk, encoding);
	      encoding = '';
	    }
	  }

	  return readableAddChunk(this, state, chunk, encoding, false);
	};

	// Unshift should *always* be something directly out of read()
	Readable.prototype.unshift = function (chunk) {
	  var state = this._readableState;
	  return readableAddChunk(this, state, chunk, '', true);
	};

	Readable.prototype.isPaused = function () {
	  return this._readableState.flowing === false;
	};

	function readableAddChunk(stream, state, chunk, encoding, addToFront) {
	  var er = chunkInvalid(state, chunk);
	  if (er) {
	    stream.emit('error', er);
	  } else if (chunk === null) {
	    state.reading = false;
	    onEofChunk(stream, state);
	  } else if (state.objectMode || chunk && chunk.length > 0) {
	    if (state.ended && !addToFront) {
	      var e = new Error('stream.push() after EOF');
	      stream.emit('error', e);
	    } else if (state.endEmitted && addToFront) {
	      var _e = new Error('stream.unshift() after end event');
	      stream.emit('error', _e);
	    } else {
	      var skipAdd;
	      if (state.decoder && !addToFront && !encoding) {
	        chunk = state.decoder.write(chunk);
	        skipAdd = !state.objectMode && chunk.length === 0;
	      }

	      if (!addToFront) state.reading = false;

	      // Don't add to the buffer if we've decoded to an empty string chunk and
	      // we're not in object mode
	      if (!skipAdd) {
	        // if we want the data now, just emit it.
	        if (state.flowing && state.length === 0 && !state.sync) {
	          stream.emit('data', chunk);
	          stream.read(0);
	        } else {
	          // update the buffer info.
	          state.length += state.objectMode ? 1 : chunk.length;
	          if (addToFront) state.buffer.unshift(chunk);else state.buffer.push(chunk);

	          if (state.needReadable) emitReadable(stream);
	        }
	      }

	      maybeReadMore(stream, state);
	    }
	  } else if (!addToFront) {
	    state.reading = false;
	  }

	  return needMoreData(state);
	}

	// if it's past the high water mark, we can push in some more.
	// Also, if we have no data yet, we can stand some
	// more bytes.  This is to work around cases where hwm=0,
	// such as the repl.  Also, if the push() triggered a
	// readable event, and the user called read(largeNumber) such that
	// needReadable was set, then we ought to push more, so that another
	// 'readable' event will be triggered.
	function needMoreData(state) {
	  return !state.ended && (state.needReadable || state.length < state.highWaterMark || state.length === 0);
	}

	// backwards compatibility.
	Readable.prototype.setEncoding = function (enc) {
	  if (!StringDecoder) StringDecoder = __webpack_require__(24).StringDecoder;
	  this._readableState.decoder = new StringDecoder(enc);
	  this._readableState.encoding = enc;
	  return this;
	};

	// Don't raise the hwm > 8MB
	var MAX_HWM = 0x800000;
	function computeNewHighWaterMark(n) {
	  if (n >= MAX_HWM) {
	    n = MAX_HWM;
	  } else {
	    // Get the next highest power of 2 to prevent increasing hwm excessively in
	    // tiny amounts
	    n--;
	    n |= n >>> 1;
	    n |= n >>> 2;
	    n |= n >>> 4;
	    n |= n >>> 8;
	    n |= n >>> 16;
	    n++;
	  }
	  return n;
	}

	// This function is designed to be inlinable, so please take care when making
	// changes to the function body.
	function howMuchToRead(n, state) {
	  if (n <= 0 || state.length === 0 && state.ended) return 0;
	  if (state.objectMode) return 1;
	  if (n !== n) {
	    // Only flow one buffer at a time
	    if (state.flowing && state.length) return state.buffer.head.data.length;else return state.length;
	  }
	  // If we're asking for more than the current hwm, then raise the hwm.
	  if (n > state.highWaterMark) state.highWaterMark = computeNewHighWaterMark(n);
	  if (n <= state.length) return n;
	  // Don't have enough
	  if (!state.ended) {
	    state.needReadable = true;
	    return 0;
	  }
	  return state.length;
	}

	// you can override either this method, or the async _read(n) below.
	Readable.prototype.read = function (n) {
	  debug('read', n);
	  n = parseInt(n, 10);
	  var state = this._readableState;
	  var nOrig = n;

	  if (n !== 0) state.emittedReadable = false;

	  // if we're doing read(0) to trigger a readable event, but we
	  // already have a bunch of data in the buffer, then just trigger
	  // the 'readable' event and move on.
	  if (n === 0 && state.needReadable && (state.length >= state.highWaterMark || state.ended)) {
	    debug('read: emitReadable', state.length, state.ended);
	    if (state.length === 0 && state.ended) endReadable(this);else emitReadable(this);
	    return null;
	  }

	  n = howMuchToRead(n, state);

	  // if we've ended, and we're now clear, then finish it up.
	  if (n === 0 && state.ended) {
	    if (state.length === 0) endReadable(this);
	    return null;
	  }

	  // All the actual chunk generation logic needs to be
	  // *below* the call to _read.  The reason is that in certain
	  // synthetic stream cases, such as passthrough streams, _read
	  // may be a completely synchronous operation which may change
	  // the state of the read buffer, providing enough data when
	  // before there was *not* enough.
	  //
	  // So, the steps are:
	  // 1. Figure out what the state of things will be after we do
	  // a read from the buffer.
	  //
	  // 2. If that resulting state will trigger a _read, then call _read.
	  // Note that this may be asynchronous, or synchronous.  Yes, it is
	  // deeply ugly to write APIs this way, but that still doesn't mean
	  // that the Readable class should behave improperly, as streams are
	  // designed to be sync/async agnostic.
	  // Take note if the _read call is sync or async (ie, if the read call
	  // has returned yet), so that we know whether or not it's safe to emit
	  // 'readable' etc.
	  //
	  // 3. Actually pull the requested chunks out of the buffer and return.

	  // if we need a readable event, then we need to do some reading.
	  var doRead = state.needReadable;
	  debug('need readable', doRead);

	  // if we currently have less than the highWaterMark, then also read some
	  if (state.length === 0 || state.length - n < state.highWaterMark) {
	    doRead = true;
	    debug('length less than watermark', doRead);
	  }

	  // however, if we've ended, then there's no point, and if we're already
	  // reading, then it's unnecessary.
	  if (state.ended || state.reading) {
	    doRead = false;
	    debug('reading or ended', doRead);
	  } else if (doRead) {
	    debug('do read');
	    state.reading = true;
	    state.sync = true;
	    // if the length is currently zero, then we *need* a readable event.
	    if (state.length === 0) state.needReadable = true;
	    // call internal read method
	    this._read(state.highWaterMark);
	    state.sync = false;
	    // If _read pushed data synchronously, then `reading` will be false,
	    // and we need to re-evaluate how much data we can return to the user.
	    if (!state.reading) n = howMuchToRead(nOrig, state);
	  }

	  var ret;
	  if (n > 0) ret = fromList(n, state);else ret = null;

	  if (ret === null) {
	    state.needReadable = true;
	    n = 0;
	  } else {
	    state.length -= n;
	  }

	  if (state.length === 0) {
	    // If we have nothing in the buffer, then we want to know
	    // as soon as we *do* get something into the buffer.
	    if (!state.ended) state.needReadable = true;

	    // If we tried to read() past the EOF, then emit end on the next tick.
	    if (nOrig !== n && state.ended) endReadable(this);
	  }

	  if (ret !== null) this.emit('data', ret);

	  return ret;
	};

	function chunkInvalid(state, chunk) {
	  var er = null;
	  if (!Buffer.isBuffer(chunk) && typeof chunk !== 'string' && chunk !== null && chunk !== undefined && !state.objectMode) {
	    er = new TypeError('Invalid non-string/buffer chunk');
	  }
	  return er;
	}

	function onEofChunk(stream, state) {
	  if (state.ended) return;
	  if (state.decoder) {
	    var chunk = state.decoder.end();
	    if (chunk && chunk.length) {
	      state.buffer.push(chunk);
	      state.length += state.objectMode ? 1 : chunk.length;
	    }
	  }
	  state.ended = true;

	  // emit 'readable' now to make sure it gets picked up.
	  emitReadable(stream);
	}

	// Don't emit readable right away in sync mode, because this can trigger
	// another read() call => stack overflow.  This way, it might trigger
	// a nextTick recursion warning, but that's not so bad.
	function emitReadable(stream) {
	  var state = stream._readableState;
	  state.needReadable = false;
	  if (!state.emittedReadable) {
	    debug('emitReadable', state.flowing);
	    state.emittedReadable = true;
	    if (state.sync) processNextTick(emitReadable_, stream);else emitReadable_(stream);
	  }
	}

	function emitReadable_(stream) {
	  debug('emit readable');
	  stream.emit('readable');
	  flow(stream);
	}

	// at this point, the user has presumably seen the 'readable' event,
	// and called read() to consume some data.  that may have triggered
	// in turn another _read(n) call, in which case reading = true if
	// it's in progress.
	// However, if we're not ended, or reading, and the length < hwm,
	// then go ahead and try to read some more preemptively.
	function maybeReadMore(stream, state) {
	  if (!state.readingMore) {
	    state.readingMore = true;
	    processNextTick(maybeReadMore_, stream, state);
	  }
	}

	function maybeReadMore_(stream, state) {
	  var len = state.length;
	  while (!state.reading && !state.flowing && !state.ended && state.length < state.highWaterMark) {
	    debug('maybeReadMore read 0');
	    stream.read(0);
	    if (len === state.length)
	      // didn't get any data, stop spinning.
	      break;else len = state.length;
	  }
	  state.readingMore = false;
	}

	// abstract method.  to be overridden in specific implementation classes.
	// call cb(er, data) where data is <= n in length.
	// for virtual (non-string, non-buffer) streams, "length" is somewhat
	// arbitrary, and perhaps not very meaningful.
	Readable.prototype._read = function (n) {
	  this.emit('error', new Error('_read() is not implemented'));
	};

	Readable.prototype.pipe = function (dest, pipeOpts) {
	  var src = this;
	  var state = this._readableState;

	  switch (state.pipesCount) {
	    case 0:
	      state.pipes = dest;
	      break;
	    case 1:
	      state.pipes = [state.pipes, dest];
	      break;
	    default:
	      state.pipes.push(dest);
	      break;
	  }
	  state.pipesCount += 1;
	  debug('pipe count=%d opts=%j', state.pipesCount, pipeOpts);

	  var doEnd = (!pipeOpts || pipeOpts.end !== false) && dest !== process.stdout && dest !== process.stderr;

	  var endFn = doEnd ? onend : cleanup;
	  if (state.endEmitted) processNextTick(endFn);else src.once('end', endFn);

	  dest.on('unpipe', onunpipe);
	  function onunpipe(readable) {
	    debug('onunpipe');
	    if (readable === src) {
	      cleanup();
	    }
	  }

	  function onend() {
	    debug('onend');
	    dest.end();
	  }

	  // when the dest drains, it reduces the awaitDrain counter
	  // on the source.  This would be more elegant with a .once()
	  // handler in flow(), but adding and removing repeatedly is
	  // too slow.
	  var ondrain = pipeOnDrain(src);
	  dest.on('drain', ondrain);

	  var cleanedUp = false;
	  function cleanup() {
	    debug('cleanup');
	    // cleanup event handlers once the pipe is broken
	    dest.removeListener('close', onclose);
	    dest.removeListener('finish', onfinish);
	    dest.removeListener('drain', ondrain);
	    dest.removeListener('error', onerror);
	    dest.removeListener('unpipe', onunpipe);
	    src.removeListener('end', onend);
	    src.removeListener('end', cleanup);
	    src.removeListener('data', ondata);

	    cleanedUp = true;

	    // if the reader is waiting for a drain event from this
	    // specific writer, then it would cause it to never start
	    // flowing again.
	    // So, if this is awaiting a drain, then we just call it now.
	    // If we don't know, then assume that we are waiting for one.
	    if (state.awaitDrain && (!dest._writableState || dest._writableState.needDrain)) ondrain();
	  }

	  // If the user pushes more data while we're writing to dest then we'll end up
	  // in ondata again. However, we only want to increase awaitDrain once because
	  // dest will only emit one 'drain' event for the multiple writes.
	  // => Introduce a guard on increasing awaitDrain.
	  var increasedAwaitDrain = false;
	  src.on('data', ondata);
	  function ondata(chunk) {
	    debug('ondata');
	    increasedAwaitDrain = false;
	    var ret = dest.write(chunk);
	    if (false === ret && !increasedAwaitDrain) {
	      // If the user unpiped during `dest.write()`, it is possible
	      // to get stuck in a permanently paused state if that write
	      // also returned false.
	      // => Check whether `dest` is still a piping destination.
	      if ((state.pipesCount === 1 && state.pipes === dest || state.pipesCount > 1 && indexOf(state.pipes, dest) !== -1) && !cleanedUp) {
	        debug('false write response, pause', src._readableState.awaitDrain);
	        src._readableState.awaitDrain++;
	        increasedAwaitDrain = true;
	      }
	      src.pause();
	    }
	  }

	  // if the dest has an error, then stop piping into it.
	  // however, don't suppress the throwing behavior for this.
	  function onerror(er) {
	    debug('onerror', er);
	    unpipe();
	    dest.removeListener('error', onerror);
	    if (EElistenerCount(dest, 'error') === 0) dest.emit('error', er);
	  }

	  // Make sure our error handler is attached before userland ones.
	  prependListener(dest, 'error', onerror);

	  // Both close and finish should trigger unpipe, but only once.
	  function onclose() {
	    dest.removeListener('finish', onfinish);
	    unpipe();
	  }
	  dest.once('close', onclose);
	  function onfinish() {
	    debug('onfinish');
	    dest.removeListener('close', onclose);
	    unpipe();
	  }
	  dest.once('finish', onfinish);

	  function unpipe() {
	    debug('unpipe');
	    src.unpipe(dest);
	  }

	  // tell the dest that it's being piped to
	  dest.emit('pipe', src);

	  // start the flow if it hasn't been started already.
	  if (!state.flowing) {
	    debug('pipe resume');
	    src.resume();
	  }

	  return dest;
	};

	function pipeOnDrain(src) {
	  return function () {
	    var state = src._readableState;
	    debug('pipeOnDrain', state.awaitDrain);
	    if (state.awaitDrain) state.awaitDrain--;
	    if (state.awaitDrain === 0 && EElistenerCount(src, 'data')) {
	      state.flowing = true;
	      flow(src);
	    }
	  };
	}

	Readable.prototype.unpipe = function (dest) {
	  var state = this._readableState;

	  // if we're not piping anywhere, then do nothing.
	  if (state.pipesCount === 0) return this;

	  // just one destination.  most common case.
	  if (state.pipesCount === 1) {
	    // passed in one, but it's not the right one.
	    if (dest && dest !== state.pipes) return this;

	    if (!dest) dest = state.pipes;

	    // got a match.
	    state.pipes = null;
	    state.pipesCount = 0;
	    state.flowing = false;
	    if (dest) dest.emit('unpipe', this);
	    return this;
	  }

	  // slow case. multiple pipe destinations.

	  if (!dest) {
	    // remove all.
	    var dests = state.pipes;
	    var len = state.pipesCount;
	    state.pipes = null;
	    state.pipesCount = 0;
	    state.flowing = false;

	    for (var i = 0; i < len; i++) {
	      dests[i].emit('unpipe', this);
	    }return this;
	  }

	  // try to find the right one.
	  var index = indexOf(state.pipes, dest);
	  if (index === -1) return this;

	  state.pipes.splice(index, 1);
	  state.pipesCount -= 1;
	  if (state.pipesCount === 1) state.pipes = state.pipes[0];

	  dest.emit('unpipe', this);

	  return this;
	};

	// set up data events if they are asked for
	// Ensure readable listeners eventually get something
	Readable.prototype.on = function (ev, fn) {
	  var res = Stream.prototype.on.call(this, ev, fn);

	  if (ev === 'data') {
	    // Start flowing on next tick if stream isn't explicitly paused
	    if (this._readableState.flowing !== false) this.resume();
	  } else if (ev === 'readable') {
	    var state = this._readableState;
	    if (!state.endEmitted && !state.readableListening) {
	      state.readableListening = state.needReadable = true;
	      state.emittedReadable = false;
	      if (!state.reading) {
	        processNextTick(nReadingNextTick, this);
	      } else if (state.length) {
	        emitReadable(this, state);
	      }
	    }
	  }

	  return res;
	};
	Readable.prototype.addListener = Readable.prototype.on;

	function nReadingNextTick(self) {
	  debug('readable nexttick read 0');
	  self.read(0);
	}

	// pause() and resume() are remnants of the legacy readable stream API
	// If the user uses them, then switch into old mode.
	Readable.prototype.resume = function () {
	  var state = this._readableState;
	  if (!state.flowing) {
	    debug('resume');
	    state.flowing = true;
	    resume(this, state);
	  }
	  return this;
	};

	function resume(stream, state) {
	  if (!state.resumeScheduled) {
	    state.resumeScheduled = true;
	    processNextTick(resume_, stream, state);
	  }
	}

	function resume_(stream, state) {
	  if (!state.reading) {
	    debug('resume read 0');
	    stream.read(0);
	  }

	  state.resumeScheduled = false;
	  state.awaitDrain = 0;
	  stream.emit('resume');
	  flow(stream);
	  if (state.flowing && !state.reading) stream.read(0);
	}

	Readable.prototype.pause = function () {
	  debug('call pause flowing=%j', this._readableState.flowing);
	  if (false !== this._readableState.flowing) {
	    debug('pause');
	    this._readableState.flowing = false;
	    this.emit('pause');
	  }
	  return this;
	};

	function flow(stream) {
	  var state = stream._readableState;
	  debug('flow', state.flowing);
	  while (state.flowing && stream.read() !== null) {}
	}

	// wrap an old-style stream as the async data source.
	// This is *not* part of the readable stream interface.
	// It is an ugly unfortunate mess of history.
	Readable.prototype.wrap = function (stream) {
	  var state = this._readableState;
	  var paused = false;

	  var self = this;
	  stream.on('end', function () {
	    debug('wrapped end');
	    if (state.decoder && !state.ended) {
	      var chunk = state.decoder.end();
	      if (chunk && chunk.length) self.push(chunk);
	    }

	    self.push(null);
	  });

	  stream.on('data', function (chunk) {
	    debug('wrapped data');
	    if (state.decoder) chunk = state.decoder.write(chunk);

	    // don't skip over falsy values in objectMode
	    if (state.objectMode && (chunk === null || chunk === undefined)) return;else if (!state.objectMode && (!chunk || !chunk.length)) return;

	    var ret = self.push(chunk);
	    if (!ret) {
	      paused = true;
	      stream.pause();
	    }
	  });

	  // proxy all the other methods.
	  // important when wrapping filters and duplexes.
	  for (var i in stream) {
	    if (this[i] === undefined && typeof stream[i] === 'function') {
	      this[i] = function (method) {
	        return function () {
	          return stream[method].apply(stream, arguments);
	        };
	      }(i);
	    }
	  }

	  // proxy certain important events.
	  var events = ['error', 'close', 'destroy', 'pause', 'resume'];
	  forEach(events, function (ev) {
	    stream.on(ev, self.emit.bind(self, ev));
	  });

	  // when we try to consume some more bytes, simply unpause the
	  // underlying stream.
	  self._read = function (n) {
	    debug('wrapped _read', n);
	    if (paused) {
	      paused = false;
	      stream.resume();
	    }
	  };

	  return self;
	};

	// exposed for testing purposes only.
	Readable._fromList = fromList;

	// Pluck off n bytes from an array of buffers.
	// Length is the combined lengths of all the buffers in the list.
	// This function is designed to be inlinable, so please take care when making
	// changes to the function body.
	function fromList(n, state) {
	  // nothing buffered
	  if (state.length === 0) return null;

	  var ret;
	  if (state.objectMode) ret = state.buffer.shift();else if (!n || n >= state.length) {
	    // read it all, truncate the list
	    if (state.decoder) ret = state.buffer.join('');else if (state.buffer.length === 1) ret = state.buffer.head.data;else ret = state.buffer.concat(state.length);
	    state.buffer.clear();
	  } else {
	    // read part of list
	    ret = fromListPartial(n, state.buffer, state.decoder);
	  }

	  return ret;
	}

	// Extracts only enough buffered data to satisfy the amount requested.
	// This function is designed to be inlinable, so please take care when making
	// changes to the function body.
	function fromListPartial(n, list, hasStrings) {
	  var ret;
	  if (n < list.head.data.length) {
	    // slice is the same for buffers and strings
	    ret = list.head.data.slice(0, n);
	    list.head.data = list.head.data.slice(n);
	  } else if (n === list.head.data.length) {
	    // first chunk is a perfect match
	    ret = list.shift();
	  } else {
	    // result spans more than one buffer
	    ret = hasStrings ? copyFromBufferString(n, list) : copyFromBuffer(n, list);
	  }
	  return ret;
	}

	// Copies a specified amount of characters from the list of buffered data
	// chunks.
	// This function is designed to be inlinable, so please take care when making
	// changes to the function body.
	function copyFromBufferString(n, list) {
	  var p = list.head;
	  var c = 1;
	  var ret = p.data;
	  n -= ret.length;
	  while (p = p.next) {
	    var str = p.data;
	    var nb = n > str.length ? str.length : n;
	    if (nb === str.length) ret += str;else ret += str.slice(0, n);
	    n -= nb;
	    if (n === 0) {
	      if (nb === str.length) {
	        ++c;
	        if (p.next) list.head = p.next;else list.head = list.tail = null;
	      } else {
	        list.head = p;
	        p.data = str.slice(nb);
	      }
	      break;
	    }
	    ++c;
	  }
	  list.length -= c;
	  return ret;
	}

	// Copies a specified amount of bytes from the list of buffered data chunks.
	// This function is designed to be inlinable, so please take care when making
	// changes to the function body.
	function copyFromBuffer(n, list) {
	  var ret = bufferShim.allocUnsafe(n);
	  var p = list.head;
	  var c = 1;
	  p.data.copy(ret);
	  n -= p.data.length;
	  while (p = p.next) {
	    var buf = p.data;
	    var nb = n > buf.length ? buf.length : n;
	    buf.copy(ret, ret.length - n, 0, nb);
	    n -= nb;
	    if (n === 0) {
	      if (nb === buf.length) {
	        ++c;
	        if (p.next) list.head = p.next;else list.head = list.tail = null;
	      } else {
	        list.head = p;
	        p.data = buf.slice(nb);
	      }
	      break;
	    }
	    ++c;
	  }
	  list.length -= c;
	  return ret;
	}

	function endReadable(stream) {
	  var state = stream._readableState;

	  // If we get here before consuming all the bytes, then that is a
	  // bug in node.  Should never happen.
	  if (state.length > 0) throw new Error('"endReadable()" called on non-empty stream');

	  if (!state.endEmitted) {
	    state.ended = true;
	    processNextTick(endReadableNT, state, stream);
	  }
	}

	function endReadableNT(state, stream) {
	  // Check that we didn't get one last unshift.
	  if (!state.endEmitted && state.length === 0) {
	    state.endEmitted = true;
	    stream.readable = false;
	    stream.emit('end');
	  }
	}

	function forEach(xs, f) {
	  for (var i = 0, l = xs.length; i < l; i++) {
	    f(xs[i], i);
	  }
	}

	function indexOf(xs, x) {
	  for (var i = 0, l = xs.length; i < l; i++) {
	    if (xs[i] === x) return i;
	  }
	  return -1;
	}
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(3)))

/***/ },
/* 23 */
/***/ function(module, exports) {

	/* WEBPACK VAR INJECTION */(function(global) {exports.fetch = isFunction(global.fetch) && isFunction(global.ReadableStream)

	exports.blobConstructor = false
	try {
		new Blob([new ArrayBuffer(1)])
		exports.blobConstructor = true
	} catch (e) {}

	// Service workers don't have XHR
	var xhr = null
	if (global.XMLHttpRequest) {
		xhr = new global.XMLHttpRequest()
		// If XDomainRequest is available (ie only, where xhr might not work
		// cross domain), use the page location. Otherwise use example.com
		// Note: this doesn't actually make an http request.
		try {
			xhr.open('GET', global.XDomainRequest ? '/' : 'https://example.com')
		} catch(e) {
			xhr = null
		}
	}

	function checkTypeSupport (type) {
		if (!xhr) return false
		try {
			xhr.responseType = type
			return xhr.responseType === type
		} catch (e) {}
		return false
	}

	// For some strange reason, Safari 7.0 reports typeof global.ArrayBuffer === 'object'.
	// Safari 7.1 appears to have fixed this bug.
	var haveArrayBuffer = typeof global.ArrayBuffer !== 'undefined'
	var haveSlice = haveArrayBuffer && isFunction(global.ArrayBuffer.prototype.slice)

	exports.arraybuffer = haveArrayBuffer && checkTypeSupport('arraybuffer')
	// These next two tests unavoidably show warnings in Chrome. Since fetch will always
	// be used if it's available, just return false for these to avoid the warnings.
	exports.msstream = !exports.fetch && haveSlice && checkTypeSupport('ms-stream')
	exports.mozchunkedarraybuffer = !exports.fetch && haveArrayBuffer &&
		checkTypeSupport('moz-chunked-arraybuffer')
	exports.overrideMimeType = xhr ? isFunction(xhr.overrideMimeType) : false
	exports.vbArray = isFunction(global.VBArray)

	function isFunction (value) {
		return typeof value === 'function'
	}

	xhr = null // Help gc

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 24 */
/***/ function(module, exports, __webpack_require__) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	var Buffer = __webpack_require__(6).Buffer;

	var isBufferEncoding = Buffer.isEncoding
	  || function(encoding) {
	       switch (encoding && encoding.toLowerCase()) {
	         case 'hex': case 'utf8': case 'utf-8': case 'ascii': case 'binary': case 'base64': case 'ucs2': case 'ucs-2': case 'utf16le': case 'utf-16le': case 'raw': return true;
	         default: return false;
	       }
	     }


	function assertEncoding(encoding) {
	  if (encoding && !isBufferEncoding(encoding)) {
	    throw new Error('Unknown encoding: ' + encoding);
	  }
	}

	// StringDecoder provides an interface for efficiently splitting a series of
	// buffers into a series of JS strings without breaking apart multi-byte
	// characters. CESU-8 is handled as part of the UTF-8 encoding.
	//
	// @TODO Handling all encodings inside a single object makes it very difficult
	// to reason about this code, so it should be split up in the future.
	// @TODO There should be a utf8-strict encoding that rejects invalid UTF-8 code
	// points as used by CESU-8.
	var StringDecoder = exports.StringDecoder = function(encoding) {
	  this.encoding = (encoding || 'utf8').toLowerCase().replace(/[-_]/, '');
	  assertEncoding(encoding);
	  switch (this.encoding) {
	    case 'utf8':
	      // CESU-8 represents each of Surrogate Pair by 3-bytes
	      this.surrogateSize = 3;
	      break;
	    case 'ucs2':
	    case 'utf16le':
	      // UTF-16 represents each of Surrogate Pair by 2-bytes
	      this.surrogateSize = 2;
	      this.detectIncompleteChar = utf16DetectIncompleteChar;
	      break;
	    case 'base64':
	      // Base-64 stores 3 bytes in 4 chars, and pads the remainder.
	      this.surrogateSize = 3;
	      this.detectIncompleteChar = base64DetectIncompleteChar;
	      break;
	    default:
	      this.write = passThroughWrite;
	      return;
	  }

	  // Enough space to store all bytes of a single character. UTF-8 needs 4
	  // bytes, but CESU-8 may require up to 6 (3 bytes per surrogate).
	  this.charBuffer = new Buffer(6);
	  // Number of bytes received for the current incomplete multi-byte character.
	  this.charReceived = 0;
	  // Number of bytes expected for the current incomplete multi-byte character.
	  this.charLength = 0;
	};


	// write decodes the given buffer and returns it as JS string that is
	// guaranteed to not contain any partial multi-byte characters. Any partial
	// character found at the end of the buffer is buffered up, and will be
	// returned when calling write again with the remaining bytes.
	//
	// Note: Converting a Buffer containing an orphan surrogate to a String
	// currently works, but converting a String to a Buffer (via `new Buffer`, or
	// Buffer#write) will replace incomplete surrogates with the unicode
	// replacement character. See https://codereview.chromium.org/121173009/ .
	StringDecoder.prototype.write = function(buffer) {
	  var charStr = '';
	  // if our last write ended with an incomplete multibyte character
	  while (this.charLength) {
	    // determine how many remaining bytes this buffer has to offer for this char
	    var available = (buffer.length >= this.charLength - this.charReceived) ?
	        this.charLength - this.charReceived :
	        buffer.length;

	    // add the new bytes to the char buffer
	    buffer.copy(this.charBuffer, this.charReceived, 0, available);
	    this.charReceived += available;

	    if (this.charReceived < this.charLength) {
	      // still not enough chars in this buffer? wait for more ...
	      return '';
	    }

	    // remove bytes belonging to the current character from the buffer
	    buffer = buffer.slice(available, buffer.length);

	    // get the character that was split
	    charStr = this.charBuffer.slice(0, this.charLength).toString(this.encoding);

	    // CESU-8: lead surrogate (D800-DBFF) is also the incomplete character
	    var charCode = charStr.charCodeAt(charStr.length - 1);
	    if (charCode >= 0xD800 && charCode <= 0xDBFF) {
	      this.charLength += this.surrogateSize;
	      charStr = '';
	      continue;
	    }
	    this.charReceived = this.charLength = 0;

	    // if there are no more bytes in this buffer, just emit our char
	    if (buffer.length === 0) {
	      return charStr;
	    }
	    break;
	  }

	  // determine and set charLength / charReceived
	  this.detectIncompleteChar(buffer);

	  var end = buffer.length;
	  if (this.charLength) {
	    // buffer the incomplete character bytes we got
	    buffer.copy(this.charBuffer, 0, buffer.length - this.charReceived, end);
	    end -= this.charReceived;
	  }

	  charStr += buffer.toString(this.encoding, 0, end);

	  var end = charStr.length - 1;
	  var charCode = charStr.charCodeAt(end);
	  // CESU-8: lead surrogate (D800-DBFF) is also the incomplete character
	  if (charCode >= 0xD800 && charCode <= 0xDBFF) {
	    var size = this.surrogateSize;
	    this.charLength += size;
	    this.charReceived += size;
	    this.charBuffer.copy(this.charBuffer, size, 0, size);
	    buffer.copy(this.charBuffer, 0, 0, size);
	    return charStr.substring(0, end);
	  }

	  // or just emit the charStr
	  return charStr;
	};

	// detectIncompleteChar determines if there is an incomplete UTF-8 character at
	// the end of the given buffer. If so, it sets this.charLength to the byte
	// length that character, and sets this.charReceived to the number of bytes
	// that are available for this character.
	StringDecoder.prototype.detectIncompleteChar = function(buffer) {
	  // determine how many bytes we have to check at the end of this buffer
	  var i = (buffer.length >= 3) ? 3 : buffer.length;

	  // Figure out if one of the last i bytes of our buffer announces an
	  // incomplete char.
	  for (; i > 0; i--) {
	    var c = buffer[buffer.length - i];

	    // See http://en.wikipedia.org/wiki/UTF-8#Description

	    // 110XXXXX
	    if (i == 1 && c >> 5 == 0x06) {
	      this.charLength = 2;
	      break;
	    }

	    // 1110XXXX
	    if (i <= 2 && c >> 4 == 0x0E) {
	      this.charLength = 3;
	      break;
	    }

	    // 11110XXX
	    if (i <= 3 && c >> 3 == 0x1E) {
	      this.charLength = 4;
	      break;
	    }
	  }
	  this.charReceived = i;
	};

	StringDecoder.prototype.end = function(buffer) {
	  var res = '';
	  if (buffer && buffer.length)
	    res = this.write(buffer);

	  if (this.charReceived) {
	    var cr = this.charReceived;
	    var buf = this.charBuffer;
	    var enc = this.encoding;
	    res += buf.slice(0, cr).toString(enc);
	  }

	  return res;
	};

	function passThroughWrite(buffer) {
	  return buffer.toString(this.encoding);
	}

	function utf16DetectIncompleteChar(buffer) {
	  this.charReceived = buffer.length % 2;
	  this.charLength = this.charReceived ? 2 : 0;
	}

	function base64DetectIncompleteChar(buffer) {
	  this.charReceived = buffer.length % 3;
	  this.charLength = this.charReceived ? 3 : 0;
	}


/***/ },
/* 25 */
/***/ function(module, exports, __webpack_require__) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	'use strict';

	var punycode = __webpack_require__(59);
	var util = __webpack_require__(60);

	exports.parse = urlParse;
	exports.resolve = urlResolve;
	exports.resolveObject = urlResolveObject;
	exports.format = urlFormat;

	exports.Url = Url;

	function Url() {
	  this.protocol = null;
	  this.slashes = null;
	  this.auth = null;
	  this.host = null;
	  this.port = null;
	  this.hostname = null;
	  this.hash = null;
	  this.search = null;
	  this.query = null;
	  this.pathname = null;
	  this.path = null;
	  this.href = null;
	}

	// Reference: RFC 3986, RFC 1808, RFC 2396

	// define these here so at least they only have to be
	// compiled once on the first module load.
	var protocolPattern = /^([a-z0-9.+-]+:)/i,
	    portPattern = /:[0-9]*$/,

	    // Special case for a simple path URL
	    simplePathPattern = /^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/,

	    // RFC 2396: characters reserved for delimiting URLs.
	    // We actually just auto-escape these.
	    delims = ['<', '>', '"', '`', ' ', '\r', '\n', '\t'],

	    // RFC 2396: characters not allowed for various reasons.
	    unwise = ['{', '}', '|', '\\', '^', '`'].concat(delims),

	    // Allowed by RFCs, but cause of XSS attacks.  Always escape these.
	    autoEscape = ['\''].concat(unwise),
	    // Characters that are never ever allowed in a hostname.
	    // Note that any invalid chars are also handled, but these
	    // are the ones that are *expected* to be seen, so we fast-path
	    // them.
	    nonHostChars = ['%', '/', '?', ';', '#'].concat(autoEscape),
	    hostEndingChars = ['/', '?', '#'],
	    hostnameMaxLen = 255,
	    hostnamePartPattern = /^[+a-z0-9A-Z_-]{0,63}$/,
	    hostnamePartStart = /^([+a-z0-9A-Z_-]{0,63})(.*)$/,
	    // protocols that can allow "unsafe" and "unwise" chars.
	    unsafeProtocol = {
	      'javascript': true,
	      'javascript:': true
	    },
	    // protocols that never have a hostname.
	    hostlessProtocol = {
	      'javascript': true,
	      'javascript:': true
	    },
	    // protocols that always contain a // bit.
	    slashedProtocol = {
	      'http': true,
	      'https': true,
	      'ftp': true,
	      'gopher': true,
	      'file': true,
	      'http:': true,
	      'https:': true,
	      'ftp:': true,
	      'gopher:': true,
	      'file:': true
	    },
	    querystring = __webpack_require__(47);

	function urlParse(url, parseQueryString, slashesDenoteHost) {
	  if (url && util.isObject(url) && url instanceof Url) return url;

	  var u = new Url;
	  u.parse(url, parseQueryString, slashesDenoteHost);
	  return u;
	}

	Url.prototype.parse = function(url, parseQueryString, slashesDenoteHost) {
	  if (!util.isString(url)) {
	    throw new TypeError("Parameter 'url' must be a string, not " + typeof url);
	  }

	  // Copy chrome, IE, opera backslash-handling behavior.
	  // Back slashes before the query string get converted to forward slashes
	  // See: https://code.google.com/p/chromium/issues/detail?id=25916
	  var queryIndex = url.indexOf('?'),
	      splitter =
	          (queryIndex !== -1 && queryIndex < url.indexOf('#')) ? '?' : '#',
	      uSplit = url.split(splitter),
	      slashRegex = /\\/g;
	  uSplit[0] = uSplit[0].replace(slashRegex, '/');
	  url = uSplit.join(splitter);

	  var rest = url;

	  // trim before proceeding.
	  // This is to support parse stuff like "  http://foo.com  \n"
	  rest = rest.trim();

	  if (!slashesDenoteHost && url.split('#').length === 1) {
	    // Try fast path regexp
	    var simplePath = simplePathPattern.exec(rest);
	    if (simplePath) {
	      this.path = rest;
	      this.href = rest;
	      this.pathname = simplePath[1];
	      if (simplePath[2]) {
	        this.search = simplePath[2];
	        if (parseQueryString) {
	          this.query = querystring.parse(this.search.substr(1));
	        } else {
	          this.query = this.search.substr(1);
	        }
	      } else if (parseQueryString) {
	        this.search = '';
	        this.query = {};
	      }
	      return this;
	    }
	  }

	  var proto = protocolPattern.exec(rest);
	  if (proto) {
	    proto = proto[0];
	    var lowerProto = proto.toLowerCase();
	    this.protocol = lowerProto;
	    rest = rest.substr(proto.length);
	  }

	  // figure out if it's got a host
	  // user@server is *always* interpreted as a hostname, and url
	  // resolution will treat //foo/bar as host=foo,path=bar because that's
	  // how the browser resolves relative URLs.
	  if (slashesDenoteHost || proto || rest.match(/^\/\/[^@\/]+@[^@\/]+/)) {
	    var slashes = rest.substr(0, 2) === '//';
	    if (slashes && !(proto && hostlessProtocol[proto])) {
	      rest = rest.substr(2);
	      this.slashes = true;
	    }
	  }

	  if (!hostlessProtocol[proto] &&
	      (slashes || (proto && !slashedProtocol[proto]))) {

	    // there's a hostname.
	    // the first instance of /, ?, ;, or # ends the host.
	    //
	    // If there is an @ in the hostname, then non-host chars *are* allowed
	    // to the left of the last @ sign, unless some host-ending character
	    // comes *before* the @-sign.
	    // URLs are obnoxious.
	    //
	    // ex:
	    // http://a@b@c/ => user:a@b host:c
	    // http://a@b?@c => user:a host:c path:/?@c

	    // v0.12 TODO(isaacs): This is not quite how Chrome does things.
	    // Review our test case against browsers more comprehensively.

	    // find the first instance of any hostEndingChars
	    var hostEnd = -1;
	    for (var i = 0; i < hostEndingChars.length; i++) {
	      var hec = rest.indexOf(hostEndingChars[i]);
	      if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
	        hostEnd = hec;
	    }

	    // at this point, either we have an explicit point where the
	    // auth portion cannot go past, or the last @ char is the decider.
	    var auth, atSign;
	    if (hostEnd === -1) {
	      // atSign can be anywhere.
	      atSign = rest.lastIndexOf('@');
	    } else {
	      // atSign must be in auth portion.
	      // http://a@b/c@d => host:b auth:a path:/c@d
	      atSign = rest.lastIndexOf('@', hostEnd);
	    }

	    // Now we have a portion which is definitely the auth.
	    // Pull that off.
	    if (atSign !== -1) {
	      auth = rest.slice(0, atSign);
	      rest = rest.slice(atSign + 1);
	      this.auth = decodeURIComponent(auth);
	    }

	    // the host is the remaining to the left of the first non-host char
	    hostEnd = -1;
	    for (var i = 0; i < nonHostChars.length; i++) {
	      var hec = rest.indexOf(nonHostChars[i]);
	      if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
	        hostEnd = hec;
	    }
	    // if we still have not hit it, then the entire thing is a host.
	    if (hostEnd === -1)
	      hostEnd = rest.length;

	    this.host = rest.slice(0, hostEnd);
	    rest = rest.slice(hostEnd);

	    // pull out port.
	    this.parseHost();

	    // we've indicated that there is a hostname,
	    // so even if it's empty, it has to be present.
	    this.hostname = this.hostname || '';

	    // if hostname begins with [ and ends with ]
	    // assume that it's an IPv6 address.
	    var ipv6Hostname = this.hostname[0] === '[' &&
	        this.hostname[this.hostname.length - 1] === ']';

	    // validate a little.
	    if (!ipv6Hostname) {
	      var hostparts = this.hostname.split(/\./);
	      for (var i = 0, l = hostparts.length; i < l; i++) {
	        var part = hostparts[i];
	        if (!part) continue;
	        if (!part.match(hostnamePartPattern)) {
	          var newpart = '';
	          for (var j = 0, k = part.length; j < k; j++) {
	            if (part.charCodeAt(j) > 127) {
	              // we replace non-ASCII char with a temporary placeholder
	              // we need this to make sure size of hostname is not
	              // broken by replacing non-ASCII by nothing
	              newpart += 'x';
	            } else {
	              newpart += part[j];
	            }
	          }
	          // we test again with ASCII char only
	          if (!newpart.match(hostnamePartPattern)) {
	            var validParts = hostparts.slice(0, i);
	            var notHost = hostparts.slice(i + 1);
	            var bit = part.match(hostnamePartStart);
	            if (bit) {
	              validParts.push(bit[1]);
	              notHost.unshift(bit[2]);
	            }
	            if (notHost.length) {
	              rest = '/' + notHost.join('.') + rest;
	            }
	            this.hostname = validParts.join('.');
	            break;
	          }
	        }
	      }
	    }

	    if (this.hostname.length > hostnameMaxLen) {
	      this.hostname = '';
	    } else {
	      // hostnames are always lower case.
	      this.hostname = this.hostname.toLowerCase();
	    }

	    if (!ipv6Hostname) {
	      // IDNA Support: Returns a punycoded representation of "domain".
	      // It only converts parts of the domain name that
	      // have non-ASCII characters, i.e. it doesn't matter if
	      // you call it with a domain that already is ASCII-only.
	      this.hostname = punycode.toASCII(this.hostname);
	    }

	    var p = this.port ? ':' + this.port : '';
	    var h = this.hostname || '';
	    this.host = h + p;
	    this.href += this.host;

	    // strip [ and ] from the hostname
	    // the host field still retains them, though
	    if (ipv6Hostname) {
	      this.hostname = this.hostname.substr(1, this.hostname.length - 2);
	      if (rest[0] !== '/') {
	        rest = '/' + rest;
	      }
	    }
	  }

	  // now rest is set to the post-host stuff.
	  // chop off any delim chars.
	  if (!unsafeProtocol[lowerProto]) {

	    // First, make 100% sure that any "autoEscape" chars get
	    // escaped, even if encodeURIComponent doesn't think they
	    // need to be.
	    for (var i = 0, l = autoEscape.length; i < l; i++) {
	      var ae = autoEscape[i];
	      if (rest.indexOf(ae) === -1)
	        continue;
	      var esc = encodeURIComponent(ae);
	      if (esc === ae) {
	        esc = escape(ae);
	      }
	      rest = rest.split(ae).join(esc);
	    }
	  }


	  // chop off from the tail first.
	  var hash = rest.indexOf('#');
	  if (hash !== -1) {
	    // got a fragment string.
	    this.hash = rest.substr(hash);
	    rest = rest.slice(0, hash);
	  }
	  var qm = rest.indexOf('?');
	  if (qm !== -1) {
	    this.search = rest.substr(qm);
	    this.query = rest.substr(qm + 1);
	    if (parseQueryString) {
	      this.query = querystring.parse(this.query);
	    }
	    rest = rest.slice(0, qm);
	  } else if (parseQueryString) {
	    // no query string, but parseQueryString still requested
	    this.search = '';
	    this.query = {};
	  }
	  if (rest) this.pathname = rest;
	  if (slashedProtocol[lowerProto] &&
	      this.hostname && !this.pathname) {
	    this.pathname = '/';
	  }

	  //to support http.request
	  if (this.pathname || this.search) {
	    var p = this.pathname || '';
	    var s = this.search || '';
	    this.path = p + s;
	  }

	  // finally, reconstruct the href based on what has been validated.
	  this.href = this.format();
	  return this;
	};

	// format a parsed object into a url string
	function urlFormat(obj) {
	  // ensure it's an object, and not a string url.
	  // If it's an obj, this is a no-op.
	  // this way, you can call url_format() on strings
	  // to clean up potentially wonky urls.
	  if (util.isString(obj)) obj = urlParse(obj);
	  if (!(obj instanceof Url)) return Url.prototype.format.call(obj);
	  return obj.format();
	}

	Url.prototype.format = function() {
	  var auth = this.auth || '';
	  if (auth) {
	    auth = encodeURIComponent(auth);
	    auth = auth.replace(/%3A/i, ':');
	    auth += '@';
	  }

	  var protocol = this.protocol || '',
	      pathname = this.pathname || '',
	      hash = this.hash || '',
	      host = false,
	      query = '';

	  if (this.host) {
	    host = auth + this.host;
	  } else if (this.hostname) {
	    host = auth + (this.hostname.indexOf(':') === -1 ?
	        this.hostname :
	        '[' + this.hostname + ']');
	    if (this.port) {
	      host += ':' + this.port;
	    }
	  }

	  if (this.query &&
	      util.isObject(this.query) &&
	      Object.keys(this.query).length) {
	    query = querystring.stringify(this.query);
	  }

	  var search = this.search || (query && ('?' + query)) || '';

	  if (protocol && protocol.substr(-1) !== ':') protocol += ':';

	  // only the slashedProtocols get the //.  Not mailto:, xmpp:, etc.
	  // unless they had them to begin with.
	  if (this.slashes ||
	      (!protocol || slashedProtocol[protocol]) && host !== false) {
	    host = '//' + (host || '');
	    if (pathname && pathname.charAt(0) !== '/') pathname = '/' + pathname;
	  } else if (!host) {
	    host = '';
	  }

	  if (hash && hash.charAt(0) !== '#') hash = '#' + hash;
	  if (search && search.charAt(0) !== '?') search = '?' + search;

	  pathname = pathname.replace(/[?#]/g, function(match) {
	    return encodeURIComponent(match);
	  });
	  search = search.replace('#', '%23');

	  return protocol + host + pathname + search + hash;
	};

	function urlResolve(source, relative) {
	  return urlParse(source, false, true).resolve(relative);
	}

	Url.prototype.resolve = function(relative) {
	  return this.resolveObject(urlParse(relative, false, true)).format();
	};

	function urlResolveObject(source, relative) {
	  if (!source) return relative;
	  return urlParse(source, false, true).resolveObject(relative);
	}

	Url.prototype.resolveObject = function(relative) {
	  if (util.isString(relative)) {
	    var rel = new Url();
	    rel.parse(relative, false, true);
	    relative = rel;
	  }

	  var result = new Url();
	  var tkeys = Object.keys(this);
	  for (var tk = 0; tk < tkeys.length; tk++) {
	    var tkey = tkeys[tk];
	    result[tkey] = this[tkey];
	  }

	  // hash is always overridden, no matter what.
	  // even href="" will remove it.
	  result.hash = relative.hash;

	  // if the relative url is empty, then there's nothing left to do here.
	  if (relative.href === '') {
	    result.href = result.format();
	    return result;
	  }

	  // hrefs like //foo/bar always cut to the protocol.
	  if (relative.slashes && !relative.protocol) {
	    // take everything except the protocol from relative
	    var rkeys = Object.keys(relative);
	    for (var rk = 0; rk < rkeys.length; rk++) {
	      var rkey = rkeys[rk];
	      if (rkey !== 'protocol')
	        result[rkey] = relative[rkey];
	    }

	    //urlParse appends trailing / to urls like http://www.example.com
	    if (slashedProtocol[result.protocol] &&
	        result.hostname && !result.pathname) {
	      result.path = result.pathname = '/';
	    }

	    result.href = result.format();
	    return result;
	  }

	  if (relative.protocol && relative.protocol !== result.protocol) {
	    // if it's a known url protocol, then changing
	    // the protocol does weird things
	    // first, if it's not file:, then we MUST have a host,
	    // and if there was a path
	    // to begin with, then we MUST have a path.
	    // if it is file:, then the host is dropped,
	    // because that's known to be hostless.
	    // anything else is assumed to be absolute.
	    if (!slashedProtocol[relative.protocol]) {
	      var keys = Object.keys(relative);
	      for (var v = 0; v < keys.length; v++) {
	        var k = keys[v];
	        result[k] = relative[k];
	      }
	      result.href = result.format();
	      return result;
	    }

	    result.protocol = relative.protocol;
	    if (!relative.host && !hostlessProtocol[relative.protocol]) {
	      var relPath = (relative.pathname || '').split('/');
	      while (relPath.length && !(relative.host = relPath.shift()));
	      if (!relative.host) relative.host = '';
	      if (!relative.hostname) relative.hostname = '';
	      if (relPath[0] !== '') relPath.unshift('');
	      if (relPath.length < 2) relPath.unshift('');
	      result.pathname = relPath.join('/');
	    } else {
	      result.pathname = relative.pathname;
	    }
	    result.search = relative.search;
	    result.query = relative.query;
	    result.host = relative.host || '';
	    result.auth = relative.auth;
	    result.hostname = relative.hostname || relative.host;
	    result.port = relative.port;
	    // to support http.request
	    if (result.pathname || result.search) {
	      var p = result.pathname || '';
	      var s = result.search || '';
	      result.path = p + s;
	    }
	    result.slashes = result.slashes || relative.slashes;
	    result.href = result.format();
	    return result;
	  }

	  var isSourceAbs = (result.pathname && result.pathname.charAt(0) === '/'),
	      isRelAbs = (
	          relative.host ||
	          relative.pathname && relative.pathname.charAt(0) === '/'
	      ),
	      mustEndAbs = (isRelAbs || isSourceAbs ||
	                    (result.host && relative.pathname)),
	      removeAllDots = mustEndAbs,
	      srcPath = result.pathname && result.pathname.split('/') || [],
	      relPath = relative.pathname && relative.pathname.split('/') || [],
	      psychotic = result.protocol && !slashedProtocol[result.protocol];

	  // if the url is a non-slashed url, then relative
	  // links like ../.. should be able
	  // to crawl up to the hostname, as well.  This is strange.
	  // result.protocol has already been set by now.
	  // Later on, put the first path part into the host field.
	  if (psychotic) {
	    result.hostname = '';
	    result.port = null;
	    if (result.host) {
	      if (srcPath[0] === '') srcPath[0] = result.host;
	      else srcPath.unshift(result.host);
	    }
	    result.host = '';
	    if (relative.protocol) {
	      relative.hostname = null;
	      relative.port = null;
	      if (relative.host) {
	        if (relPath[0] === '') relPath[0] = relative.host;
	        else relPath.unshift(relative.host);
	      }
	      relative.host = null;
	    }
	    mustEndAbs = mustEndAbs && (relPath[0] === '' || srcPath[0] === '');
	  }

	  if (isRelAbs) {
	    // it's absolute.
	    result.host = (relative.host || relative.host === '') ?
	                  relative.host : result.host;
	    result.hostname = (relative.hostname || relative.hostname === '') ?
	                      relative.hostname : result.hostname;
	    result.search = relative.search;
	    result.query = relative.query;
	    srcPath = relPath;
	    // fall through to the dot-handling below.
	  } else if (relPath.length) {
	    // it's relative
	    // throw away the existing file, and take the new path instead.
	    if (!srcPath) srcPath = [];
	    srcPath.pop();
	    srcPath = srcPath.concat(relPath);
	    result.search = relative.search;
	    result.query = relative.query;
	  } else if (!util.isNullOrUndefined(relative.search)) {
	    // just pull out the search.
	    // like href='?foo'.
	    // Put this after the other two cases because it simplifies the booleans
	    if (psychotic) {
	      result.hostname = result.host = srcPath.shift();
	      //occationaly the auth can get stuck only in host
	      //this especially happens in cases like
	      //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
	      var authInHost = result.host && result.host.indexOf('@') > 0 ?
	                       result.host.split('@') : false;
	      if (authInHost) {
	        result.auth = authInHost.shift();
	        result.host = result.hostname = authInHost.shift();
	      }
	    }
	    result.search = relative.search;
	    result.query = relative.query;
	    //to support http.request
	    if (!util.isNull(result.pathname) || !util.isNull(result.search)) {
	      result.path = (result.pathname ? result.pathname : '') +
	                    (result.search ? result.search : '');
	    }
	    result.href = result.format();
	    return result;
	  }

	  if (!srcPath.length) {
	    // no path at all.  easy.
	    // we've already handled the other stuff above.
	    result.pathname = null;
	    //to support http.request
	    if (result.search) {
	      result.path = '/' + result.search;
	    } else {
	      result.path = null;
	    }
	    result.href = result.format();
	    return result;
	  }

	  // if a url ENDs in . or .., then it must get a trailing slash.
	  // however, if it ends in anything else non-slashy,
	  // then it must NOT get a trailing slash.
	  var last = srcPath.slice(-1)[0];
	  var hasTrailingSlash = (
	      (result.host || relative.host || srcPath.length > 1) &&
	      (last === '.' || last === '..') || last === '');

	  // strip single dots, resolve double dots to parent dir
	  // if the path tries to go above the root, `up` ends up > 0
	  var up = 0;
	  for (var i = srcPath.length; i >= 0; i--) {
	    last = srcPath[i];
	    if (last === '.') {
	      srcPath.splice(i, 1);
	    } else if (last === '..') {
	      srcPath.splice(i, 1);
	      up++;
	    } else if (up) {
	      srcPath.splice(i, 1);
	      up--;
	    }
	  }

	  // if the path is allowed to go above the root, restore leading ..s
	  if (!mustEndAbs && !removeAllDots) {
	    for (; up--; up) {
	      srcPath.unshift('..');
	    }
	  }

	  if (mustEndAbs && srcPath[0] !== '' &&
	      (!srcPath[0] || srcPath[0].charAt(0) !== '/')) {
	    srcPath.unshift('');
	  }

	  if (hasTrailingSlash && (srcPath.join('/').substr(-1) !== '/')) {
	    srcPath.push('');
	  }

	  var isAbsolute = srcPath[0] === '' ||
	      (srcPath[0] && srcPath[0].charAt(0) === '/');

	  // put the host back
	  if (psychotic) {
	    result.hostname = result.host = isAbsolute ? '' :
	                                    srcPath.length ? srcPath.shift() : '';
	    //occationaly the auth can get stuck only in host
	    //this especially happens in cases like
	    //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
	    var authInHost = result.host && result.host.indexOf('@') > 0 ?
	                     result.host.split('@') : false;
	    if (authInHost) {
	      result.auth = authInHost.shift();
	      result.host = result.hostname = authInHost.shift();
	    }
	  }

	  mustEndAbs = mustEndAbs || (result.host && srcPath.length);

	  if (mustEndAbs && !isAbsolute) {
	    srcPath.unshift('');
	  }

	  if (!srcPath.length) {
	    result.pathname = null;
	    result.path = null;
	  } else {
	    result.pathname = srcPath.join('/');
	  }

	  //to support request.http
	  if (!util.isNull(result.pathname) || !util.isNull(result.search)) {
	    result.path = (result.pathname ? result.pathname : '') +
	                  (result.search ? result.search : '');
	  }
	  result.auth = relative.auth || result.auth;
	  result.slashes = result.slashes || relative.slashes;
	  result.href = result.format();
	  return result;
	};

	Url.prototype.parseHost = function() {
	  var host = this.host;
	  var port = portPattern.exec(host);
	  if (port) {
	    port = port[0];
	    if (port !== ':') {
	      this.port = port.substr(1);
	    }
	    host = host.substr(0, host.length - port.length);
	  }
	  if (host) this.hostname = host;
	};


/***/ },
/* 26 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _react = __webpack_require__(7);

	var _react2 = _interopRequireDefault(_react);

	var _queries = __webpack_require__(5);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var DocumentById = function (_React$Component) {
	  _inherits(DocumentById, _React$Component);

	  function DocumentById(props) {
	    _classCallCheck(this, DocumentById);

	    var _this2 = _possibleConstructorReturn(this, _React$Component.call(this, props));

	    _this2.componentDidMount = function () {
	      var _this = _this2;
	      (0, _queries.queryById)({ url: _this2.props.url, id: _this2.props.id }).then(function (response) {
	        _this.setState({ loading: false, prismic: response });
	      }).catch(function (err) {
	        _this.setState({ loading: false, error: err });
	      });
	    };

	    _this2.state = {
	      loading: true,
	      prismic: false,
	      error: false
	    };
	    return _this2;
	  }

	  DocumentById.prototype.render = function render() {
	    var _prismic;

	    var keyed = this.props.queryKey.length > 0;
	    var prismic = (_prismic = {
	      queryKey: keyed ? this.props.queryKey : false
	    }, _prismic[keyed ? this.props.queryKey + 'Loading' : 'loading'] = this.state.loading, _prismic[keyed ? this.props.queryKey + 'Error' : 'error'] = this.state.error, _prismic[keyed ? this.props.queryKey + 'Prismic' : 'prismic'] = this.state.prismic, _prismic);
	    return _react2.default.createElement(
	      'div',
	      null,
	      this.props.children(prismic)
	    );
	  };

	  return DocumentById;
	}(_react2.default.Component);

	DocumentById.defaultProps = {
	  queryKey: ''
	};
	exports.default = DocumentById;

/***/ },
/* 27 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _react = __webpack_require__(7);

	var _react2 = _interopRequireDefault(_react);

	var _queries = __webpack_require__(5);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var DocumentById = function (_React$Component) {
	  _inherits(DocumentById, _React$Component);

	  function DocumentById(props) {
	    _classCallCheck(this, DocumentById);

	    var _this2 = _possibleConstructorReturn(this, _React$Component.call(this, props));

	    _this2.componentDidMount = function () {
	      var _this = _this2;
	      (0, _queries.queryByUid)({ url: _this2.props.url, uid: _this2.props.uid, type: _this2.props.type }).then(function (response) {
	        _this.setState({ loading: false, prismic: response });
	      }).catch(function (err) {
	        _this.setState({ loading: false, error: err });
	      });
	    };

	    _this2.state = {
	      loading: true,
	      prismic: false,
	      error: false
	    };
	    return _this2;
	  }

	  DocumentById.prototype.render = function render() {
	    var _prismic;

	    var keyed = this.props.queryKey.length > 0;
	    var prismic = (_prismic = {
	      queryKey: keyed ? this.props.queryKey : false
	    }, _prismic[keyed ? this.props.queryKey + 'Loading' : 'loading'] = this.state.loading, _prismic[keyed ? this.props.queryKey + 'Error' : 'error'] = this.state.error, _prismic[keyed ? this.props.queryKey + 'Prismic' : 'prismic'] = this.state.prismic, _prismic);
	    return _react2.default.createElement(
	      'div',
	      null,
	      this.props.children(prismic)
	    );
	  };

	  return DocumentById;
	}(_react2.default.Component);

	DocumentById.defaultProps = {
	  queryKey: ''
	};
	exports.default = DocumentById;

/***/ },
/* 28 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _react = __webpack_require__(7);

	var _react2 = _interopRequireDefault(_react);

	var _queries = __webpack_require__(5);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var Query = function (_React$Component) {
	  _inherits(Query, _React$Component);

	  function Query(props) {
	    _classCallCheck(this, Query);

	    var _this2 = _possibleConstructorReturn(this, _React$Component.call(this, props));

	    _this2.componentDidMount = function () {
	      var _this = _this2;
	      (0, _queries.query)({ url: _this2.props.url, query: _this.props.query, predicates: _this.props.predicates, options: _this.props.options }).then(function (response) {
	        _this.setState({ loading: false, prismic: response });
	      }).catch(function (err) {
	        _this.setState({ loading: false, error: err });
	      });
	    };

	    _this2.state = {
	      loading: true,
	      prismic: false,
	      error: false
	    };
	    return _this2;
	  }

	  Query.prototype.render = function render() {
	    var _prismic;

	    var keyed = this.props.queryKey.length > 0;
	    var prismic = (_prismic = {
	      queryKey: keyed ? this.props.queryKey : false
	    }, _prismic[keyed ? this.props.queryKey + 'Loading' : 'loading'] = this.state.loading, _prismic[keyed ? this.props.queryKey + 'Error' : 'error'] = this.state.error, _prismic[keyed ? this.props.queryKey + 'Prismic' : 'prismic'] = this.state.prismic, _prismic);
	    return _react2.default.createElement(
	      'div',
	      null,
	      this.props.children(prismic)
	    );
	  };

	  return Query;
	}(_react2.default.Component);

	Query.defaultProps = {
	  query: false,
	  queryKey: '',
	  predicates: '',
	  options: {}
	};
	exports.default = Query;

/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports.default = withDocumentById;

	var _react = __webpack_require__(7);

	var _react2 = _interopRequireDefault(_react);

	var _queries = __webpack_require__(5);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	function withDocumentById(_ref) {
	  var url = _ref.url,
	      id = _ref.id,
	      _ref$queryKey = _ref.queryKey,
	      queryKey = _ref$queryKey === undefined ? '' : _ref$queryKey;

	  return function (ComposedComponent) {
	    return function (_React$Component) {
	      _inherits(withDocument, _React$Component);

	      function withDocument(props) {
	        _classCallCheck(this, withDocument);

	        var _this2 = _possibleConstructorReturn(this, _React$Component.call(this, props));

	        _this2.componentDidMount = function () {
	          var _this = _this2;
	          (0, _queries.queryById)({ url: url, id: id }).then(function (response) {
	            _this.setState({ loading: false, prismic: response });
	          }).catch(function (err) {
	            _this.setState({ loading: false, error: err });
	          });
	        };

	        _this2.state = {
	          loading: true,
	          prismic: false,
	          error: false
	        };
	        return _this2;
	      }

	      withDocument.prototype.render = function render() {
	        var _prismic;

	        var keyed = queryKey.length > 0;
	        var prismic = (_prismic = {
	          queryKey: keyed ? queryKey : false
	        }, _prismic[keyed ? queryKey + 'Loading' : 'loading'] = this.state.loading, _prismic[keyed ? queryKey + 'Error' : 'error'] = this.state.error, _prismic[keyed ? queryKey + 'Prismic' : 'prismic'] = this.state.prismic, _prismic);
	        return _react2.default.createElement(ComposedComponent, _extends({}, this.props, prismic));
	      };

	      return withDocument;
	    }(_react2.default.Component);
	  };
	}

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports.default = withDocumentById;

	var _react = __webpack_require__(7);

	var _react2 = _interopRequireDefault(_react);

	var _queries = __webpack_require__(5);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	function withDocumentById(_ref) {
	  var url = _ref.url,
	      uid = _ref.uid,
	      type = _ref.type,
	      _ref$queryKey = _ref.queryKey,
	      queryKey = _ref$queryKey === undefined ? '' : _ref$queryKey;

	  return function (ComposedComponent) {
	    return function (_React$Component) {
	      _inherits(withDocument, _React$Component);

	      function withDocument(props) {
	        _classCallCheck(this, withDocument);

	        var _this2 = _possibleConstructorReturn(this, _React$Component.call(this, props));

	        _this2.componentDidMount = function () {
	          var _this = _this2;
	          (0, _queries.queryByUid)({ url: url, uid: uid, type: type }).then(function (response) {
	            _this.setState({ loading: false, prismic: response });
	          }).catch(function (err) {
	            _this.setState({ loading: false, error: err });
	          });
	        };

	        _this2.state = {
	          loading: true,
	          prismic: false,
	          error: false
	        };
	        return _this2;
	      }

	      withDocument.prototype.render = function render() {
	        var _prismic;

	        var keyed = queryKey.length > 0;
	        var prismic = (_prismic = {
	          queryKey: keyed ? queryKey : false
	        }, _prismic[keyed ? queryKey + 'Loading' : 'loading'] = this.state.loading, _prismic[keyed ? queryKey + 'Error' : 'error'] = this.state.error, _prismic[keyed ? queryKey + 'Prismic' : 'prismic'] = this.state.prismic, _prismic);
	        return _react2.default.createElement(ComposedComponent, _extends({}, this.props, prismic));
	      };

	      return withDocument;
	    }(_react2.default.Component);
	  };
	}

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports.default = withQuery;

	var _react = __webpack_require__(7);

	var _react2 = _interopRequireDefault(_react);

	var _queries = __webpack_require__(5);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	//$FlowFixMe https://github.com/facebook/flow/issues/183
	function withQuery(_ref) {
	  var url = _ref.url,
	      _ref$queryKey = _ref.queryKey,
	      queryKey = _ref$queryKey === undefined ? '' : _ref$queryKey,
	      _ref$query = _ref.query,
	      query = _ref$query === undefined ? false : _ref$query,
	      _ref$predicates = _ref.predicates,
	      predicates = _ref$predicates === undefined ? '' : _ref$predicates,
	      _ref$options = _ref.options,
	      options = _ref$options === undefined ? {} : _ref$options;

	  return function (ComposedComponent) {
	    return function (_React$Component) {
	      _inherits(withQuery, _React$Component);

	      function withQuery(props) {
	        _classCallCheck(this, withQuery);

	        var _this2 = _possibleConstructorReturn(this, _React$Component.call(this, props));

	        _this2.state = {
	          loading: true,
	          prismic: {},
	          error: false
	        };
	        return _this2;
	      }

	      withQuery.prototype.componentDidMount = function componentDidMount() {
	        var _this = this;
	        (0, _queries.query)({ url: url, query: query, predicates: predicates, options: options }).then(function (response) {
	          _this.setState({ loading: false, prismic: response });
	        }).catch(function (err) {
	          _this.setState({ loading: false, error: err });
	        });
	      };

	      withQuery.prototype.render = function render() {
	        var _prismic;

	        var keyed = queryKey.length > 0;
	        var prismic = (_prismic = {
	          queryKey: keyed ? queryKey : false
	        }, _prismic[keyed ? queryKey + 'Loading' : 'loading'] = this.state.loading, _prismic[keyed ? queryKey + 'Error' : 'error'] = this.state.error, _prismic[keyed ? queryKey + 'Prismic' : 'prismic'] = this.state.prismic, _prismic);
	        return _react2.default.createElement(ComposedComponent, _extends({}, this.props, prismic));
	      };

	      return withQuery;
	    }(_react2.default.Component);
	  };
	}

/***/ },
/* 32 */
/***/ function(module, exports) {

	'use strict'

	exports.byteLength = byteLength
	exports.toByteArray = toByteArray
	exports.fromByteArray = fromByteArray

	var lookup = []
	var revLookup = []
	var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array

	var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
	for (var i = 0, len = code.length; i < len; ++i) {
	  lookup[i] = code[i]
	  revLookup[code.charCodeAt(i)] = i
	}

	revLookup['-'.charCodeAt(0)] = 62
	revLookup['_'.charCodeAt(0)] = 63

	function placeHoldersCount (b64) {
	  var len = b64.length
	  if (len % 4 > 0) {
	    throw new Error('Invalid string. Length must be a multiple of 4')
	  }

	  // the number of equal signs (place holders)
	  // if there are two placeholders, than the two characters before it
	  // represent one byte
	  // if there is only one, then the three characters before it represent 2 bytes
	  // this is just a cheap hack to not do indexOf twice
	  return b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0
	}

	function byteLength (b64) {
	  // base64 is 4/3 + up to two characters of the original data
	  return b64.length * 3 / 4 - placeHoldersCount(b64)
	}

	function toByteArray (b64) {
	  var i, j, l, tmp, placeHolders, arr
	  var len = b64.length
	  placeHolders = placeHoldersCount(b64)

	  arr = new Arr(len * 3 / 4 - placeHolders)

	  // if there are placeholders, only get up to the last complete 4 chars
	  l = placeHolders > 0 ? len - 4 : len

	  var L = 0

	  for (i = 0, j = 0; i < l; i += 4, j += 3) {
	    tmp = (revLookup[b64.charCodeAt(i)] << 18) | (revLookup[b64.charCodeAt(i + 1)] << 12) | (revLookup[b64.charCodeAt(i + 2)] << 6) | revLookup[b64.charCodeAt(i + 3)]
	    arr[L++] = (tmp >> 16) & 0xFF
	    arr[L++] = (tmp >> 8) & 0xFF
	    arr[L++] = tmp & 0xFF
	  }

	  if (placeHolders === 2) {
	    tmp = (revLookup[b64.charCodeAt(i)] << 2) | (revLookup[b64.charCodeAt(i + 1)] >> 4)
	    arr[L++] = tmp & 0xFF
	  } else if (placeHolders === 1) {
	    tmp = (revLookup[b64.charCodeAt(i)] << 10) | (revLookup[b64.charCodeAt(i + 1)] << 4) | (revLookup[b64.charCodeAt(i + 2)] >> 2)
	    arr[L++] = (tmp >> 8) & 0xFF
	    arr[L++] = tmp & 0xFF
	  }

	  return arr
	}

	function tripletToBase64 (num) {
	  return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F]
	}

	function encodeChunk (uint8, start, end) {
	  var tmp
	  var output = []
	  for (var i = start; i < end; i += 3) {
	    tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2])
	    output.push(tripletToBase64(tmp))
	  }
	  return output.join('')
	}

	function fromByteArray (uint8) {
	  var tmp
	  var len = uint8.length
	  var extraBytes = len % 3 // if we have 1 byte left, pad 2 bytes
	  var output = ''
	  var parts = []
	  var maxChunkLength = 16383 // must be multiple of 3

	  // go through the array every three bytes, we'll deal with trailing stuff later
	  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
	    parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)))
	  }

	  // pad the end with zeros, but make sure to not forget the extra bytes
	  if (extraBytes === 1) {
	    tmp = uint8[len - 1]
	    output += lookup[tmp >> 2]
	    output += lookup[(tmp << 4) & 0x3F]
	    output += '=='
	  } else if (extraBytes === 2) {
	    tmp = (uint8[len - 2] << 8) + (uint8[len - 1])
	    output += lookup[tmp >> 10]
	    output += lookup[(tmp >> 4) & 0x3F]
	    output += lookup[(tmp << 2) & 0x3F]
	    output += '='
	  }

	  parts.push(output)

	  return parts.join('')
	}


/***/ },
/* 33 */
/***/ function(module, exports) {

	var toString = {}.toString;

	module.exports = Array.isArray || function (arr) {
	  return toString.call(arr) == '[object Array]';
	};


/***/ },
/* 34 */
/***/ function(module, exports) {

	module.exports = {
	  "100": "Continue",
	  "101": "Switching Protocols",
	  "102": "Processing",
	  "200": "OK",
	  "201": "Created",
	  "202": "Accepted",
	  "203": "Non-Authoritative Information",
	  "204": "No Content",
	  "205": "Reset Content",
	  "206": "Partial Content",
	  "207": "Multi-Status",
	  "208": "Already Reported",
	  "226": "IM Used",
	  "300": "Multiple Choices",
	  "301": "Moved Permanently",
	  "302": "Found",
	  "303": "See Other",
	  "304": "Not Modified",
	  "305": "Use Proxy",
	  "307": "Temporary Redirect",
	  "308": "Permanent Redirect",
	  "400": "Bad Request",
	  "401": "Unauthorized",
	  "402": "Payment Required",
	  "403": "Forbidden",
	  "404": "Not Found",
	  "405": "Method Not Allowed",
	  "406": "Not Acceptable",
	  "407": "Proxy Authentication Required",
	  "408": "Request Timeout",
	  "409": "Conflict",
	  "410": "Gone",
	  "411": "Length Required",
	  "412": "Precondition Failed",
	  "413": "Payload Too Large",
	  "414": "URI Too Long",
	  "415": "Unsupported Media Type",
	  "416": "Range Not Satisfiable",
	  "417": "Expectation Failed",
	  "418": "I'm a teapot",
	  "421": "Misdirected Request",
	  "422": "Unprocessable Entity",
	  "423": "Locked",
	  "424": "Failed Dependency",
	  "425": "Unordered Collection",
	  "426": "Upgrade Required",
	  "428": "Precondition Required",
	  "429": "Too Many Requests",
	  "431": "Request Header Fields Too Large",
	  "451": "Unavailable For Legal Reasons",
	  "500": "Internal Server Error",
	  "501": "Not Implemented",
	  "502": "Bad Gateway",
	  "503": "Service Unavailable",
	  "504": "Gateway Timeout",
	  "505": "HTTP Version Not Supported",
	  "506": "Variant Also Negotiates",
	  "507": "Insufficient Storage",
	  "508": "Loop Detected",
	  "509": "Bandwidth Limit Exceeded",
	  "510": "Not Extended",
	  "511": "Network Authentication Required"
	}


/***/ },
/* 35 */
/***/ function(module, exports, __webpack_require__) {

	var http = __webpack_require__(17);

	var https = module.exports;

	for (var key in http) {
	    if (http.hasOwnProperty(key)) https[key] = http[key];
	};

	https.request = function (params, cb) {
	    if (!params) params = {};
	    params.scheme = 'https';
	    params.protocol = 'https:';
	    return http.request.call(this, params, cb);
	}


/***/ },
/* 36 */
/***/ function(module, exports) {

	exports.read = function (buffer, offset, isLE, mLen, nBytes) {
	  var e, m
	  var eLen = nBytes * 8 - mLen - 1
	  var eMax = (1 << eLen) - 1
	  var eBias = eMax >> 1
	  var nBits = -7
	  var i = isLE ? (nBytes - 1) : 0
	  var d = isLE ? -1 : 1
	  var s = buffer[offset + i]

	  i += d

	  e = s & ((1 << (-nBits)) - 1)
	  s >>= (-nBits)
	  nBits += eLen
	  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  m = e & ((1 << (-nBits)) - 1)
	  e >>= (-nBits)
	  nBits += mLen
	  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  if (e === 0) {
	    e = 1 - eBias
	  } else if (e === eMax) {
	    return m ? NaN : ((s ? -1 : 1) * Infinity)
	  } else {
	    m = m + Math.pow(2, mLen)
	    e = e - eBias
	  }
	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
	}

	exports.write = function (buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c
	  var eLen = nBytes * 8 - mLen - 1
	  var eMax = (1 << eLen) - 1
	  var eBias = eMax >> 1
	  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0)
	  var i = isLE ? 0 : (nBytes - 1)
	  var d = isLE ? 1 : -1
	  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0

	  value = Math.abs(value)

	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0
	    e = eMax
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2)
	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--
	      c *= 2
	    }
	    if (e + eBias >= 1) {
	      value += rt / c
	    } else {
	      value += rt * Math.pow(2, 1 - eBias)
	    }
	    if (value * c >= 2) {
	      e++
	      c /= 2
	    }

	    if (e + eBias >= eMax) {
	      m = 0
	      e = eMax
	    } else if (e + eBias >= 1) {
	      m = (value * c - 1) * Math.pow(2, mLen)
	      e = e + eBias
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)
	      e = 0
	    }
	  }

	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

	  e = (e << mLen) | m
	  eLen += mLen
	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

	  buffer[offset + i - d] |= s * 128
	}


/***/ },
/* 37 */
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Copyright 2013-2015, Facebook, Inc.
	 * All rights reserved.
	 *
	 * This source code is licensed under the BSD-style license found in the
	 * LICENSE file in the root directory of this source tree. An additional grant
	 * of patent rights can be found in the PATENTS file in the same directory.
	 */

	'use strict';

	/**
	 * Use invariant() to assert state which your program assumes to be true.
	 *
	 * Provide sprintf-style format (only %s is supported) and arguments
	 * to provide information about what broke and what you were
	 * expecting.
	 *
	 * The invariant message will be stripped in production, but the invariant
	 * will remain to ensure logic does not differ in production.
	 */

	var invariant = function(condition, format, a, b, c, d, e, f) {
	  if (true) {
	    if (format === undefined) {
	      throw new Error('invariant requires an error message argument');
	    }
	  }

	  if (!condition) {
	    var error;
	    if (format === undefined) {
	      error = new Error(
	        'Minified exception occurred; use the non-minified dev environment ' +
	        'for the full error message and additional helpful warnings.'
	      );
	    } else {
	      var args = [a, b, c, d, e, f];
	      var argIndex = 0;
	      error = new Error(
	        format.replace(/%s/g, function() { return args[argIndex++]; })
	      );
	      error.name = 'Invariant Violation';
	    }

	    error.framesToPop = 1; // we don't care about invariant's own frame
	    throw error;
	  }
	};

	module.exports = invariant;


/***/ },
/* 38 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';

	var Requests = __webpack_require__(44),
	    Cookies = __webpack_require__(40),
	    documents = __webpack_require__(11),
	    ApiCache = __webpack_require__(39),
	    Predicates = __webpack_require__(20),
	    experiments = __webpack_require__(19);

	var Experiments = experiments.Experiments,
	    Document = documents.Document;

	var experimentCookie = "io.prismic.experiment",
	    previewCookie = "io.prismic.preview";

	/**
	 * Initialisation of the API object.
	 * This is for internal use, from outside this kit, you should call Prismic.Api()
	 * @private
	 */
	function Api(url, options) {
	  var opts = options || {};
	  this.accessToken = opts.accessToken;
	  this.url = url + (this.accessToken ? (url.indexOf('?') > -1 ? '&' : '?') + 'access_token=' + this.accessToken : '');
	  this.req = opts.req;
	  this.apiCache = opts.apiCache || globalCache();
	  this.requestHandler = opts.requestHandler || Requests.request;
	  this.apiCacheKey = this.url + (this.accessToken ? ('#' + this.accessToken) : '');
	  this.apiDataTTL = opts.apiDataTTL || 5;
	  return this;
	}

	Api.prototype = {

	  // Predicates
	  AT: "at",
	  ANY: "any",
	  SIMILAR: "similar",
	  FULLTEXT: "fulltext",
	  NUMBER: {
	    GT: "number.gt",
	    LT: "number.lt"
	  },
	  DATE: {
	    // Other date operators are available: see the documentation.
	    AFTER: "date.after",
	    BEFORE: "date.before",
	    BETWEEN: "date.between"
	  },

	  // Fragment: usable as the second element of a query array on most predicates (except SIMILAR).
	  // You can also use "my.*" for your custom fields.
	  DOCUMENT: {
	    ID: "document.id",
	    TYPE: "document.type",
	    TAGS: "document.tags"
	  },

	  data: null,

	  /**
	   * Fetches data used to construct the api client, from cache if it's
	   * present, otherwise from calling the prismic api endpoint (which is
	   * then cached).
	   *
	   * @param {function} callback - Callback to receive the data. Optional, you can use the promise result.
	   * @returns {Promise} Promise holding the data or error
	   */
	  get: function(callback) {
	    var self = this;
	    var cacheKey = this.apiCacheKey;

	    return new Promise(function (resolve, reject) {
	      var cb = function(err, value, xhr, ttl) {
	        if (callback) callback(err, value, xhr, ttl);
	        if (value) resolve(value);
	        if (err) reject(err);
	      };
	      self.apiCache.get(cacheKey, function (err, value) {
	        if (err || value) {
	          cb(err, value);
	          return;
	        }

	        self.requestHandler(self.url, function(err, data, xhr, ttl) {
	          if (err) {
	            cb(err, null, xhr, ttl);
	            return;
	          }

	          var parsed = self.parse(data);
	          ttl = ttl || self.apiDataTTL;

	          self.apiCache.set(cacheKey, parsed, ttl, function (err) {
	            cb(err, parsed, xhr, ttl);
	          });
	        });
	      });
	    });
	  },

	  /**
	   * Cleans api data from the cache and fetches an up to date copy.
	   *
	   * @param {function} callback - Optional callback function that is called after the data has been refreshed
	   * @returns {Promise}
	   */
	  refresh: function (callback) {
	    var self = this;
	    var cacheKey = this.apiCacheKey;

	    return new Promise(function(resolve, reject) {
	      var cb = function(err, value, xhr) {
	        if (callback) callback(err, value, xhr);
	        if (value) resolve(value);
	        if (err) reject(err);
	      };
	      self.apiCache.remove(cacheKey, function (err) {
	        if (err) { cb(err); return; }

	        self.get(function (err, data) {
	          if (err) { cb(err); return; }

	          self.data = data;
	          self.bookmarks = data.bookmarks;
	          self.experiments = new Experiments(data.experiments);

	          cb();
	        });
	      });
	    });
	  },

	  /**
	   * Parses and returns the /api document.
	   * This is for internal use, from outside this kit, you should call Prismic.Api()
	   *
	   * @param {string} data - The JSON document responded on the API's endpoint
	   * @returns {Api} - The Api object that can be manipulated
	   * @private
	   */
	  parse: function(data) {
	    var refs,
	        master,
	        forms = {},
	        form,
	        types,
	        tags,
	        f,
	        i;

	    // Parse the forms
	    for (i in data.forms) {
	      if (data.forms.hasOwnProperty(i)) {
	        f = data.forms[i];

	        if(this.accessToken) {
	          f.fields['access_token'] = {};
	          f.fields['access_token']['type'] = 'string';
	          f.fields['access_token']['default'] = this.accessToken;
	        }

	        form = new Form(
	          f.name,
	          f.fields,
	          f.form_method,
	          f.rel,
	          f.enctype,
	          f.action
	        );

	        forms[i] = form;
	      }
	    }

	    refs = data.refs.map(function (r) {
	      return new Ref(
	        r.ref,
	        r.label,
	        r.isMasterRef,
	        r.scheduledAt,
	        r.id
	      );
	    }) || [];

	    master = refs.filter(function (r) {
	      return r.isMaster === true;
	    });

	    types = data.types;

	    tags = data.tags;

	    if (master.length === 0) {
	      throw ("No master ref.");
	    }

	    return {
	      bookmarks: data.bookmarks || {},
	      refs: refs,
	      forms: forms,
	      master: master[0],
	      types: types,
	      tags: tags,
	      experiments: data.experiments,
	      oauthInitiate: data['oauth_initiate'],
	      oauthToken: data['oauth_token'],
	      quickRoutes: data.quickRoutes
	    };

	  },

	  /**
	   * @deprecated use form() now
	   * @param {string} formId - The id of a form, like "everything", or "products"
	   * @returns {SearchForm} - the SearchForm that can be used.
	   */
	  forms: function(formId) {
	    return this.form(formId);
	  },

	  /**
	   * Returns a useable form from its id, as described in the RESTful description of the API.
	   * For instance: api.form("everything") works on every repository (as "everything" exists by default)
	   * You can then chain the calls: api.form("everything").query('[[:d = at(document.id, "UkL0gMuvzYUANCpf")]]').ref(ref).submit()
	   *
	   * @param {string} formId - The id of a form, like "everything", or "products"
	   * @returns {SearchForm} - the SearchForm that can be used.
	   */
	  form: function(formId) {
	    var form = this.data.forms[formId];
	    if(form) {
	      return new SearchForm(this, form, {});
	    }
	    return null;
	  },

	  /**
	   * The ID of the master ref on this prismic.io API.
	   * Do not use like this: searchForm.ref(api.master()).
	   * Instead, set your ref once in a variable, and call it when you need it; this will allow to change the ref you're viewing easily for your entire page.
	   *
	   * @returns {string}
	   */
	  master: function() {
	    return this.data.master.ref;
	  },

	  /**
	   * Returns the ref ID for a given ref's label.
	   * Do not use like this: searchForm.ref(api.ref("Future release label")).
	   * Instead, set your ref once in a variable, and call it when you need it; this will allow to change the ref you're viewing easily for your entire page.
	   *
	   * @param {string} label - the ref's label
	   * @returns {string}
	   */
	  ref: function(label) {
	    for(var i=0; i<this.data.refs.length; i++) {
	      if(this.data.refs[i].label == label) {
	        return this.data.refs[i].ref;
	      }
	    }
	    return null;
	  },

	  /**
	   * The current experiment, or null
	   * @returns {Experiment}
	   */
	  currentExperiment: function() {
	    return this.experiments.current();
	  },

	  quickRoutesEnabled: function() {
	    return this.data.quickRoutes.enabled;
	  },

	  /**
	   * Retrieve quick routes definitions
	   */
	  quickRoutes: function(callback) {
	    var self = this;
	    return new Promise(function(resolve, reject) {
	      self.requestHandler(self.data.quickRoutes.url, function(err, data, xhr) {
	        if (callback) callback(err, data, xhr);
	        if (err) reject(err);
	        if (data) resolve(data);
	      });
	    });
	  },

	  /**
	   * Query the repository
	   * @param {string|array|Predicate} the query itself
	   * @param {object} additional parameters. In NodeJS, pass the request as 'req'.
	   * @param {function} callback(err, response)
	   */
	  query: function(q, options, callback) {
	    var opts = options || {};
	    var form = this.form('everything');
	    for (var key in opts) {
	      form = form.set(key, options[key]);
	    }
	    // Don't override the ref if the caller specified one in the options
	    if (!opts['ref']) {
	      // Look in cookies if we have a ref (preview or experiment)
	      var cookieString = '';
	      if (this.req) { // NodeJS
	        cookieString = this.req.headers["cookie"] || '';
	      } else if (typeof window !== 'undefined') { // Browser
	        cookieString = window.document.cookie || '';
	      }
	      var cookies = Cookies.parse(cookieString);
	      var previewRef = cookies[previewCookie];
	      var experimentRef = cookies[experimentCookie];
	      form = form.ref(previewRef || experimentRef || this.master());
	    }
	    return form.query(q).submit(callback);
	  },

	  /**
	   * Retrieve the document with the given id
	   * @param {string} id
	   * @param {object} additional parameters
	   * @param {function} callback(err, response)
	   */
	  getByID: function(id, options, callback) {
	    return this.query(Predicates.at('document.id', id), options, function(err, response) {
	      if (callback) {
	        var result = response.results.length > 0 ? response.results[0] : null;
	        callback(err, result);
	      }
	    }).then(function(response){
	      return response && response.results && response.results[0];
	    });
	  },

	  /**
	   * Retrieve multiple documents from an array of id
	   * @param {array} ids
	   * @param {object} additional parameters
	   * @param {function} callback(err, response)
	   */
	  getByIDs: function(ids, options, callback) {
	    return this.query(['in', 'document.id', ids], options, callback);
	  },

	  /**
	   * Retrieve the document with the given uid
	   * @param {string} type the custom type of the document
	   * @param {string} uid
	   * @param {object} additional parameters
	   * @param {function} callback(err, response)
	   */
	  getByUID: function(type, uid, options, callback) {
	    if (typeof options === 'function') {
	      callback = options;
	      options = {};
	    }
	    var self = this;
	    return new Promise(function(resolve, reject) {
	      var cb = function(err, value, xhr) {
	        if (callback) callback(err, value, xhr);
	        if (err) {
	          reject(err);
	        } else {
	          resolve(value);
	        }
	      };
	      self.query(Predicates.at('my.'+type+'.uid', uid), options, function(err, response) {
	        var result = (response && response.results && response.results.length > 0) ? response.results[0] : null;
	        cb(err, result);
	      });
	    });
	  },

	  /**
	   * Retrieve the singleton document with the given type
	   * @param {string} type the custom type of the document
	   * @param {object} additional parameters
	   * @param {function} callback(err, response)
	   */
	  getSingle: function(type, options, callback) {
	    if (typeof options === 'function') {
	      callback = options;
	      options = {};
	    }
	    var self = this;
	    return new Promise(function(resolve, reject) {
	      var cb = function(err, value, xhr) {
	        if (callback) callback(err, value, xhr);
	        if (err) {
	          reject(err);
	        } else {
	          resolve(value);
	        }
	      };
	      self.query(Predicates.at('document.type', type), options, function(err, response) {
	        var result = (response && response.results && response.results.length > 0) ? response.results[0] : null;
	        cb(err, result);
	      });
	    });
	  },

	  /**
	   * Retrieve the document with the given bookmark
	   * @param {string} bookmark name
	   * @param {object} additional parameters
	   * @param {function} callback(err, response)
	   * @returns {Promise}
	   */
	  getBookmark: function(bookmark, options, callback) {
	    return new Promise(function(resolve, reject) {
	      var id = this.bookmarks[bookmark];
	      if (id) {
	        resolve(id);
	      } else {
	        var err = new Error("Error retrieving bookmarked id");
	        if (callback) callback(err);
	        reject(err);
	      }
	    }).then(function(id) {
	      return this.getByID(id, options, callback);
	    });
	  },

	  /**
	   * Return the URL to display a given preview
	   * @param {string} token as received from Prismic server to identify the content to preview
	   * @param {function} linkResolver the link resolver to build URL for your site
	   * @param {string} defaultUrl the URL to default to return if the preview doesn't correspond to a document
	   *                (usually the home page of your site)
	   * @param {function} callback to get the resulting URL (optional, you can get it from the Promise result)
	   * @returns {Promise}
	   */
	  previewSession: function(token, linkResolver, defaultUrl, callback) {
	    var api = this;
	    return new Promise(function(resolve, reject) {
	      var cb = function(err, value, xhr) {
	        if (callback) callback(err, value, xhr);
	        if (err) {
	          reject(err);
	        } else {
	          resolve(value);
	        }
	      };
	      api.requestHandler(token, function (err, result, xhr) {
	        if (err) {
	          cb(err, defaultUrl, xhr);
	          return;
	        }
	        try {
	          var mainDocumentId = result.mainDocument;
	          if (!mainDocumentId) {
	            cb(null, defaultUrl, xhr);
	          } else {
	            api.form("everything").query(Predicates.at("document.id", mainDocumentId)).ref(token).submit(function(err, response) {
	              if (err) {
	                cb(err);
	              }
	              try {
	                if (response.results.length === 0) {
	                  cb(null, defaultUrl, xhr);
	                } else {
	                  cb(null, linkResolver(response.results[0]), xhr);
	                }
	              } catch (e) {
	                cb(e);
	              }
	            });
	          }
	        } catch (e) {
	          cb(e, defaultUrl, xhr);
	        }
	      });
	    });
	  },

	  /**
	   * Fetch a URL corresponding to a query, and parse the response as a Response object
	   */
	  request: function(url, callback) {
	    var api = this;
	    var cacheKey = url + (this.accessToken ? ('#' + this.accessToken) : '');
	    var cache = this.apiCache;
	    cache.get(cacheKey, function (err, value) {
	      if (err || value) {
	        callback(err, api.response(value));
	        return;
	      }
	      api.requestHandler(url, function (err, documents, xhr, ttl) {
	        if (err) {
	          callback(err, null, xhr);
	          return;
	        }

	        if (ttl) {
	          cache.set(cacheKey, documents, ttl, function (err) {
	            callback(err, api.response(documents));
	          });
	        } else {
	          callback(null, api.response(documents));
	        }
	      });
	    });
	  },

	  /**
	   * JSON documents to Response object
	   */
	  response: function(documents){
	    var results = documents.results.map(parseDoc);
	    return new Response(
	      documents.page,
	      documents.results_per_page,
	      documents.results_size,
	      documents.total_results_size,
	      documents.total_pages,
	      documents.next_page,
	      documents.prev_page,
	      results || []);
	  }

	};

	/**
	 * Embodies a submittable RESTful form as described on the API endpoint (as per RESTful standards)
	 * @constructor
	 * @private
	 */
	function Form(name, fields, form_method, rel, enctype, action) {
	  this.name = name;
	  this.fields = fields;
	  this.form_method = form_method;
	  this.rel = rel;
	  this.enctype = enctype;
	  this.action = action;
	}

	Form.prototype = {};

	/**
	 * Parse json as a document
	 *
	 * @returns {Document}
	 */
	var parseDoc = function(json) {
	  var fragments = {};
	  for(var field in json.data[json.type]) {
	    fragments[json.type + '.' + field] = json.data[json.type][field];
	  }

	  var slugs = [];
	  if (json.slugs !== undefined) {
	    for (var i = 0; i < json.slugs.length; i++) {
	      slugs.push(decodeURIComponent(json.slugs[i]));
	    }
	  }

	  return new Document(
	    json.id,
	    json.uid || null,
	    json.type,
	    json.href,
	    json.tags,
	    slugs,
	    json.first_publication_date,
	    json.last_publication_date,
	    fragments
	  );
	};

	/**
	 * Embodies a SearchForm object. To create SearchForm objects that are allowed in the API, please use the API.form() method.
	 * @constructor
	 * @global
	 * @alias SearchForm
	 */
	function SearchForm(api, form, data) {
	  this.api = api;
	  this.form = form;
	  this.data = data || {};

	  for(var field in form.fields) {
	    if(form.fields[field]['default']) {
	      this.data[field] = [form.fields[field]['default']];
	    }
	  }
	}

	SearchForm.prototype = {

	  /**
	   * Set an API call parameter. This will only work if field is a valid field of the
	   * RESTful form in the first place (as described in the /api document); otherwise,
	   * an "Unknown field" error is thrown.
	   * Please prefer using dedicated methods like query(), orderings(), ...
	   *
	   * @param {string} field - The name of the field to set
	   * @param {string} value - The value that gets assigned
	   * @returns {SearchForm} - The SearchForm itself
	   */
	  set: function(field, value) {
	    var fieldDesc = this.form.fields[field];
	    if(!fieldDesc) throw new Error("Unknown field " + field);
	    var values= this.data[field] || [];
	    if(value === '' || value === undefined) {
	      // we must compare value to null because we want to allow 0
	      value = null;
	    }
	    if(fieldDesc.multiple) {
	      if (value) values.push(value);
	    } else {
	      values = value && [value];
	    }
	    this.data[field] = values;
	    return this;
	  },

	  /**
	   * Sets a ref to query on for this SearchForm. This is a mandatory
	   * method to call before calling submit(), and api.form('everything').submit()
	   * will not work.
	   *
	   * @param {Ref} ref - The Ref object defining the ref to query
	   * @returns {SearchForm} - The SearchForm itself
	   */
	  ref: function(ref) {
	    return this.set("ref", ref);
	  },

	  /**
	   * Sets a predicate-based query for this SearchForm. This is where you
	   * paste what you compose in your prismic.io API browser.
	   *
	   * @example form.query(Prismic.Predicates.at("document.id", "foobar"))
	   * @param {string|...array} query - Either a query as a string, or as many predicates as you want. See Prismic.Predicates.
	   * @returns {SearchForm} - The SearchForm itself
	   */
	  query: function(query) {
	    if (typeof query === 'string') {
	      return this.set("q", query);
	    } else {
	      var predicates;
	      if (query.constructor === Array && query.length > 0 && query[0].constructor === Array) {
	        predicates = query;
	      } else {
	        predicates = [].slice.apply(arguments); // Convert to a real JS array
	      }
	      var stringQueries = [];
	      predicates.forEach(function (predicate) {
	        stringQueries.push(Predicates.toQuery(predicate));
	      });
	      return this.query("[" + stringQueries.join("") + "]");
	    }
	  },

	  /**
	   * Sets a page size to query for this SearchForm. This is an optional method.
	   *
	   * @param {number} size - The page size
	   * @returns {SearchForm} - The SearchForm itself
	   */
	  pageSize: function(size) {
	    return this.set("pageSize", size);
	  },

	  /**
	   * Restrict the results document to the specified fields
	   *
	   * @param {string|array} fields - The list of fields, array or comma separated string
	   * @returns {SearchForm} - The SearchForm itself
	   */
	  fetch: function(fields) {
	    if (fields instanceof Array) {
	      fields = fields.join(",");
	    }
	    return this.set("fetch", fields);
	  },

	  /**
	   * Include the requested fields in the DocumentLink instances in the result
	   *
	   * @param {string|array} fields - The list of fields, array or comma separated string
	   * @returns {SearchForm} - The SearchForm itself
	   */
	  fetchLinks: function(fields) {
	    if (fields instanceof Array) {
	      fields = fields.join(",");
	    }
	    return this.set("fetchLinks", fields);
	  },

	  /**
	   * Sets the page number to query for this SearchForm. This is an optional method.
	   *
	   * @param {number} p - The page number
	   * @returns {SearchForm} - The SearchForm itself
	   */
	  page: function(p) {
	    return this.set("page", p);
	  },

	  /**
	   * Sets the orderings to query for this SearchForm. This is an optional method.
	   *
	   * @param {array} orderings - Array of string: list of fields, optionally followed by space and desc. Example: ['my.product.price desc', 'my.product.date']
	   * @returns {SearchForm} - The SearchForm itself
	   */
	  orderings: function(orderings) {
	    if (typeof orderings === 'string') {
	      // Backward compatibility
	      return this.set("orderings", orderings);
	    } else if (!orderings) {
	      // Noop
	      return this;
	    } else {
	      // Normal usage
	      return this.set("orderings", "[" + orderings.join(",") + "]");
	    }
	  },

	  /**
	   * Submits the query, and calls the callback function.
	   *
	   * @param {function} callback - Optional callback function that is called after the query was made,
	   * to which you may pass three parameters: a potential error (null if no problem),
	   * a Response object (containing all the pagination specifics + the array of Docs),
	   * and the XMLHttpRequest
	   */
	  submit: function(callback) {
	    var self = this;
	    var url = this.form.action;

	    if (this.data) {
	      var sep = (url.indexOf('?') > -1 ? '&' : '?');
	      for(var key in this.data) {
	        if (this.data.hasOwnProperty(key)) {
	          var values = this.data[key];
	          if (values) {
	            for (var i = 0; i < values.length; i++) {
	              url += sep + key + '=' + encodeURIComponent(values[i]);
	              sep = '&';
	            }
	          }
	        }
	      }
	    }

	    return new Promise(function(resolve, reject) {
	      self.api.request(url, function(err, value, xhr) {
	        if (callback) callback(err, value, xhr);
	        if (err) reject(err);
	        if (value) resolve(value);
	      });
	    });
	  }
	};

	/**
	 * Embodies the response of a SearchForm query as returned by the API.
	 * It includes all the fields that are useful for pagination (page, total_pages, total_results_size, ...),
	 * as well as the field "results", which is an array of {@link Document} objects, the documents themselves.
	 *
	 * @constructor
	 * @global
	 */
	function Response(page, results_per_page, results_size, total_results_size, total_pages, next_page, prev_page, results) {
	  /**
	   * The current page
	   * @type {number}
	   */
	  this.page = page;
	  /**
	   * The number of results per page
	   * @type {number}
	   */
	  this.results_per_page = results_per_page;
	  /**
	   * The size of the current page
	   * @type {number}
	   */
	  this.results_size = results_size;
	  /**
	   * The total size of results across all pages
	   * @type {number}
	   */
	  this.total_results_size = total_results_size;
	  /**
	   * The total number of pages
	   * @type {number}
	   */
	  this.total_pages = total_pages;
	  /**
	   * The URL of the next page in the API
	   * @type {string}
	   */
	  this.next_page = next_page;
	  /**
	   * The URL of the previous page in the API
	   * @type {string}
	   */
	  this.prev_page = prev_page;
	  /**
	   * Array of {@link Document} for the current page
	   * @type {Array}
	   */
	  this.results = results;
	}

	/**
	 * Embodies a prismic.io ref (a past or future point in time you can query)
	 * @constructor
	 * @global
	 */
	function Ref(ref, label, isMaster, scheduledAt, id) {
	  /**
	   * @field
	   * @description the ID of the ref
	   */
	  this.ref = ref;
	  /**
	   * @field
	   * @description the label of the ref
	   */
	  this.label = label;
	  /**
	   * @field
	   * @description is true if the ref is the master ref
	   */
	  this.isMaster = isMaster;
	  /**
	   * @field
	   * @description the scheduled date of the ref
	   */
	  this.scheduledAt = scheduledAt;
	  /**
	   * @field
	   * @description the name of the ref
	   */
	  this.id = id;
	}
	Ref.prototype = {};
	function globalCache() {
	  var g;
	  if (typeof global == 'object') {
	    g = global; // NodeJS
	  } else {
	    g = window; // browser
	  }
	  if (!g.prismicCache) {
	    g.prismicCache = new ApiCache();
	  }
	  return g.prismicCache;
	}

	module.exports = {
	  experimentCookie: experimentCookie,
	  previewCookie: previewCookie,
	  Api: Api,
	  Form: Form,
	  SearchForm: SearchForm,
	  Ref: Ref,
	  parseDoc: parseDoc
	};

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 39 */
/***/ function(module, exports, __webpack_require__) {

	
	"use strict";

	var LRUCache = __webpack_require__(41);

	/**
	 * Api cache
	 */
	function ApiCache(limit) {
	  this.lru = new LRUCache(limit);
	}

	ApiCache.prototype = {

	  get: function(key, cb) {
	    var maybeEntry = this.lru.get(key);
	    if(maybeEntry && !this.isExpired(key)) {
	      return cb(null, maybeEntry.data);
	    }
	    return cb();
	  },

	  set: function(key, value, ttl, cb) {
	    this.lru.remove(key);
	    this.lru.put(key, {
	      data: value,
	      expiredIn: ttl ? (Date.now() + (ttl * 1000)) : 0
	    });

	    return cb();
	  },

	  isExpired: function(key) {
	    var entry = this.lru.get(key);
	    if(entry) {
	      return entry.expiredIn !== 0 && entry.expiredIn < Date.now();
	    } else {
	      return false;
	    }
	  },

	  remove: function(key, cb) {
	    this.lru.remove(key);
	    return cb();
	  },

	  clear: function(cb) {
	    this.lru.removeAll();
	    return cb();
	  }
	};

	module.exports = ApiCache;


/***/ },
/* 40 */
/***/ function(module, exports) {

	"use strict";

	// Some portions of code from https://github.com/jshttp/cookie

	var decode = decodeURIComponent;

	function tryDecode(str, decode) {
	  try {
	    return decode(str);
	  } catch (e) {
	    return str;
	  }
	}

	function parse(str, options) {
	  if (typeof str !== 'string') {
	    throw new TypeError('argument str must be a string');
	  }

	  var obj = {};
	  var opt = options || {};
	  var pairs = str.split(/; */);
	  var dec = opt.decode || decode;

	  pairs.forEach(function(pair) {
	    var eq_idx = pair.indexOf('=');

	    // skip things that don't look like key=value
	    if (eq_idx < 0) {
	      return;
	    }

	    var key = pair.substr(0, eq_idx).trim();
	    var val = pair.substr(++eq_idx, pair.length).trim();

	    // quoted values
	    if ('"' == val[0]) {
	      val = val.slice(1, -1);
	    }

	    // only assign once
	    if (undefined == obj[key]) {
	      obj[key] = tryDecode(val, dec);
	    }
	  });

	  return obj;
	}

	module.exports = {
	  parse: parse
	};



/***/ },
/* 41 */
/***/ function(module, exports) {

	
	/**
	 * A doubly linked list-based Least Recently Used (LRU) cache. Will keep most
	 * recently used items while discarding least recently used items when its limit
	 * is reached.
	 *
	 * Licensed under MIT. Copyright (c) 2010 Rasmus Andersson <http://hunch.se/>
	 * See README.md for details.
	 *
	 * Illustration of the design:
	 *
	 *       entry             entry             entry             entry
	 *       ______            ______            ______            ______
	 *      | head |.newer => |      |.newer => |      |.newer => | tail |
	 *      |  A   |          |  B   |          |  C   |          |  D   |
	 *      |______| <= older.|______| <= older.|______| <= older.|______|
	 *
	 *  removed  <--  <--  <--  <--  <--  <--  <--  <--  <--  <--  <--  added
	 */
	function LRUCache (limit) {
	  // Current size of the cache. (Read-only).
	  this.size = 0;
	  // Maximum number of items this cache can hold.
	  this.limit = limit;
	  this._keymap = {};
	}

	/**
	 * Put <value> into the cache associated with <key>. Returns the entry which was
	 * removed to make room for the new entry. Otherwise undefined is returned
	 * (i.e. if there was enough room already).
	 */
	LRUCache.prototype.put = function(key, value) {
	  var entry = {key:key, value:value};
	  // Note: No protection agains replacing, and thus orphan entries. By design.
	  this._keymap[key] = entry;
	  if (this.tail) {
	    // link previous tail to the new tail (entry)
	    this.tail.newer = entry;
	    entry.older = this.tail;
	  } else {
	    // we're first in -- yay
	    this.head = entry;
	  }
	  // add new entry to the end of the linked list -- it's now the freshest entry.
	  this.tail = entry;
	  if (this.size === this.limit) {
	    // we hit the limit -- remove the head
	    return this.shift();
	  } else {
	    // increase the size counter
	    this.size++;
	  }
	  return null;
	};

	/**
	 * Purge the least recently used (oldest) entry from the cache. Returns the
	 * removed entry or undefined if the cache was empty.
	 *
	 * If you need to perform any form of finalization of purged items, this is a
	 * good place to do it. Simply override/replace this function:
	 *
	 *   var c = new LRUCache(123);
	 *   c.shift = function() {
	 *     var entry = LRUCache.prototype.shift.call(this);
	 *     doSomethingWith(entry);
	 *     return entry;
	 *   }
	 */
	LRUCache.prototype.shift = function() {
	  // todo: handle special case when limit == 1
	  var entry = this.head;
	  if (entry) {
	    if (this.head.newer) {
	      this.head = this.head.newer;
	      this.head.older = undefined;
	    } else {
	      this.head = undefined;
	    }
	    // Remove last strong reference to <entry> and remove links from the purged
	    // entry being returned:
	    entry.newer = entry.older = undefined;
	    // delete is slow, but we need to do this to avoid uncontrollable growth:
	    delete this._keymap[entry.key];
	  }
	  return entry;
	};

	/**
	 * Get and register recent use of <key>. Returns the value associated with <key>
	 * or undefined if not in cache.
	 */
	LRUCache.prototype.get = function(key, returnEntry) {
	  // First, find our cache entry
	  var entry = this._keymap[key];
	  if (entry === undefined) return null; // Not cached. Sorry.
	  // As <key> was found in the cache, register it as being requested recently
	  if (entry === this.tail) {
	    // Already the most recenlty used entry, so no need to update the list
	    return returnEntry ? entry : entry.value;
	  }
	  // HEAD--------------TAIL
	  //   <.older   .newer>
	  //  <--- add direction --
	  //   A  B  C  <D>  E
	  if (entry.newer) {
	    if (entry === this.head)
	      this.head = entry.newer;
	    entry.newer.older = entry.older; // C <-- E.
	  }
	  if (entry.older)
	    entry.older.newer = entry.newer; // C. --> E
	  entry.newer = undefined; // D --x
	  entry.older = this.tail; // D. --> E
	  if (this.tail)
	    this.tail.newer = entry; // E. <-- D
	  this.tail = entry;
	  return returnEntry ? entry : entry.value;
	};

	// ----------------------------------------------------------------------------
	// Following code is optional and can be removed without breaking the core
	// functionality.

	/**
	 * Check if <key> is in the cache without registering recent use. Feasible if
	 * you do not want to chage the state of the cache, but only "peek" at it.
	 * Returns the entry associated with <key> if found, or undefined if not found.
	 */
	LRUCache.prototype.find = function(key) {
	  return this._keymap[key];
	};

	/**
	 * Update the value of entry with <key>. Returns the old value, or undefined if
	 * entry was not in the cache.
	 */
	LRUCache.prototype.set = function(key, value) {
	  var oldvalue, entry = this.get(key, true);
	  if (entry) {
	    oldvalue = entry.value;
	    entry.value = value;
	  } else {
	    oldvalue = this.put(key, value);
	    if (oldvalue) oldvalue = oldvalue.value;
	  }
	  return oldvalue;
	};

	/**
	 * Remove entry <key> from cache and return its value. Returns undefined if not
	 * found.
	 */
	LRUCache.prototype.remove = function(key) {
	  var entry = this._keymap[key];
	  if (!entry) return null;
	  delete this._keymap[entry.key]; // need to do delete unfortunately
	  if (entry.newer && entry.older) {
	    // relink the older entry with the newer entry
	    entry.older.newer = entry.newer;
	    entry.newer.older = entry.older;
	  } else if (entry.newer) {
	    // remove the link to us
	    entry.newer.older = undefined;
	    // link the newer entry to head
	    this.head = entry.newer;
	  } else if (entry.older) {
	    // remove the link to us
	    entry.older.newer = undefined;
	    // link the newer entry to head
	    this.tail = entry.older;
	  } else { // if(entry.older === undefined && entry.newer === undefined) {
	    this.head = this.tail = undefined;
	  }

	  this.size--;
	  return entry.value;
	};

	/** Removes all entries */
	LRUCache.prototype.removeAll = function() {
	  // This should be safe, as we never expose strong refrences to the outside
	  this.head = this.tail = undefined;
	  this.size = 0;
	  this._keymap = {};
	};

	/**
	 * Return an array containing all keys of entries stored in the cache object, in
	 * arbitrary order.
	 */
	if (typeof Object.keys === 'function') {
	  LRUCache.prototype.keys = function() { return Object.keys(this._keymap); };
	} else {
	  LRUCache.prototype.keys = function() {
	    var keys = [];
	    for (var k in this._keymap) keys.push(k);
	    return keys;
	  };
	}

	/**
	 * Call `fun` for each entry. Starting with the newest entry if `desc` is a true
	 * value, otherwise starts with the oldest (head) enrty and moves towards the
	 * tail.
	 *
	 * `fun` is called with 3 arguments in the context `context`:
	 *   `fun.call(context, Object key, Object value, LRUCache self)`
	 */
	LRUCache.prototype.forEach = function(fun, context, desc) {
	  var entry;
	  if (context === true) { desc = true; context = undefined; }
	  else if (typeof context !== 'object') context = this;
	  if (desc) {
	    entry = this.tail;
	    while (entry) {
	      fun.call(context, entry.key, entry.value, this);
	      entry = entry.older;
	    }
	  } else {
	    entry = this.head;
	    while (entry) {
	      fun.call(context, entry.key, entry.value, this);
	      entry = entry.newer;
	    }
	  }
	};

	/** Returns a JSON (array) representation */
	LRUCache.prototype.toJSON = function() {
	  var s = [], entry = this.head;
	  while (entry) {
	    s.push({key:entry.key.toJSON(), value:entry.value.toJSON()});
	    entry = entry.newer;
	  }
	  return s;
	};

	/** Returns a String representation */
	LRUCache.prototype.toString = function() {
	  var s = '', entry = this.head;
	  while (entry) {
	    s += String(entry.key)+':'+entry.value;
	    entry = entry.newer;
	    if (entry)
	      s += ' < ';
	  }
	  return s;
	};

	module.exports = LRUCache;


/***/ },
/* 42 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	var experiments = __webpack_require__(19),
	    Predicates = __webpack_require__(20),
	    api = __webpack_require__(38),
	    Fragments = __webpack_require__(1),
	    QuickRoutes = __webpack_require__(43),
	    documents = __webpack_require__(11);

	var Api = api.Api,
	    Experiments = experiments.Experiments;

	/**
	 * The kit's main entry point; initialize your API like this: Prismic.api(url, {accessToken: "XXX"})
	 *
	 * @global
	 * @alias Api
	 * @constructor
	 * @param {string} url - The mandatory URL of the prismic.io API endpoint (like: https://lesbonneschoses.prismic.io/api)
	 * @param {function} options.callback - Optional callback function that is called after the API was retrieved, which will be called with two parameters: a potential error object and the API object
	 * @param {string} options.accessToken - The accessToken, necessary if the API is set as private
	 * @param {string} options.req - The NodeJS request (only use in a NodeJS context)
	 * @param {function} options.requestHandler - Environment specific HTTP request handling function
	 * @param {object} options.apiCache - A cache object with get/set functions for caching API responses
	 * @param {int} options.apiDataTTL - How long (in seconds) to cache data used by the client to make calls (e.g. refs). Defaults to 5 seconds
	 * @returns {Api} - The Api object that can be manipulated
	 */
	function getApi(url, options) {
	  options = options || {};
	  if (typeof arguments[1] == 'function') {
	    // Legacy (1) the second argument is the callback
	    options = {
	      "complete": arguments[1],
	      "accessToken": arguments[2],
	      "requestHandler": arguments[3],
	      "apiCache": arguments[4],
	      "apiDataTTL": arguments[5]
	    };
	  } else if (typeof arguments[1] == 'string') {
	    // Legacy (2) the second argument is the accessToken
	    options = {
	      "accessToken": arguments[1],
	      "requestHandler": arguments[2],
	      "apiCache": arguments[3],
	      "apiDataTTL": arguments[4]
	    };
	  }
	  var api = new Api(url, options || {});
	  //Use cached api data if available
	  return new Promise(function(resolve, reject) {
	    var cb = function(err, value, xhr) {
	      if (options.complete) options.complete(err, value, xhr);
	      if (err) {
	        reject(err);
	      } else {
	        resolve(value);
	      }
	    };
	    api.get(function (err, data) {
	      if (!err && data) {
	        api.data = data;
	        api.bookmarks = data.bookmarks;
	        api.experiments = new Experiments(data.experiments);
	      }

	      cb(err, api);
	    });

	    return api;
	  });
	}

	module.exports = {
	  experimentCookie: api.experimentCookie,
	  previewCookie: api.previewCookie,
	  Document: documents.Document,
	  SearchForm: api.SearchForm,
	  Form: api.Form,
	  Experiments: Experiments,
	  Predicates: Predicates,
	  Fragments: Fragments,
	  QuickRoutes: QuickRoutes,
	  api: getApi,
	  Api: getApi, // Backward compatibility
	  parseDoc: api.parseDoc
	};

	module.exports.Prismic = module.exports; // Backward compatibility


/***/ },
/* 43 */
/***/ function(module, exports) {

	
	var Kind = {
	  Dynamic: 'dynamic',
	  Static: 'static'
	};

	var Condition = {
	  ID: 'withId',
	  UID: 'withUid',
	  Singleton: 'singleton'
	};

	function toUrl(route, doc) {
	  if(!route.fragments || route.fragments.length == 0) {
	    return '/';
	  } else {
	    return route.fragments.reduce(function (acc, f) {
	      switch(f.kind) {
	      case Kind.Dynamic:
	        if (doc)
	          return acc + '/' + getFragmentValue(f, doc);
	        else
	          return acc + '/:' + toKey(f.key);

	      case Kind.Static:
	        return acc + '/' + f.value;

	      default:
	        return acc;
	      }
	    }, '');
	  }
	}

	function getFragmentValue(fragment, doc) {
	  var steps = fragment.key.split('.');
	  if (steps[0] == doc.type) {
	    switch(steps[1]) {
	    case 'uid':
	      return doc.uid;
	    case 'id':
	      return doc.id;
	    default:
	      throw Error("Unsupported dynamic fragment: " + fragment);
	    }
	  } else {
	    throw Error("Wrong doc type error: got " + doc.type + ", expected " + steps[0]);
	  }
	}


	function toKey(dotty) {
	  return dotty.split('.').join('_');
	}

	function fetchData(req, res, fetchers) {
	  return new Promise(function(resolve, reject) {
	    var pData = fetchers.map(function(f) {
	      return fetcherAction(f, req)
	        .then(function(doc) {
	          return { name: f.name, doc: doc };
	        })
	        .catch(function(err) {
	          reject(err);
	        });
	    });

	    Promise.all(pData).then(function(results) {
	      var data = {};
	      results.forEach(function(result) {
	        data[result.name] = result.doc;
	      });
	      resolve(data);
	    });
	  });
	}

	function fetcherAction(f, req) {
	  switch(f.condition.kind) {
	  case Condition.ID:
	    return req.prismic.api.getByID(f.mask, req.params[toKey(f.condition.key)]);

	  case Condition.UID:
	    return req.prismic.api.getByUID(f.mask, req.params[toKey(f.condition.key)]);

	  case Condition.Singleton:
	    return req.prismic.api.getSingle(f.mask);

	  default:
	    return Promise.reject(new Error("Unknown fetcher condition: " + f.condition.kind));
	  }
	}



	function makeLinkResolver(dynRoutes, linkResolver) {
	  return function(doc) {
	    var docRoute = dynRoutes.find(function(dr) {
	      return dr.forMask === doc.type;
	    });
	    if(docRoute) return toUrl(docRoute, doc);
	    else return linkResolver(doc);
	  };
	}

	module.exports = {
	  toUrl: toUrl,
	  makeLinkResolver: makeLinkResolver,
	  fetchData: fetchData
	};


/***/ },
/* 44 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {
	"use strict";

	var createError = function(status, message) {
	  var err = new Error(message);
	  err.status = status;
	  return err;
	};

	// -- Request handlers

	var ajaxRequest = (function() {
	  if(typeof XMLHttpRequest != 'undefined' && 'withCredentials' in new XMLHttpRequest()) {
	    return function(url, callback) {

	      var xhr = new XMLHttpRequest();

	      // Called on success
	      var resolve = function() {
	        var ttl, cacheControl = /max-age\s*=\s*(\d+)/.exec(
	          xhr.getResponseHeader('Cache-Control'));
	        if (cacheControl && cacheControl.length > 1) {
	          ttl = parseInt(cacheControl[1], 10);
	        }
	        callback(null, JSON.parse(xhr.responseText), xhr, ttl);
	      };

	      // Called on error
	      var reject = function() {
	        var status = xhr.status;
	        callback(createError(status, "Unexpected status code [" + status + "] on URL "+url), null, xhr);
	      };

	      // Bind the XHR finished callback
	      xhr.onreadystatechange = function() {
	        if (xhr.readyState === 4) {
	          if(xhr.status && xhr.status == 200) {
	            resolve();
	          } else {
	            reject();
	          }
	        }
	      };

	      // Open the XHR
	      xhr.open('GET', url, true);

	      // Kit version (can't override the user-agent client side)
	      // xhr.setRequestHeader("X-Prismic-User-Agent", "Prismic-javascript-kit/%VERSION%".replace("%VERSION%", Global.Prismic.version));

	      // Json request
	      xhr.setRequestHeader('Accept', 'application/json');

	      // Send the XHR
	      xhr.send();
	    };
	  }
	  return null;
	});

	var xdomainRequest = (function() {
	  if(typeof XDomainRequest != 'undefined') { // Internet Explorer
	    return function(url, callback) {

	      var xdr = new XDomainRequest();

	      // Called on success
	      var resolve = function() {
	        callback(null, JSON.parse(xdr.responseText), xdr, 0);
	      };

	      // Called on error
	      var reject = function(msg) {
	        callback(new Error(msg), null, xdr);
	      };

	      // Bind the XDR finished callback
	      xdr.onload = function() {
	        resolve(xdr);
	      };

	      // Bind the XDR error callback
	      xdr.onerror = function() {
	        reject("Unexpected status code on URL " + url);
	      };

	      // Open the XHR
	      xdr.open('GET', url, true);

	      // Bind the XDR timeout callback
	      xdr.ontimeout = function () {
	        reject("Request timeout");
	      };

	      // Empty callback. IE sometimes abort the reqeust if
	      // this is not present
	      xdr.onprogress = function () { };

	      xdr.send();
	    };
	  }
	  return null;
	});


	// The experimental fetch API, required by React Native for example.
	// We still use browser requests by default because there could be an
	// incomplete polyfill in the context (lacking CORS for example)
	var fetchRequest = (function() {
	  if (typeof fetch == "function") {
	    var pjson = __webpack_require__(18);
	    return function(requestUrl, callback) {
	      fetch(requestUrl, {
	        headers: {
	          'Accept': 'application/json',
	          'User-Agent': 'Prismic-javascript-kit/' + pjson.version + " NodeJS/" + process.version
	        }
	      }).then(function (response) {
	        if (~~(response.status / 100 != 2)) {
	          throw new createError(response.status, "Unexpected status code [" + response.status + "] on URL " + requestUrl);
	        } else {
	          return response.json().then(function(json) {
	            return {
	              response: response,
	              json: json
	            };
	          });
	        }
	      }).then(function(next) {
	        var response = next.response;
	        var json = next.json;
	        var cacheControl = response.headers['cache-control'];
	        var ttl = cacheControl && /max-age=(\d+)/.test(cacheControl) ? parseInt(/max-age=(\d+)/.exec(cacheControl)[1], 10) : undefined;
	        callback(null, json, response, ttl);
	      }).catch(function (error) {
	        callback(error);
	      });
	    };
	  }
	  return null;
	});

	var nodeJSRequest = (function() {
	  if("function" == 'function' && __webpack_require__(17)) {
	    var http = __webpack_require__(17),
	        https = __webpack_require__(35),
	        url = __webpack_require__(25),
	        pjson = __webpack_require__(18);

	    return function(requestUrl, callback) {
	      var parsed = url.parse(requestUrl),
	          h = parsed.protocol == 'https:' ? https : http,
	          options = {
	            hostname: parsed.hostname,
	            path: parsed.path,
	            query: parsed.query,
	            headers: {
	              'Accept': 'application/json',
	              'User-Agent': 'Prismic-javascript-kit/' + pjson.version + " NodeJS/" + process.version
	            }
	          };

	      if (!requestUrl) {
	        var e = new Error('dummy');
	        var stack = e.stack.replace(/^[^\(]+?[\n$]/gm, '')
	              .replace(/^\s+at\s+/gm, '')
	              .replace(/^Object.<anonymous>\s*\(/gm, '{anonymous}()@')
	              .split('\n');
	        console.log(stack);
	      }
	      var request = h.get(options, function(response) {
	        if (response.statusCode && response.statusCode == 200) {
	          var jsonStr = '';

	          response.setEncoding('utf8');
	          response.on('data', function (chunk) {
	            jsonStr += chunk;
	          });

	          response.on('end', function () {
	            var json;
	            try {
	              json = JSON.parse(jsonStr);
	            } catch (ex) {
	              console.log("Failed to parse json: " + jsonStr, ex);
	            }
	            var cacheControl = response.headers['cache-control'];
	            var ttl = cacheControl && /max-age=(\d+)/.test(cacheControl) ? parseInt(/max-age=(\d+)/.exec(cacheControl)[1], 10) : undefined;

	            callback(null, json, response, ttl);
	          });
	        } else {
	          callback(createError(response.statusCode, "Unexpected status code [" + response.statusCode + "] on URL "+requestUrl), null, response);
	        }
	      });

	      // properly handle timeouts
	      request.on('error', function(err) {
	        callback(new Error("Unexpected error on URL "+requestUrl), null, err);
	      });


	    };
	  }
	  return null;
	});

	// Number of maximum simultaneous connections to the prismic server
	var MAX_CONNECTIONS = 20;
	// Number of requests currently running (capped by MAX_CONNECTIONS)
	var running = 0;
	// Requests in queue
	var queue = [];

	var processQueue = function() {
	  if (queue.length === 0 || running >= MAX_CONNECTIONS) {
	    return;
	  }
	  running++;
	  var next = queue.shift();
	  var fn = ajaxRequest() || xdomainRequest() || fetchRequest() || nodeJSRequest() ||
	        (function() { throw new Error("No request handler available (tried XMLHttpRequest, fetch & NodeJS)"); })();
	  fn.call(this, next.url, function(error, result, xhr, ttl) {
	    running--;
	    next.callback(error, result, xhr, ttl);
	    processQueue();
	  });
	};

	var request = function (url, callback) {
	  queue.push({
	    'url': url,
	    'callback': callback
	  });
	  processQueue();
	};

	module.exports = {
	  MAX_CONNECTIONS: MAX_CONNECTIONS, // Number of maximum simultaneous connections to the prismic server
	  request: request
	};

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(3)))

/***/ },
/* 45 */
/***/ function(module, exports) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	'use strict';

	// If obj.hasOwnProperty has been overridden, then calling
	// obj.hasOwnProperty(prop) will break.
	// See: https://github.com/joyent/node/issues/1707
	function hasOwnProperty(obj, prop) {
	  return Object.prototype.hasOwnProperty.call(obj, prop);
	}

	module.exports = function(qs, sep, eq, options) {
	  sep = sep || '&';
	  eq = eq || '=';
	  var obj = {};

	  if (typeof qs !== 'string' || qs.length === 0) {
	    return obj;
	  }

	  var regexp = /\+/g;
	  qs = qs.split(sep);

	  var maxKeys = 1000;
	  if (options && typeof options.maxKeys === 'number') {
	    maxKeys = options.maxKeys;
	  }

	  var len = qs.length;
	  // maxKeys <= 0 means that we should not limit keys count
	  if (maxKeys > 0 && len > maxKeys) {
	    len = maxKeys;
	  }

	  for (var i = 0; i < len; ++i) {
	    var x = qs[i].replace(regexp, '%20'),
	        idx = x.indexOf(eq),
	        kstr, vstr, k, v;

	    if (idx >= 0) {
	      kstr = x.substr(0, idx);
	      vstr = x.substr(idx + 1);
	    } else {
	      kstr = x;
	      vstr = '';
	    }

	    k = decodeURIComponent(kstr);
	    v = decodeURIComponent(vstr);

	    if (!hasOwnProperty(obj, k)) {
	      obj[k] = v;
	    } else if (Array.isArray(obj[k])) {
	      obj[k].push(v);
	    } else {
	      obj[k] = [obj[k], v];
	    }
	  }

	  return obj;
	};


/***/ },
/* 46 */
/***/ function(module, exports) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	'use strict';

	var stringifyPrimitive = function(v) {
	  switch (typeof v) {
	    case 'string':
	      return v;

	    case 'boolean':
	      return v ? 'true' : 'false';

	    case 'number':
	      return isFinite(v) ? v : '';

	    default:
	      return '';
	  }
	};

	module.exports = function(obj, sep, eq, name) {
	  sep = sep || '&';
	  eq = eq || '=';
	  if (obj === null) {
	    obj = undefined;
	  }

	  if (typeof obj === 'object') {
	    return Object.keys(obj).map(function(k) {
	      var ks = encodeURIComponent(stringifyPrimitive(k)) + eq;
	      if (Array.isArray(obj[k])) {
	        return obj[k].map(function(v) {
	          return ks + encodeURIComponent(stringifyPrimitive(v));
	        }).join(sep);
	      } else {
	        return ks + encodeURIComponent(stringifyPrimitive(obj[k]));
	      }
	    }).join(sep);

	  }

	  if (!name) return '';
	  return encodeURIComponent(stringifyPrimitive(name)) + eq +
	         encodeURIComponent(stringifyPrimitive(obj));
	};


/***/ },
/* 47 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.decode = exports.parse = __webpack_require__(45);
	exports.encode = exports.stringify = __webpack_require__(46);


/***/ },
/* 48 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(4)


/***/ },
/* 49 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var Buffer = __webpack_require__(6).Buffer;
	/*<replacement>*/
	var bufferShim = __webpack_require__(10);
	/*</replacement>*/

	module.exports = BufferList;

	function BufferList() {
	  this.head = null;
	  this.tail = null;
	  this.length = 0;
	}

	BufferList.prototype.push = function (v) {
	  var entry = { data: v, next: null };
	  if (this.length > 0) this.tail.next = entry;else this.head = entry;
	  this.tail = entry;
	  ++this.length;
	};

	BufferList.prototype.unshift = function (v) {
	  var entry = { data: v, next: this.head };
	  if (this.length === 0) this.tail = entry;
	  this.head = entry;
	  ++this.length;
	};

	BufferList.prototype.shift = function () {
	  if (this.length === 0) return;
	  var ret = this.head.data;
	  if (this.length === 1) this.head = this.tail = null;else this.head = this.head.next;
	  --this.length;
	  return ret;
	};

	BufferList.prototype.clear = function () {
	  this.head = this.tail = null;
	  this.length = 0;
	};

	BufferList.prototype.join = function (s) {
	  if (this.length === 0) return '';
	  var p = this.head;
	  var ret = '' + p.data;
	  while (p = p.next) {
	    ret += s + p.data;
	  }return ret;
	};

	BufferList.prototype.concat = function (n) {
	  if (this.length === 0) return bufferShim.alloc(0);
	  if (this.length === 1) return this.head.data;
	  var ret = bufferShim.allocUnsafe(n >>> 0);
	  var p = this.head;
	  var i = 0;
	  while (p) {
	    p.data.copy(ret, i);
	    i += p.data.length;
	    p = p.next;
	  }
	  return ret;
	};

/***/ },
/* 50 */
/***/ function(module, exports) {

	var toString = {}.toString;

	module.exports = Array.isArray || function (arr) {
	  return toString.call(arr) == '[object Array]';
	};


/***/ },
/* 51 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(21)


/***/ },
/* 52 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(13)


/***/ },
/* 53 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(14)


/***/ },
/* 54 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global, process) {(function (global, undefined) {
	    "use strict";

	    if (global.setImmediate) {
	        return;
	    }

	    var nextHandle = 1; // Spec says greater than zero
	    var tasksByHandle = {};
	    var currentlyRunningATask = false;
	    var doc = global.document;
	    var registerImmediate;

	    function setImmediate(callback) {
	      // Callback can either be a function or a string
	      if (typeof callback !== "function") {
	        callback = new Function("" + callback);
	      }
	      // Copy function arguments
	      var args = new Array(arguments.length - 1);
	      for (var i = 0; i < args.length; i++) {
	          args[i] = arguments[i + 1];
	      }
	      // Store and register the task
	      var task = { callback: callback, args: args };
	      tasksByHandle[nextHandle] = task;
	      registerImmediate(nextHandle);
	      return nextHandle++;
	    }

	    function clearImmediate(handle) {
	        delete tasksByHandle[handle];
	    }

	    function run(task) {
	        var callback = task.callback;
	        var args = task.args;
	        switch (args.length) {
	        case 0:
	            callback();
	            break;
	        case 1:
	            callback(args[0]);
	            break;
	        case 2:
	            callback(args[0], args[1]);
	            break;
	        case 3:
	            callback(args[0], args[1], args[2]);
	            break;
	        default:
	            callback.apply(undefined, args);
	            break;
	        }
	    }

	    function runIfPresent(handle) {
	        // From the spec: "Wait until any invocations of this algorithm started before this one have completed."
	        // So if we're currently running a task, we'll need to delay this invocation.
	        if (currentlyRunningATask) {
	            // Delay by doing a setTimeout. setImmediate was tried instead, but in Firefox 7 it generated a
	            // "too much recursion" error.
	            setTimeout(runIfPresent, 0, handle);
	        } else {
	            var task = tasksByHandle[handle];
	            if (task) {
	                currentlyRunningATask = true;
	                try {
	                    run(task);
	                } finally {
	                    clearImmediate(handle);
	                    currentlyRunningATask = false;
	                }
	            }
	        }
	    }

	    function installNextTickImplementation() {
	        registerImmediate = function(handle) {
	            process.nextTick(function () { runIfPresent(handle); });
	        };
	    }

	    function canUsePostMessage() {
	        // The test against `importScripts` prevents this implementation from being installed inside a web worker,
	        // where `global.postMessage` means something completely different and can't be used for this purpose.
	        if (global.postMessage && !global.importScripts) {
	            var postMessageIsAsynchronous = true;
	            var oldOnMessage = global.onmessage;
	            global.onmessage = function() {
	                postMessageIsAsynchronous = false;
	            };
	            global.postMessage("", "*");
	            global.onmessage = oldOnMessage;
	            return postMessageIsAsynchronous;
	        }
	    }

	    function installPostMessageImplementation() {
	        // Installs an event handler on `global` for the `message` event: see
	        // * https://developer.mozilla.org/en/DOM/window.postMessage
	        // * http://www.whatwg.org/specs/web-apps/current-work/multipage/comms.html#crossDocumentMessages

	        var messagePrefix = "setImmediate$" + Math.random() + "$";
	        var onGlobalMessage = function(event) {
	            if (event.source === global &&
	                typeof event.data === "string" &&
	                event.data.indexOf(messagePrefix) === 0) {
	                runIfPresent(+event.data.slice(messagePrefix.length));
	            }
	        };

	        if (global.addEventListener) {
	            global.addEventListener("message", onGlobalMessage, false);
	        } else {
	            global.attachEvent("onmessage", onGlobalMessage);
	        }

	        registerImmediate = function(handle) {
	            global.postMessage(messagePrefix + handle, "*");
	        };
	    }

	    function installMessageChannelImplementation() {
	        var channel = new MessageChannel();
	        channel.port1.onmessage = function(event) {
	            var handle = event.data;
	            runIfPresent(handle);
	        };

	        registerImmediate = function(handle) {
	            channel.port2.postMessage(handle);
	        };
	    }

	    function installReadyStateChangeImplementation() {
	        var html = doc.documentElement;
	        registerImmediate = function(handle) {
	            // Create a <script> element; its readystatechange event will be fired asynchronously once it is inserted
	            // into the document. Do so, thus queuing up the task. Remember to clean up once it's been called.
	            var script = doc.createElement("script");
	            script.onreadystatechange = function () {
	                runIfPresent(handle);
	                script.onreadystatechange = null;
	                html.removeChild(script);
	                script = null;
	            };
	            html.appendChild(script);
	        };
	    }

	    function installSetTimeoutImplementation() {
	        registerImmediate = function(handle) {
	            setTimeout(runIfPresent, 0, handle);
	        };
	    }

	    // If supported, we should attach to the prototype of global, since that is where setTimeout et al. live.
	    var attachTo = Object.getPrototypeOf && Object.getPrototypeOf(global);
	    attachTo = attachTo && attachTo.setTimeout ? attachTo : global;

	    // Don't get fooled by e.g. browserify environments.
	    if ({}.toString.call(global.process) === "[object process]") {
	        // For Node.js before 0.9
	        installNextTickImplementation();

	    } else if (canUsePostMessage()) {
	        // For non-IE10 modern browsers
	        installPostMessageImplementation();

	    } else if (global.MessageChannel) {
	        // For web workers, where supported
	        installMessageChannelImplementation();

	    } else if (doc && "onreadystatechange" in doc.createElement("script")) {
	        // For IE 6–8
	        installReadyStateChangeImplementation();

	    } else {
	        // For older browsers
	        installSetTimeoutImplementation();
	    }

	    attachTo.setImmediate = setImmediate;
	    attachTo.clearImmediate = clearImmediate;
	}(typeof self === "undefined" ? typeof global === "undefined" ? this : global : self));

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }()), __webpack_require__(3)))

/***/ },
/* 55 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global, process) {var capability = __webpack_require__(23)
	var inherits = __webpack_require__(2)
	var response = __webpack_require__(56)
	var stream = __webpack_require__(15)
	var toArrayBuffer = __webpack_require__(58)

	var IncomingMessage = response.IncomingMessage
	var rStates = response.readyStates

	function decideMode (preferBinary, useFetch) {
		if (capability.fetch && useFetch) {
			return 'fetch'
		} else if (capability.mozchunkedarraybuffer) {
			return 'moz-chunked-arraybuffer'
		} else if (capability.msstream) {
			return 'ms-stream'
		} else if (capability.arraybuffer && preferBinary) {
			return 'arraybuffer'
		} else if (capability.vbArray && preferBinary) {
			return 'text:vbarray'
		} else {
			return 'text'
		}
	}

	var ClientRequest = module.exports = function (opts) {
		var self = this
		stream.Writable.call(self)

		self._opts = opts
		self._body = []
		self._headers = {}
		if (opts.auth)
			self.setHeader('Authorization', 'Basic ' + new Buffer(opts.auth).toString('base64'))
		Object.keys(opts.headers).forEach(function (name) {
			self.setHeader(name, opts.headers[name])
		})

		var preferBinary
		var useFetch = true
		if (opts.mode === 'disable-fetch' || 'timeout' in opts) {
			// If the use of XHR should be preferred and includes preserving the 'content-type' header.
			// Force XHR to be used since the Fetch API does not yet support timeouts.
			useFetch = false
			preferBinary = true
		} else if (opts.mode === 'prefer-streaming') {
			// If streaming is a high priority but binary compatibility and
			// the accuracy of the 'content-type' header aren't
			preferBinary = false
		} else if (opts.mode === 'allow-wrong-content-type') {
			// If streaming is more important than preserving the 'content-type' header
			preferBinary = !capability.overrideMimeType
		} else if (!opts.mode || opts.mode === 'default' || opts.mode === 'prefer-fast') {
			// Use binary if text streaming may corrupt data or the content-type header, or for speed
			preferBinary = true
		} else {
			throw new Error('Invalid value for opts.mode')
		}
		self._mode = decideMode(preferBinary, useFetch)

		self.on('finish', function () {
			self._onFinish()
		})
	}

	inherits(ClientRequest, stream.Writable)

	ClientRequest.prototype.setHeader = function (name, value) {
		var self = this
		var lowerName = name.toLowerCase()
		// This check is not necessary, but it prevents warnings from browsers about setting unsafe
		// headers. To be honest I'm not entirely sure hiding these warnings is a good thing, but
		// http-browserify did it, so I will too.
		if (unsafeHeaders.indexOf(lowerName) !== -1)
			return

		self._headers[lowerName] = {
			name: name,
			value: value
		}
	}

	ClientRequest.prototype.getHeader = function (name) {
		var self = this
		return self._headers[name.toLowerCase()].value
	}

	ClientRequest.prototype.removeHeader = function (name) {
		var self = this
		delete self._headers[name.toLowerCase()]
	}

	ClientRequest.prototype._onFinish = function () {
		var self = this

		if (self._destroyed)
			return
		var opts = self._opts

		var headersObj = self._headers
		var body
		if (opts.method === 'POST' || opts.method === 'PUT' || opts.method === 'PATCH' || opts.method === 'MERGE') {
			if (capability.blobConstructor) {
				body = new global.Blob(self._body.map(function (buffer) {
					return toArrayBuffer(buffer)
				}), {
					type: (headersObj['content-type'] || {}).value || ''
				})
			} else {
				// get utf8 string
				body = Buffer.concat(self._body).toString()
			}
		}

		if (self._mode === 'fetch') {
			var headers = Object.keys(headersObj).map(function (name) {
				return [headersObj[name].name, headersObj[name].value]
			})

			global.fetch(self._opts.url, {
				method: self._opts.method,
				headers: headers,
				body: body,
				mode: 'cors',
				credentials: opts.withCredentials ? 'include' : 'same-origin'
			}).then(function (response) {
				self._fetchResponse = response
				self._connect()
			}, function (reason) {
				self.emit('error', reason)
			})
		} else {
			var xhr = self._xhr = new global.XMLHttpRequest()
			try {
				xhr.open(self._opts.method, self._opts.url, true)
			} catch (err) {
				process.nextTick(function () {
					self.emit('error', err)
				})
				return
			}

			// Can't set responseType on really old browsers
			if ('responseType' in xhr)
				xhr.responseType = self._mode.split(':')[0]

			if ('withCredentials' in xhr)
				xhr.withCredentials = !!opts.withCredentials

			if (self._mode === 'text' && 'overrideMimeType' in xhr)
				xhr.overrideMimeType('text/plain; charset=x-user-defined')

			if ('timeout' in opts) {
				xhr.timeout = opts.timeout
				xhr.ontimeout = function () {
					self.emit('timeout')
				}
			}

			Object.keys(headersObj).forEach(function (name) {
				xhr.setRequestHeader(headersObj[name].name, headersObj[name].value)
			})

			self._response = null
			xhr.onreadystatechange = function () {
				switch (xhr.readyState) {
					case rStates.LOADING:
					case rStates.DONE:
						self._onXHRProgress()
						break
				}
			}
			// Necessary for streaming in Firefox, since xhr.response is ONLY defined
			// in onprogress, not in onreadystatechange with xhr.readyState = 3
			if (self._mode === 'moz-chunked-arraybuffer') {
				xhr.onprogress = function () {
					self._onXHRProgress()
				}
			}

			xhr.onerror = function () {
				if (self._destroyed)
					return
				self.emit('error', new Error('XHR error'))
			}

			try {
				xhr.send(body)
			} catch (err) {
				process.nextTick(function () {
					self.emit('error', err)
				})
				return
			}
		}
	}

	/**
	 * Checks if xhr.status is readable and non-zero, indicating no error.
	 * Even though the spec says it should be available in readyState 3,
	 * accessing it throws an exception in IE8
	 */
	function statusValid (xhr) {
		try {
			var status = xhr.status
			return (status !== null && status !== 0)
		} catch (e) {
			return false
		}
	}

	ClientRequest.prototype._onXHRProgress = function () {
		var self = this

		if (!statusValid(self._xhr) || self._destroyed)
			return

		if (!self._response)
			self._connect()

		self._response._onXHRProgress()
	}

	ClientRequest.prototype._connect = function () {
		var self = this

		if (self._destroyed)
			return

		self._response = new IncomingMessage(self._xhr, self._fetchResponse, self._mode)
		self._response.on('error', function(err) {
			self.emit('error', err)
		})

		self.emit('response', self._response)
	}

	ClientRequest.prototype._write = function (chunk, encoding, cb) {
		var self = this

		self._body.push(chunk)
		cb()
	}

	ClientRequest.prototype.abort = ClientRequest.prototype.destroy = function () {
		var self = this
		self._destroyed = true
		if (self._response)
			self._response._destroyed = true
		if (self._xhr)
			self._xhr.abort()
		// Currently, there isn't a way to truly abort a fetch.
		// If you like bikeshedding, see https://github.com/whatwg/fetch/issues/27
	}

	ClientRequest.prototype.end = function (data, encoding, cb) {
		var self = this
		if (typeof data === 'function') {
			cb = data
			data = undefined
		}

		stream.Writable.prototype.end.call(self, data, encoding, cb)
	}

	ClientRequest.prototype.flushHeaders = function () {}
	ClientRequest.prototype.setTimeout = function () {}
	ClientRequest.prototype.setNoDelay = function () {}
	ClientRequest.prototype.setSocketKeepAlive = function () {}

	// Taken from http://www.w3.org/TR/XMLHttpRequest/#the-setrequestheader%28%29-method
	var unsafeHeaders = [
		'accept-charset',
		'accept-encoding',
		'access-control-request-headers',
		'access-control-request-method',
		'connection',
		'content-length',
		'cookie',
		'cookie2',
		'date',
		'dnt',
		'expect',
		'host',
		'keep-alive',
		'origin',
		'referer',
		'te',
		'trailer',
		'transfer-encoding',
		'upgrade',
		'user-agent',
		'via'
	]

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }()), __webpack_require__(3)))

/***/ },
/* 56 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process, global) {var capability = __webpack_require__(23)
	var inherits = __webpack_require__(2)
	var stream = __webpack_require__(15)

	var rStates = exports.readyStates = {
		UNSENT: 0,
		OPENED: 1,
		HEADERS_RECEIVED: 2,
		LOADING: 3,
		DONE: 4
	}

	var IncomingMessage = exports.IncomingMessage = function (xhr, response, mode) {
		var self = this
		stream.Readable.call(self)

		self._mode = mode
		self.headers = {}
		self.rawHeaders = []
		self.trailers = {}
		self.rawTrailers = []

		// Fake the 'close' event, but only once 'end' fires
		self.on('end', function () {
			// The nextTick is necessary to prevent the 'request' module from causing an infinite loop
			process.nextTick(function () {
				self.emit('close')
			})
		})

		if (mode === 'fetch') {
			self._fetchResponse = response

			self.url = response.url
			self.statusCode = response.status
			self.statusMessage = response.statusText
			
			response.headers.forEach(function(header, key){
				self.headers[key.toLowerCase()] = header
				self.rawHeaders.push(key, header)
			})


			// TODO: this doesn't respect backpressure. Once WritableStream is available, this can be fixed
			var reader = response.body.getReader()
			function read () {
				reader.read().then(function (result) {
					if (self._destroyed)
						return
					if (result.done) {
						self.push(null)
						return
					}
					self.push(new Buffer(result.value))
					read()
				}).catch(function(err) {
					self.emit('error', err)
				})
			}
			read()

		} else {
			self._xhr = xhr
			self._pos = 0

			self.url = xhr.responseURL
			self.statusCode = xhr.status
			self.statusMessage = xhr.statusText
			var headers = xhr.getAllResponseHeaders().split(/\r?\n/)
			headers.forEach(function (header) {
				var matches = header.match(/^([^:]+):\s*(.*)/)
				if (matches) {
					var key = matches[1].toLowerCase()
					if (key === 'set-cookie') {
						if (self.headers[key] === undefined) {
							self.headers[key] = []
						}
						self.headers[key].push(matches[2])
					} else if (self.headers[key] !== undefined) {
						self.headers[key] += ', ' + matches[2]
					} else {
						self.headers[key] = matches[2]
					}
					self.rawHeaders.push(matches[1], matches[2])
				}
			})

			self._charset = 'x-user-defined'
			if (!capability.overrideMimeType) {
				var mimeType = self.rawHeaders['mime-type']
				if (mimeType) {
					var charsetMatch = mimeType.match(/;\s*charset=([^;])(;|$)/)
					if (charsetMatch) {
						self._charset = charsetMatch[1].toLowerCase()
					}
				}
				if (!self._charset)
					self._charset = 'utf-8' // best guess
			}
		}
	}

	inherits(IncomingMessage, stream.Readable)

	IncomingMessage.prototype._read = function () {}

	IncomingMessage.prototype._onXHRProgress = function () {
		var self = this

		var xhr = self._xhr

		var response = null
		switch (self._mode) {
			case 'text:vbarray': // For IE9
				if (xhr.readyState !== rStates.DONE)
					break
				try {
					// This fails in IE8
					response = new global.VBArray(xhr.responseBody).toArray()
				} catch (e) {}
				if (response !== null) {
					self.push(new Buffer(response))
					break
				}
				// Falls through in IE8	
			case 'text':
				try { // This will fail when readyState = 3 in IE9. Switch mode and wait for readyState = 4
					response = xhr.responseText
				} catch (e) {
					self._mode = 'text:vbarray'
					break
				}
				if (response.length > self._pos) {
					var newData = response.substr(self._pos)
					if (self._charset === 'x-user-defined') {
						var buffer = new Buffer(newData.length)
						for (var i = 0; i < newData.length; i++)
							buffer[i] = newData.charCodeAt(i) & 0xff

						self.push(buffer)
					} else {
						self.push(newData, self._charset)
					}
					self._pos = response.length
				}
				break
			case 'arraybuffer':
				if (xhr.readyState !== rStates.DONE || !xhr.response)
					break
				response = xhr.response
				self.push(new Buffer(new Uint8Array(response)))
				break
			case 'moz-chunked-arraybuffer': // take whole
				response = xhr.response
				if (xhr.readyState !== rStates.LOADING || !response)
					break
				self.push(new Buffer(new Uint8Array(response)))
				break
			case 'ms-stream':
				response = xhr.response
				if (xhr.readyState !== rStates.LOADING)
					break
				var reader = new global.MSStreamReader()
				reader.onprogress = function () {
					if (reader.result.byteLength > self._pos) {
						self.push(new Buffer(new Uint8Array(reader.result.slice(self._pos))))
						self._pos = reader.result.byteLength
					}
				}
				reader.onload = function () {
					self.push(null)
				}
				// reader.onerror = ??? // TODO: this
				reader.readAsArrayBuffer(response)
				break
		}

		// The ms-stream case handles end separately in reader.onload()
		if (self._xhr.readyState === rStates.DONE && self._mode !== 'ms-stream') {
			self.push(null)
		}
	}

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(3), (function() { return this; }())))

/***/ },
/* 57 */
/***/ function(module, exports, __webpack_require__) {

	var apply = Function.prototype.apply;

	// DOM APIs, for completeness

	exports.setTimeout = function() {
	  return new Timeout(apply.call(setTimeout, window, arguments), clearTimeout);
	};
	exports.setInterval = function() {
	  return new Timeout(apply.call(setInterval, window, arguments), clearInterval);
	};
	exports.clearTimeout =
	exports.clearInterval = function(timeout) {
	  if (timeout) {
	    timeout.close();
	  }
	};

	function Timeout(id, clearFn) {
	  this._id = id;
	  this._clearFn = clearFn;
	}
	Timeout.prototype.unref = Timeout.prototype.ref = function() {};
	Timeout.prototype.close = function() {
	  this._clearFn.call(window, this._id);
	};

	// Does not start the time, just sets up the members needed.
	exports.enroll = function(item, msecs) {
	  clearTimeout(item._idleTimeoutId);
	  item._idleTimeout = msecs;
	};

	exports.unenroll = function(item) {
	  clearTimeout(item._idleTimeoutId);
	  item._idleTimeout = -1;
	};

	exports._unrefActive = exports.active = function(item) {
	  clearTimeout(item._idleTimeoutId);

	  var msecs = item._idleTimeout;
	  if (msecs >= 0) {
	    item._idleTimeoutId = setTimeout(function onTimeout() {
	      if (item._onTimeout)
	        item._onTimeout();
	    }, msecs);
	  }
	};

	// setimmediate attaches itself to the global object
	__webpack_require__(54);
	exports.setImmediate = setImmediate;
	exports.clearImmediate = clearImmediate;


/***/ },
/* 58 */
/***/ function(module, exports, __webpack_require__) {

	var Buffer = __webpack_require__(6).Buffer

	module.exports = function (buf) {
		// If the buffer is backed by a Uint8Array, a faster version will work
		if (buf instanceof Uint8Array) {
			// If the buffer isn't a subarray, return the underlying ArrayBuffer
			if (buf.byteOffset === 0 && buf.byteLength === buf.buffer.byteLength) {
				return buf.buffer
			} else if (typeof buf.buffer.slice === 'function') {
				// Otherwise we need to get a proper copy
				return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength)
			}
		}

		if (Buffer.isBuffer(buf)) {
			// This is the slow version that will work with any Buffer
			// implementation (even in old browsers)
			var arrayCopy = new Uint8Array(buf.length)
			var len = buf.length
			for (var i = 0; i < len; i++) {
				arrayCopy[i] = buf[i]
			}
			return arrayCopy.buffer
		} else {
			throw new Error('Argument must be a Buffer')
		}
	}


/***/ },
/* 59 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;/* WEBPACK VAR INJECTION */(function(module, global) {/*! https://mths.be/punycode v1.3.2 by @mathias */
	;(function(root) {

		/** Detect free variables */
		var freeExports = typeof exports == 'object' && exports &&
			!exports.nodeType && exports;
		var freeModule = typeof module == 'object' && module &&
			!module.nodeType && module;
		var freeGlobal = typeof global == 'object' && global;
		if (
			freeGlobal.global === freeGlobal ||
			freeGlobal.window === freeGlobal ||
			freeGlobal.self === freeGlobal
		) {
			root = freeGlobal;
		}

		/**
		 * The `punycode` object.
		 * @name punycode
		 * @type Object
		 */
		var punycode,

		/** Highest positive signed 32-bit float value */
		maxInt = 2147483647, // aka. 0x7FFFFFFF or 2^31-1

		/** Bootstring parameters */
		base = 36,
		tMin = 1,
		tMax = 26,
		skew = 38,
		damp = 700,
		initialBias = 72,
		initialN = 128, // 0x80
		delimiter = '-', // '\x2D'

		/** Regular expressions */
		regexPunycode = /^xn--/,
		regexNonASCII = /[^\x20-\x7E]/, // unprintable ASCII chars + non-ASCII chars
		regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g, // RFC 3490 separators

		/** Error messages */
		errors = {
			'overflow': 'Overflow: input needs wider integers to process',
			'not-basic': 'Illegal input >= 0x80 (not a basic code point)',
			'invalid-input': 'Invalid input'
		},

		/** Convenience shortcuts */
		baseMinusTMin = base - tMin,
		floor = Math.floor,
		stringFromCharCode = String.fromCharCode,

		/** Temporary variable */
		key;

		/*--------------------------------------------------------------------------*/

		/**
		 * A generic error utility function.
		 * @private
		 * @param {String} type The error type.
		 * @returns {Error} Throws a `RangeError` with the applicable error message.
		 */
		function error(type) {
			throw RangeError(errors[type]);
		}

		/**
		 * A generic `Array#map` utility function.
		 * @private
		 * @param {Array} array The array to iterate over.
		 * @param {Function} callback The function that gets called for every array
		 * item.
		 * @returns {Array} A new array of values returned by the callback function.
		 */
		function map(array, fn) {
			var length = array.length;
			var result = [];
			while (length--) {
				result[length] = fn(array[length]);
			}
			return result;
		}

		/**
		 * A simple `Array#map`-like wrapper to work with domain name strings or email
		 * addresses.
		 * @private
		 * @param {String} domain The domain name or email address.
		 * @param {Function} callback The function that gets called for every
		 * character.
		 * @returns {Array} A new string of characters returned by the callback
		 * function.
		 */
		function mapDomain(string, fn) {
			var parts = string.split('@');
			var result = '';
			if (parts.length > 1) {
				// In email addresses, only the domain name should be punycoded. Leave
				// the local part (i.e. everything up to `@`) intact.
				result = parts[0] + '@';
				string = parts[1];
			}
			// Avoid `split(regex)` for IE8 compatibility. See #17.
			string = string.replace(regexSeparators, '\x2E');
			var labels = string.split('.');
			var encoded = map(labels, fn).join('.');
			return result + encoded;
		}

		/**
		 * Creates an array containing the numeric code points of each Unicode
		 * character in the string. While JavaScript uses UCS-2 internally,
		 * this function will convert a pair of surrogate halves (each of which
		 * UCS-2 exposes as separate characters) into a single code point,
		 * matching UTF-16.
		 * @see `punycode.ucs2.encode`
		 * @see <https://mathiasbynens.be/notes/javascript-encoding>
		 * @memberOf punycode.ucs2
		 * @name decode
		 * @param {String} string The Unicode input string (UCS-2).
		 * @returns {Array} The new array of code points.
		 */
		function ucs2decode(string) {
			var output = [],
			    counter = 0,
			    length = string.length,
			    value,
			    extra;
			while (counter < length) {
				value = string.charCodeAt(counter++);
				if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
					// high surrogate, and there is a next character
					extra = string.charCodeAt(counter++);
					if ((extra & 0xFC00) == 0xDC00) { // low surrogate
						output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
					} else {
						// unmatched surrogate; only append this code unit, in case the next
						// code unit is the high surrogate of a surrogate pair
						output.push(value);
						counter--;
					}
				} else {
					output.push(value);
				}
			}
			return output;
		}

		/**
		 * Creates a string based on an array of numeric code points.
		 * @see `punycode.ucs2.decode`
		 * @memberOf punycode.ucs2
		 * @name encode
		 * @param {Array} codePoints The array of numeric code points.
		 * @returns {String} The new Unicode string (UCS-2).
		 */
		function ucs2encode(array) {
			return map(array, function(value) {
				var output = '';
				if (value > 0xFFFF) {
					value -= 0x10000;
					output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
					value = 0xDC00 | value & 0x3FF;
				}
				output += stringFromCharCode(value);
				return output;
			}).join('');
		}

		/**
		 * Converts a basic code point into a digit/integer.
		 * @see `digitToBasic()`
		 * @private
		 * @param {Number} codePoint The basic numeric code point value.
		 * @returns {Number} The numeric value of a basic code point (for use in
		 * representing integers) in the range `0` to `base - 1`, or `base` if
		 * the code point does not represent a value.
		 */
		function basicToDigit(codePoint) {
			if (codePoint - 48 < 10) {
				return codePoint - 22;
			}
			if (codePoint - 65 < 26) {
				return codePoint - 65;
			}
			if (codePoint - 97 < 26) {
				return codePoint - 97;
			}
			return base;
		}

		/**
		 * Converts a digit/integer into a basic code point.
		 * @see `basicToDigit()`
		 * @private
		 * @param {Number} digit The numeric value of a basic code point.
		 * @returns {Number} The basic code point whose value (when used for
		 * representing integers) is `digit`, which needs to be in the range
		 * `0` to `base - 1`. If `flag` is non-zero, the uppercase form is
		 * used; else, the lowercase form is used. The behavior is undefined
		 * if `flag` is non-zero and `digit` has no uppercase form.
		 */
		function digitToBasic(digit, flag) {
			//  0..25 map to ASCII a..z or A..Z
			// 26..35 map to ASCII 0..9
			return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
		}

		/**
		 * Bias adaptation function as per section 3.4 of RFC 3492.
		 * http://tools.ietf.org/html/rfc3492#section-3.4
		 * @private
		 */
		function adapt(delta, numPoints, firstTime) {
			var k = 0;
			delta = firstTime ? floor(delta / damp) : delta >> 1;
			delta += floor(delta / numPoints);
			for (/* no initialization */; delta > baseMinusTMin * tMax >> 1; k += base) {
				delta = floor(delta / baseMinusTMin);
			}
			return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
		}

		/**
		 * Converts a Punycode string of ASCII-only symbols to a string of Unicode
		 * symbols.
		 * @memberOf punycode
		 * @param {String} input The Punycode string of ASCII-only symbols.
		 * @returns {String} The resulting string of Unicode symbols.
		 */
		function decode(input) {
			// Don't use UCS-2
			var output = [],
			    inputLength = input.length,
			    out,
			    i = 0,
			    n = initialN,
			    bias = initialBias,
			    basic,
			    j,
			    index,
			    oldi,
			    w,
			    k,
			    digit,
			    t,
			    /** Cached calculation results */
			    baseMinusT;

			// Handle the basic code points: let `basic` be the number of input code
			// points before the last delimiter, or `0` if there is none, then copy
			// the first basic code points to the output.

			basic = input.lastIndexOf(delimiter);
			if (basic < 0) {
				basic = 0;
			}

			for (j = 0; j < basic; ++j) {
				// if it's not a basic code point
				if (input.charCodeAt(j) >= 0x80) {
					error('not-basic');
				}
				output.push(input.charCodeAt(j));
			}

			// Main decoding loop: start just after the last delimiter if any basic code
			// points were copied; start at the beginning otherwise.

			for (index = basic > 0 ? basic + 1 : 0; index < inputLength; /* no final expression */) {

				// `index` is the index of the next character to be consumed.
				// Decode a generalized variable-length integer into `delta`,
				// which gets added to `i`. The overflow checking is easier
				// if we increase `i` as we go, then subtract off its starting
				// value at the end to obtain `delta`.
				for (oldi = i, w = 1, k = base; /* no condition */; k += base) {

					if (index >= inputLength) {
						error('invalid-input');
					}

					digit = basicToDigit(input.charCodeAt(index++));

					if (digit >= base || digit > floor((maxInt - i) / w)) {
						error('overflow');
					}

					i += digit * w;
					t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);

					if (digit < t) {
						break;
					}

					baseMinusT = base - t;
					if (w > floor(maxInt / baseMinusT)) {
						error('overflow');
					}

					w *= baseMinusT;

				}

				out = output.length + 1;
				bias = adapt(i - oldi, out, oldi == 0);

				// `i` was supposed to wrap around from `out` to `0`,
				// incrementing `n` each time, so we'll fix that now:
				if (floor(i / out) > maxInt - n) {
					error('overflow');
				}

				n += floor(i / out);
				i %= out;

				// Insert `n` at position `i` of the output
				output.splice(i++, 0, n);

			}

			return ucs2encode(output);
		}

		/**
		 * Converts a string of Unicode symbols (e.g. a domain name label) to a
		 * Punycode string of ASCII-only symbols.
		 * @memberOf punycode
		 * @param {String} input The string of Unicode symbols.
		 * @returns {String} The resulting Punycode string of ASCII-only symbols.
		 */
		function encode(input) {
			var n,
			    delta,
			    handledCPCount,
			    basicLength,
			    bias,
			    j,
			    m,
			    q,
			    k,
			    t,
			    currentValue,
			    output = [],
			    /** `inputLength` will hold the number of code points in `input`. */
			    inputLength,
			    /** Cached calculation results */
			    handledCPCountPlusOne,
			    baseMinusT,
			    qMinusT;

			// Convert the input in UCS-2 to Unicode
			input = ucs2decode(input);

			// Cache the length
			inputLength = input.length;

			// Initialize the state
			n = initialN;
			delta = 0;
			bias = initialBias;

			// Handle the basic code points
			for (j = 0; j < inputLength; ++j) {
				currentValue = input[j];
				if (currentValue < 0x80) {
					output.push(stringFromCharCode(currentValue));
				}
			}

			handledCPCount = basicLength = output.length;

			// `handledCPCount` is the number of code points that have been handled;
			// `basicLength` is the number of basic code points.

			// Finish the basic string - if it is not empty - with a delimiter
			if (basicLength) {
				output.push(delimiter);
			}

			// Main encoding loop:
			while (handledCPCount < inputLength) {

				// All non-basic code points < n have been handled already. Find the next
				// larger one:
				for (m = maxInt, j = 0; j < inputLength; ++j) {
					currentValue = input[j];
					if (currentValue >= n && currentValue < m) {
						m = currentValue;
					}
				}

				// Increase `delta` enough to advance the decoder's <n,i> state to <m,0>,
				// but guard against overflow
				handledCPCountPlusOne = handledCPCount + 1;
				if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
					error('overflow');
				}

				delta += (m - n) * handledCPCountPlusOne;
				n = m;

				for (j = 0; j < inputLength; ++j) {
					currentValue = input[j];

					if (currentValue < n && ++delta > maxInt) {
						error('overflow');
					}

					if (currentValue == n) {
						// Represent delta as a generalized variable-length integer
						for (q = delta, k = base; /* no condition */; k += base) {
							t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);
							if (q < t) {
								break;
							}
							qMinusT = q - t;
							baseMinusT = base - t;
							output.push(
								stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0))
							);
							q = floor(qMinusT / baseMinusT);
						}

						output.push(stringFromCharCode(digitToBasic(q, 0)));
						bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
						delta = 0;
						++handledCPCount;
					}
				}

				++delta;
				++n;

			}
			return output.join('');
		}

		/**
		 * Converts a Punycode string representing a domain name or an email address
		 * to Unicode. Only the Punycoded parts of the input will be converted, i.e.
		 * it doesn't matter if you call it on a string that has already been
		 * converted to Unicode.
		 * @memberOf punycode
		 * @param {String} input The Punycoded domain name or email address to
		 * convert to Unicode.
		 * @returns {String} The Unicode representation of the given Punycode
		 * string.
		 */
		function toUnicode(input) {
			return mapDomain(input, function(string) {
				return regexPunycode.test(string)
					? decode(string.slice(4).toLowerCase())
					: string;
			});
		}

		/**
		 * Converts a Unicode string representing a domain name or an email address to
		 * Punycode. Only the non-ASCII parts of the domain name will be converted,
		 * i.e. it doesn't matter if you call it with a domain that's already in
		 * ASCII.
		 * @memberOf punycode
		 * @param {String} input The domain name or email address to convert, as a
		 * Unicode string.
		 * @returns {String} The Punycode representation of the given domain name or
		 * email address.
		 */
		function toASCII(input) {
			return mapDomain(input, function(string) {
				return regexNonASCII.test(string)
					? 'xn--' + encode(string)
					: string;
			});
		}

		/*--------------------------------------------------------------------------*/

		/** Define the public API */
		punycode = {
			/**
			 * A string representing the current Punycode.js version number.
			 * @memberOf punycode
			 * @type String
			 */
			'version': '1.3.2',
			/**
			 * An object of methods to convert from JavaScript's internal character
			 * representation (UCS-2) to Unicode code points, and back.
			 * @see <https://mathiasbynens.be/notes/javascript-encoding>
			 * @memberOf punycode
			 * @type Object
			 */
			'ucs2': {
				'decode': ucs2decode,
				'encode': ucs2encode
			},
			'decode': decode,
			'encode': encode,
			'toASCII': toASCII,
			'toUnicode': toUnicode
		};

		/** Expose `punycode` */
		// Some AMD build optimizers, like r.js, check for specific condition patterns
		// like the following:
		if (
			true
		) {
			!(__WEBPACK_AMD_DEFINE_RESULT__ = function() {
				return punycode;
			}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
		} else if (freeExports && freeModule) {
			if (module.exports == freeExports) { // in Node.js or RingoJS v0.8.0+
				freeModule.exports = punycode;
			} else { // in Narwhal or RingoJS v0.7.0-
				for (key in punycode) {
					punycode.hasOwnProperty(key) && (freeExports[key] = punycode[key]);
				}
			}
		} else { // in Rhino or a web browser
			root.punycode = punycode;
		}

	}(this));

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(62)(module), (function() { return this; }())))

/***/ },
/* 60 */
/***/ function(module, exports) {

	'use strict';

	module.exports = {
	  isString: function(arg) {
	    return typeof(arg) === 'string';
	  },
	  isObject: function(arg) {
	    return typeof(arg) === 'object' && arg !== null;
	  },
	  isNull: function(arg) {
	    return arg === null;
	  },
	  isNullOrUndefined: function(arg) {
	    return arg == null;
	  }
	};


/***/ },
/* 61 */
/***/ function(module, exports) {

	/* WEBPACK VAR INJECTION */(function(global) {
	/**
	 * Module exports.
	 */

	module.exports = deprecate;

	/**
	 * Mark that a method should not be used.
	 * Returns a modified function which warns once by default.
	 *
	 * If `localStorage.noDeprecation = true` is set, then it is a no-op.
	 *
	 * If `localStorage.throwDeprecation = true` is set, then deprecated functions
	 * will throw an Error when invoked.
	 *
	 * If `localStorage.traceDeprecation = true` is set, then deprecated functions
	 * will invoke `console.trace()` instead of `console.error()`.
	 *
	 * @param {Function} fn - the function to deprecate
	 * @param {String} msg - the string to print to the console when `fn` is invoked
	 * @returns {Function} a new "deprecated" version of `fn`
	 * @api public
	 */

	function deprecate (fn, msg) {
	  if (config('noDeprecation')) {
	    return fn;
	  }

	  var warned = false;
	  function deprecated() {
	    if (!warned) {
	      if (config('throwDeprecation')) {
	        throw new Error(msg);
	      } else if (config('traceDeprecation')) {
	        console.trace(msg);
	      } else {
	        console.warn(msg);
	      }
	      warned = true;
	    }
	    return fn.apply(this, arguments);
	  }

	  return deprecated;
	}

	/**
	 * Checks `localStorage` for boolean values for the given `name`.
	 *
	 * @param {String} name
	 * @returns {Boolean}
	 * @api private
	 */

	function config (name) {
	  // accessing global.localStorage can trigger a DOMException in sandboxed iframes
	  try {
	    if (!global.localStorage) return false;
	  } catch (_) {
	    return false;
	  }
	  var val = global.localStorage[name];
	  if (null == val) return false;
	  return String(val).toLowerCase() === 'true';
	}

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 62 */
/***/ function(module, exports) {

	module.exports = function(module) {
		if(!module.webpackPolyfill) {
			module.deprecate = function() {};
			module.paths = [];
			// module.parent = undefined by default
			module.children = [];
			module.webpackPolyfill = 1;
		}
		return module;
	}


/***/ },
/* 63 */
/***/ function(module, exports) {

	module.exports = extend

	var hasOwnProperty = Object.prototype.hasOwnProperty;

	function extend() {
	    var target = {}

	    for (var i = 0; i < arguments.length; i++) {
	        var source = arguments[i]

	        for (var key in source) {
	            if (hasOwnProperty.call(source, key)) {
	                target[key] = source[key]
	            }
	        }
	    }

	    return target
	}


/***/ },
/* 64 */
/***/ function(module, exports) {

	/* (ignored) */

/***/ }
/******/ ])
});
;